/*********************************************************************************

*********************************************************************************/

#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <malloc.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "MEKSextraa.h"

//#include "Fl_Preferences.H"

// #define  MAX_MONSTERS 10

/********************************************************************************/
char mybuf[900], *myptr, mybuf2[900];

int  actionResults[3][8];
int  interpResults[9];		// OB, NP, MP, HP, AP, Bl, St, Dead, In

int  i, j, k, l, m, editStdMonsterNo;
float f;

char spellchge[5] = {-30, -15, 0, 10, 20},  /* spell charging values */
     mamdif[9] = {30,20,10,0,-10,-20,-30,-50,-70},
     mmadj[9] = {-50,-35,-20,-10,0,5,10,15,20},
     actionString[4][9] = {{"attacks"}, {"casts"}, {"missile"}, {"moves"}};

int  mmxp[9] = {0,5,10,50,100,150,200,300,500},
	  tempPenalties[8][4];        /* temp penalties from attack */

char *tablemem[61];    /* memory malloc'ed for each table file */
char  tabletype[61][4];    /* all the 2 digit table codes loaded */
char ArmorType[5][3] = {"No", "SL", "RL", "Ch", "Pl"};

time_t t;
struct tm *tp;

/********************************************************************************/
void reloadAllNames();
void doFileAction(char *, char *, int, int);
int getOB(int, int);
void saveSystemConfig();
void loadSystemConfig();
int getModifiers(int, int);
int getTempPenalties(int, int);
void setActionTile(int);
char * getSystemData(char *, char);
void doSystemAlert(char *);
char doAreYouSure(char *);
void loadExtrasFile(char *);
void setTimeOnTitle();
int meks_init_calc();
void doSaveAsIniFile();
void doReadAsIniFile();
void setTempPenalty(int, int, int, int);

/********************************************************************************/
extern int getRND(int);
extern int getDiceRoll();
extern void init16();
extern void setSpellAction();
extern void setActionMessage(char *);
extern char *getWeaponStats(char *);
extern void showCopyright();
extern void acceptTriggers();
extern void acceptModifiers();
extern void editStdMonster(int);

/********************************************************************************/
void loadEditPlayer(int plyr) {

	meksEditSpecialActions->deactivate();

	if (plyr == -1) {			// clear enough details ......
//		plyr = MEKSconfig.cur_plyr;
		MEKSconfig.cur_plyr = -1;
		meksEditPlayerSelector->activate();
		meksEditMonsterSelector->activate();
		meksEditName->value("");
		meksEditLevel->value("");
		meksEditHitsMax->value("");
		meksEditHitsCur->value("");
		meksEditNoAttks->value("");
		for (i=0; i<5; i++) {
			meksEditWName[i]->value("");
			meksEditWOB[i]->value("");
		}
		meksEditAccept->deactivate();
		meksEditCancel->deactivate();
		return;
	}
	else {
		MEKSconfig.cur_plyr = plyr;
		meksEditPlayerSelector->deactivate();
		meksEditMonsterSelector->deactivate();
	}
	meksEditTab->value(meksEditCharacter);

if (debug == 1) printf("Loading Player %d (%d/%d)\n", plyr,i,j);
	sprintf(mybuf, "%s", party[plyr].Name); meksEditName->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].Level); meksEditLevel->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].HitsMax); meksEditHitsMax->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].HitsCur); meksEditHitsCur->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].NoAttks); meksEditNoAttks->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].Bleed); meksEditBleed->value(mybuf);
	sprintf(mybuf, "%s", party[plyr].Wounds); meksEditWounds->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].Stun); meksEditStun->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].ActPenalty); meksEditActPenalty->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].Parry); meksEditParry->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].NoParry); meksEditNoParry->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].Inactive); meksEditInactive->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].Death); meksEditDeath->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].DBBase); meksEditDBBase->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].SpellBase); meksEditSpellBase->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].DBShield); meksEditDBShield->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].SpellDirAttacks); meksEditSpellDirAttacks->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].MMBase); meksEditMMBase->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].AGQU); meksEditAGQU->value(mybuf);
	meksEditArmor->value(party[plyr].Armor);
	sprintf(mybuf, "%d", party[plyr].CON); meksEditCON->value(mybuf);
	meksEditSize->value(party[plyr].Size);
	meksEditDBLeg->value(party[plyr].DBLeg);
	meksEditDBArm->value(party[plyr].DBArm);
	meksEditDBHelm->value(party[plyr].DBHelm);
	meksEditIgnoreAtk->value(party[plyr].IgnoreAtk);
	meksEditCritAdj->value(party[plyr].CritAdj);
	meksEditRealm->value(party[plyr].Realm);
	sprintf(mybuf, "%d", party[plyr].RRPoison); meksEditRRPoison->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].RRChannel); meksEditRRChannel->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].RRMentalism); meksEditRRMentalism->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].RREssence); meksEditRREssence->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].RRDisease); meksEditRRDisease->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].SpellCharge); meksEditSpellCharge->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].MissileLoad); meksEditMissileLoad->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].ParryVal); meksEditParryValue->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].perc); meksEditSkillPerc->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].stalk); meksEditSkillStalk->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].r_rune); meksEditSkillRR->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].u_item); meksEditSkillUI->value(mybuf);

	for (i=0; i<5; i++) {
		meksEditWName[i]->value(party[plyr].weap[i].wp_dsc);
		sprintf(mybuf, "%d", party[plyr].weap[i].wp_ob);
		meksEditWOB[i]->value(mybuf);
		meksEditWTable[i]->value(party[plyr].weap[i].wp_tbl);
		meksEditWSize[i]->value(party[plyr].weap[i].wp_sz);
		sprintf(mybuf, "%d", party[plyr].weap[i].wp_fm);
		meksEditWFumble[i]->value(mybuf);
		meksEditWPrimaryCrit[i]->value(party[plyr].weap[i].wp_pc);
		meksEditWSecondaryCrit[i]->value(party[plyr].weap[i].wp_sc);
		meksEditWSpecMods[i]->value(party[plyr].weap[i].wp_sm);
	}
	if (party[plyr].NoAttks > 1) {
		meksEditWSelect[0]->value(0);
		meksEditWSelect[1]->value(0);
		meksEditWSelect[2]->value(0);
		meksEditWSelect[0]->deactivate();
		meksEditWSelect[1]->deactivate();
		meksEditWSelect[2]->deactivate();
	} else {
		meksEditWSelect[0]->activate();
		meksEditWSelect[1]->activate();
		meksEditWSelect[2]->activate();
		for (i=0; i<3; i++) {
			meksEditWSelect[i]->value(party[plyr].weap[i].wp_sel);
		}
	}
	for (i=0; i<8; i++) {
		for (j=0; j<3; j++) {
			sprintf(mybuf, "%d", party[plyr].TempPenalties[i][j]);
			meksEditTempPen[i][j]->value(mybuf);
		}
	}
	meksEditAccept->activate();
	meksEditCancel->activate();

	if (plyr > 9) {
		meksEditSpecialActions->activate();
		meksEditSpecialActions->value(0);
	}
}

/********************************************************************************/
void saveEditPlayer(int plyr) {
//int plyr=0;

	if (plyr == -1) {
		plyr = MEKSconfig.cur_plyr;
		MEKSconfig.cur_plyr = -1;
	}

if (debug == 1) printf("Saving Player %d\n", plyr);
	strcpy(party[plyr].Name, meksEditName->value());
	party[plyr].Level = atoi(meksEditLevel->value());
	party[plyr].HitsMax = atoi(meksEditHitsMax->value());
	party[plyr].HitsCur = atoi(meksEditHitsCur->value());
	party[plyr].NoAttks = atoi(meksEditNoAttks->value());
	party[plyr].Bleed = atoi(meksEditBleed->value());
	strcpy(party[plyr].Wounds, meksEditWounds->value());
	party[plyr].Stun = atoi(meksEditStun->value());
	party[plyr].ActPenalty = atoi(meksEditActPenalty->value());
	party[plyr].Parry = atoi(meksEditParry->value());
	party[plyr].NoParry = atoi(meksEditNoParry->value());
	party[plyr].Inactive = atoi(meksEditInactive->value());
	party[plyr].Death = atoi(meksEditDeath->value());
	party[plyr].DBBase = atoi(meksEditDBBase->value());
	party[plyr].SpellBase = atoi(meksEditSpellBase->value());
	party[plyr].DBShield = atoi(meksEditDBShield->value());
	party[plyr].SpellDirAttacks = atoi(meksEditSpellDirAttacks->value());
	party[plyr].MMBase = atoi(meksEditMMBase->value());
	party[plyr].AGQU = atoi(meksEditAGQU->value());
	party[plyr].Armor = meksEditArmor->value();
	party[plyr].CON = atoi(meksEditCON->value());
	party[plyr].Size = meksEditSize->value();
	party[plyr].DBLeg = meksEditDBLeg->value();
	party[plyr].DBArm = meksEditDBArm->value();
	party[plyr].DBHelm = meksEditDBHelm->value();
	party[plyr].IgnoreAtk = meksEditIgnoreAtk->value();
	party[plyr].CritAdj = meksEditCritAdj->value();
	party[plyr].RRPoison = atoi(meksEditRRPoison->value());
	party[plyr].RRChannel = atoi(meksEditRRChannel->value());
	party[plyr].RRMentalism = atoi(meksEditRRMentalism->value());
	party[plyr].RREssence = atoi(meksEditRREssence->value());
	party[plyr].RRDisease = atoi(meksEditRRDisease->value());
	party[plyr].SpellCharge = atoi(meksEditSpellCharge->value());
	party[plyr].MissileLoad = atoi(meksEditMissileLoad->value());
	party[plyr].ParryVal = atoi(meksEditParryValue->value());
	party[plyr].Realm = meksEditRealm->value();
	party[plyr].perc = atoi(meksEditSkillPerc->value());
	party[plyr].stalk = atoi(meksEditSkillStalk->value());
	party[plyr].r_rune = atoi(meksEditSkillRR->value());
	party[plyr].u_item = atoi(meksEditSkillUI->value());

	for (i=0; i<5; i++) {
		strcpy(party[plyr].weap[i].wp_dsc, meksEditWName[i]->value());
		party[plyr].weap[i].wp_ob = atoi(meksEditWOB[i]->value());
		strcpy(party[plyr].weap[i].wp_tbl, meksEditWTable[i]->value());
		strcpy(party[plyr].weap[i].wp_sz, meksEditWSize[i]->value());
		party[plyr].weap[i].wp_fm = atoi(meksEditWFumble[i]->value());
		strcpy(party[plyr].weap[i].wp_pc, meksEditWPrimaryCrit[i]->value());
		strcpy(party[plyr].weap[i].wp_sc, meksEditWSecondaryCrit[i]->value());
		strcpy(party[plyr].weap[i].wp_sm, meksEditWSpecMods[i]->value());

		meksEditWName[i]->value("");
		meksEditWOB[i]->value("");
	}
	for (i=0; i<3; i++) {
		party[plyr].weap[i].wp_sel = meksEditWSelect[i]->value();
	}

	for (i=0; i<8; i++) {
		for (j=0; j<3; j++) {
			party[plyr].TempPenalties[i][j] = atoi(meksEditTempPen[i][j]->value());
		}
	}
	meksEditName->value("");
	meksEditLevel->value("");
	meksEditHitsMax->value("");
	meksEditHitsCur->value("");
	meksEditNoAttks->value("");

	meksEditPlayerSelector->activate();
	meksEditMonsterSelector->activate();
	meksEditAccept->deactivate();
	meksEditCancel->deactivate();
	meksEditTab->value(meksEditCharacter);
	meksEditSpecialActions->deactivate();

	if (editStdMonsterNo != -1) {
		editStdMonster(1);
		editStdMonsterNo = -1;
	}

	reloadAllNames();
}

/********************************************************************************/
void reloadAllNames() {
int i, m;
unsigned char ml[6];
char nbuf[256];

if (debug == 1) printf("reloading all Names\n");
	meksEditPlayerSelector->clear();
	meksEditMonsterSelector->clear();
	for (i=0; i<10; i++) {
		meksEditPlayerSelector->add(party[i].Name, 0, 0, (void *)0);
	}
	for (i=10; i<(MAX_MONSTERS+10); i++) {
		meksEditMonsterSelector->add(party[i].Name, 0, 0, (void *)0);
	}
	if (MEKSconfig.cur_init == 0) {
		meksActionInitiator->clear();
		meksActionReceiver->clear();
		j = k=0;
		for (int i=0; i<(MAX_MONSTERS+10); i++) {
			if (party[i].Name[0] != '\0' && party[i].Name[0] != '-') {
				if (party[i].HitsCur >= 0 && party[i].Inactive == 0) {
if (debug == 1) printf("rAN: adding %s\n", party[i].Name);
					strcpy(nbuf, party[i].Name);
					m = 0;
					if (party[i].Stun > 0) { if (m==0) { strcat(nbuf, " (*S"); } else { strcat(nbuf, " *S"); } m = 1; }
					if (m == 1) { strcat(nbuf, ")"); }
					meksActionInitiator->add(nbuf, (void *)0);
					MEKSactionInitiatorList[k++] = i;
				}
				strcpy(nbuf, party[i].Name);
				m = 0;
				if (party[i].HitsCur < 1) { if (m==0) { strcat(nbuf, " (*D"); } else { strcat(nbuf, " *D"); } m = 1; }
				if (party[i].Stun > 0) { if (m==0) { strcat(nbuf, " (*S"); } else { strcat(nbuf, " *S"); } m = 1; }
				if (m == 1) { strcat(nbuf, ")"); }
				meksActionReceiver->add(nbuf, (void *)0);
				MEKSactionReceiverList[j++] = i;
			}
		}
	}
	for (i=0; i<6; i++) {
		ml[i] = meksModifierEffects[i]->value();
if (debug == 1) printf("sMmL:0: %d = %d\n", i, ml[i]);
		meksModifierEffects[i]->clear();
		meksModifierEffects[i]->add("", 0, 0, (void *)0);
		meksModifierEffects[i]->add("All Players", 0, 0, (void *)0);
		meksModifierEffects[i]->add("All Monster", 0, 0, (void *)0);
	}
	memset(MEKSmodifierList, 250, 25); k = 0;
	for (i=0; i<(10+MAX_MONSTERS); i++) {
		if (party[i].Name[0] != '\0' && party[i].Name[0] != '-' && party[i].HitsMax > 0) {
if (debug == 1) printf("sMmL:1: %d = %d\n", MEKSmodifierList[k], i);
			MEKSmodifierList[k++]  = i;
			for (j=0; j<6; j++) {
				meksModifierEffects[j]->add(party[i].Name, 0, 0, (void *)0);
			}
		}
	}
	for (i=0; i<6; i++) {
		meksModifierEffects[i]->value(ml[i]);
if (debug == 1) printf("sMmL:2: %d = %d\n", i, MEKSmodifierList[i]);
	}
}

/********************************************************************************/
void initialiseMEKS(char **args) {
//printf("initialiseMEKS\n");
	init16();		// init random generator

	MEKSconfig.cur_init = 0;
	MEKSconfig.cur_plyr = -1;
	MEKSconfig.xp_mult = 1.0;

	editStdMonsterNo = -1;

	memset(meksInitKey, -1, 20);

	meksActionAccept->deactivate();
	meksActionCancel->deactivate();
	meksActionReceiver->deactivate();

	for (int i=0; i<10; i++) {
		sprintf(party[i].Name, "--Party Slot %d", i);
		strcpy(party[i].weap[0].wp_dsc, "Melee");
		strcpy(party[i].weap[1].wp_dsc, "Melee");
		strcpy(party[i].weap[2].wp_dsc, "Melee");
		strcpy(party[i].weap[3].wp_dsc, "Missile");
		strcpy(party[i].weap[4].wp_dsc, "Thrown");
	}
	for (int i=10; i<(10+MAX_MONSTERS); i++) {
		sprintf(party[i].Name, "--Monst Slot %d", i-10);
		strcpy(party[i].weap[0].wp_dsc, "Melee");
		strcpy(party[i].weap[1].wp_dsc, "Melee");
		strcpy(party[i].weap[2].wp_dsc, "Melee");
		strcpy(party[i].weap[3].wp_dsc, "Missile");
		strcpy(party[i].weap[4].wp_dsc, "Thrown");
	}
	loadExtrasFile("test.xta");

	meksLogAction->deactivate();

//	if (MEKSconfig.use_logging == 1) {
		if (time(&t) != -1) {
			tp = localtime(&t);
			printf("MEKS Started (%2.2d/%2.2d/%4.4d %2.2d:%2.2d)\n", tp->tm_mday, tp->tm_mon+1, tp->tm_year+1900, tp->tm_hour, tp->tm_min);
		} else {
			printf("unable to get time ...\n");
		}
//	}

#ifdef TOOLTIPS
#include "MEKStooltips.h"
#endif

}

/********************************************************************************/
void loadExtrasFile(char *fl) {
if (debug == 1) printf("iM: loading files\n");
	doFileAction(fl, &MEKSconfig.use_merp, 1, sizeof(config));
	meksExtrasFile->value(fl);
	loadSystemConfig();

	doFileAction(MEKSconfig.pty_fn, &party[0].Name[0], 1, sizeof(players)*10);
//doReadAsIniFile();

	doFileAction(MEKSconfig.mon_fn, &party[10].Name[0], 1, sizeof(players)*MAX_MONSTERS);

	reloadAllNames();

	setActionTile(0);		// disable all the fields

	myptr = getSystemData("WE", 1);

	players *p = (players *)getSystemData("XM", 0);
	if (p != NULL) {
		for (int i=0; i<30; i++) {
//			meksMonsterName[i]->value(p->Name);
			meksSpecialBrowser->add(p->Name);
			p++;
		}
	}

//	memset(MEKSmodifierList, 250, 25); k = 0;
	for (int i=0; i<6; i++) {
      sprintf(mybuf, "%d", MEKSconfig.meksTriggers[i].rnd);
		meksTriggerCount[i]->value(mybuf);
		meksTriggerText[i]->value(MEKSconfig.meksTriggers[i].text);
//
      if (MEKSconfig.meksModifiers[i].rnd > 0) {
	      sprintf(mybuf, "%d", MEKSconfig.meksModifiers[i].rnd);
			meksModifierCount[i]->value(mybuf);
  		   sprintf(mybuf, "%d", MEKSconfig.meksModifiers[i].bonus);
			meksModifierBonus[i]->value(mybuf);
			meksModifierType[i]->value(MEKSconfig.meksModifiers[i].type);
			meksModifierEffects[i]->value(MEKSconfig.meksModifiers[i].effects);
//if (debug == 1) printf("sMmL:4: %d = %d\n", MEKSmodifierList[k], MEKSconfig.meksModifiers[i].effects);
//			MEKSmodifierList[k++] = MEKSconfig.meksModifiers[i].effects;
		}
	}

	meksActionInitiator->has_scrollbar(2);
	meksActionReceiver->has_scrollbar(2);

	meksEditAccept->deactivate();
	meksEditCancel->deactivate();
}

/********************************************************************************/
void loadFile(int type) {
	char *merge = NULL;
	players *p;
	int i,j;

	switch(type) {
		case 0:	myptr = fl_file_chooser("Select a Party File to Load", "*.pty", (char *)meksPlayerFile->value());
			if (myptr != NULL) {
				doFileAction(myptr, &party[0].Name[0], 1, sizeof(players)*10);
				meksPlayerFile->value(myptr);
			}
			reloadAllNames();
			break;
		case 1:	merge = NULL;
					if (party[10].Name[0] != '-' || party[10].HitsMax != 0) {
						if (doAreYouSure("Shall I MERGE these in ?") == 1) {
							merge = (char *)malloc(sizeof(players)*24);
						}
					}
			myptr = fl_file_chooser("Select a Monster File to Load", "*.mon", (char *)meksMonsterFile->value());
			if (myptr != NULL) {
				if (merge == NULL) {
					doFileAction(myptr, &party[10].Name[0], 1, sizeof(players)*MAX_MONSTERS);
				} else {
					doFileAction(myptr, merge, 1, sizeof(players)*MAX_MONSTERS);
					p = (players *)merge;
					for (i=0; i<MAX_MONSTERS; i++) {
						if (p[i].Name[0] != '-' && p[i].HitsMax != 0) {
							for (j=10; j<(10+MAX_MONSTERS); j++) {
								if (party[j].Name[0] == '-' || party[j].HitsMax == 0 || party[j].HitsCur < 0) {
									memcpy(party[j].Name, p[i].Name, sizeof(players));
									break;
								}
							}
						}
					}
					free(merge);
				}
				meksMonsterFile->value(myptr);
			}
			reloadAllNames();
			break;
		case 2:	myptr = fl_file_chooser("Select a Extras File to Load", "*.xta", (char *)meksExtrasFile->value());
			if (myptr != NULL) {
				doFileAction(myptr, &MEKSconfig.use_merp, 1, sizeof(config));
				meksExtrasFile->value(myptr);
			}
			break;
	}
}

/********************************************************************************/
void saveFile(int type) {
	saveSystemConfig();

	switch(type) {
		case 0: doFileAction((char *)meksPlayerFile->value(), &party[0].Name[0], 2, sizeof(players)*10);
				  break;
		case 1: doFileAction((char *)meksMonsterFile->value(), &party[10].Name[0], 2, sizeof(players)*MAX_MONSTERS);
				  break;
	}
}

/********************************************************************************/
void doFileAction(char *fname, char *buf, int type, int size) {
int fp;

	if (fname[0] == '\0') {
		return;
	}

	switch(type) {
		case 1:	if ((fp = open(fname, O_RDONLY)) != -1) {
				read(fp, buf, size);
				close(fp);
			}
			break;
		case 2:	if ((fp = open(fname, O_RDWR|O_CREAT|O_TRUNC, 666)) != -1) {
				write(fp, buf, size);
				close(fp);
			}
			break;
	}
}

/********************************************************************************/
void qksaveFile() {
	saveSystemConfig();
	doFileAction((char *)meksPlayerFile->value(), &party[0].Name[0], 2, sizeof(players)*10);
	doFileAction((char *)meksMonsterFile->value(), &party[10].Name[0], 2, sizeof(players)*MAX_MONSTERS);
	doFileAction((char *)meksExtrasFile->value(), &MEKSconfig.use_merp, 2, sizeof(config));
//	doSaveAsIniFile();
}

/********************************************************************************/
void doExtrasSelection() {
	int kxp[11+MAX_MONSTERS], wkxp[11+MAX_MONSTERS], whxp[11+MAX_MONSTERS];
	unsigned char whom, bxp;
	int i, j;

	i = meksExtraSelector->value();

	meksExtrasDisplay->clear();

	switch (i) {
		case 0:	sprintf(mybuf, "Doing XP Calc: %.2f", MEKSconfig.xp_mult);
					meksExtrasDisplay->add(mybuf, (void *)0);
					j = k = l = 0;
					for (i=0; i<(10+MAX_MONSTERS); i++) {
						kxp[i] = 0; wkxp[i] = whxp[i] = -1;
					}
					for (i=0; i<10; i++) {
						if (party[i].xp > 0) {
							sprintf(mybuf, "%s: %d", party[i].Name, (int )(party[i].xp * MEKSconfig.xp_mult));
if (MEKSconfig.use_logging == 1) printf("XP: %s\n", mybuf);
							meksExtrasDisplay->add(mybuf, (void *)0);
							j += (int )(party[i].xp * MEKSconfig.xp_mult);
							for (l=0; party[i].batlxp[l] != '\0' && l < 80; l++) {
								whom = party[i].batlxp[l];
								whom = whom << 4;
								whom = whom >> 4;
								bxp = party[i].batlxp[l] >> 4;
if (debug == 1) printf("dEX: %d (%d/%d/%d)\n", i, l, whom, bxp);
								if (bxp == KILL_XP) {
									wkxp[whom] = i;
									if (whxp[whom] == -1) {
										whxp[whom] = i;
									} else if (whxp[whom] != i) {
										whxp[whom] = -2;
									}
								} else {
									kxp[whom] += (int )(bxp * 5 * party[whom].Level * MEKSconfig.xp_mult);
if (debug == 1) printf("dEX: %d (%d/%d)\n", i, whom, kxp[whom]);
								}
							}
						}
						if (party[i].HitsMax > 0) {
							k++;
						}
					}
					if (k != 0) {
						sprintf(mybuf, "Group XP: %d (%d)", j, (j/k));
						meksExtrasDisplay->add(mybuf, (void *)0);
if (MEKSconfig.use_logging == 1) printf("XP: %s\n", mybuf);
					}
					for (i=0; i<(10+MAX_MONSTERS); i++) {
						if (wkxp[i] != -1) {
							whom = wkxp[i];
							if (party[i].Level >= party[whom].Level) {
								l = 200 + (party[i].Level - party[whom].Level) * 50;
							} else {
								l = 200 + (party[i].Level - party[whom].Level) * 30;
							}
							if (whxp[i] == whom && l > 0) {
								l *= 2;
							}
							l -= kxp[i];
							if (l > 0) {
								sprintf(mybuf, "Kill XP: %s: %s = %d\n", party[whom].Name, party[i].Name, l);
								meksExtrasDisplay->add(mybuf, (void *)0);
if (MEKSconfig.use_logging == 1) printf("XP: %s", mybuf);
							}
						}
					}
			break;
		case 1:	meksExtrasDisplay->add("Doing Status Display", (void *)0);
					for (i=0; i<(10+MAX_MONSTERS); i++) {
						mybuf[0] = '\0';
						if (party[i].Name[0] != '-' && party[i].Name[0] != '\0' && party[i].HitsMax > 0) {
							strcpy(mybuf, party[i].Name);
							strcat(mybuf, ": ");
							if (party[i].HitsCur >= 0) {
								j = (party[i].HitsCur * 100) / party[i].HitsMax;
							}
							else {
								if (party[i].CON == 0) {
									party[i].CON = 70;
								}
								j = (party[i].HitsCur * 100) / party[i].CON;
							}
if (debug == 1) printf("SD: %d %d %d\n", j, party[i].HitsCur, party[i].HitsMax);
							sprintf(mybuf2, "%d%% H:%d/%d B:%d AP:%d S:%d I:%d Lvl:%d M&M %d Armor: %s OB: %d DB: %d/%d", j, party[i].HitsCur, party[i].HitsMax, party[i].Bleed, party[i].ActPenalty, party[i].Stun, party[i].Inactive, party[i].Level, party[i].MMBase, ArmorType[party[i].Armor], getOB(i, Act_Melee), party[i].DBBase, party[i].DBShield);
							strcat(mybuf, mybuf2);
							meksExtrasDisplay->add(mybuf, (void *)0);
						}
					}
			break;
	}
}

/********************************************************************************/
void setReceiverFlag() {
int tOB;

	MEKSconfig.cur_def = 1;

	meksActionAccept->activate();
	meksActionCancel->activate();

	i = MEKSactionReceiverList[meksActionReceiver->value() - 1];
	j = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
	k = party[j].AttackCount;
	if (party[j].NoAttks == 1) {
		for (l=0; l<3; l++) {
			if (party[j].weap[l].wp_sel == 1) {
				k = l;
				break;
			}
		}
	}
	sprintf(mybuf, "Initiator Selected: %s\nUsing:\nDB (P:%d, B:%d, S:%d, Max-OB:%d) %s\nMax Weapon OB: %d", party[j].Name, party[i].ParryVal, party[i].DBBase, party[i].DBShield, getOB(i, Act_Melee), party[i].Name, getOB(j, Act_Melee));
	meksActionMessage->value(mybuf);

		// sanity check ...
	tOB = getOB(i, Act_Melee);
	if (party[i].ParryVal > tOB) {
		if (tOB < 0) {
			party[i].ParryVal = 0;
		} else {
			party[i].ParryVal = getOB(i, Act_Melee);
		}
	}

	sprintf(mybuf, "%d", party[i].ParryVal);		// set defenders parry field
	actionsMeleeParryDefender[0]->value(mybuf);
	actionsMeleeParryDefender[2]->value(mybuf);
	meksMeleeArmorSelector->value(party[i].Armor);
}

/********************************************************************************/
void setPlayerAction(int plyr) {
int tOB;

	MEKSconfig.cur_def = -1;

	plyr = MEKSactionInitiatorList[plyr];
if (debug == 1) printf("sPA: %d\n", plyr);

	if (party[plyr].NoAttks == 0 || party[plyr].NoAttks > 3) {
		doSystemAlert("Warning: an issue with 'No Attks' ... please fix");
		return;
	}

	if (party[plyr].AttackCount >= party[plyr].NoAttks) {
		doSystemAlert("Warning: they have exceeded their attack count\nUsing 1st Melee Weapon");
	}
		// sanity check ...
	tOB = getOB(plyr, Act_Melee);
	if (party[plyr].ParryVal > tOB) {
		if (tOB < 0) {
			party[plyr].ParryVal = 0;
		} else {
			party[plyr].ParryVal = getOB(plyr, Act_Melee) / 2;
		}
	}

	if (party[plyr].Parry > 0) {		// they MUST parry
		party[plyr].ParryVal = getOB(plyr, Act_Melee);
		meksActionMessage->value("!!!  They MUST parry !!!");
	}

	if (party[plyr].NoParry > 0) {		// they MUST NOT parry
		party[plyr].ParryVal = 0;
		meksActionMessage->value("!!!  They MUST NOT parry !!!");
	}

	meksActionInitiator->deactivate();
	meksActionReceiver->activate();
	meksActionReceiver->deselect(0);
	meksActionMessage->value("");
	meksActionCancel->activate();

	setActionTile(1);			// enable just the file line of rolls

	memcpy(party[plyr].weap[5].wp_dsc, getWeaponStats("Base Spell"), sizeof(weapon));

	if (MEKSconfig.roll_all == 1 || plyr > 9) {
		sprintf(mybuf, "%d", getDiceRoll());
		actionsMeleeRoll[0]->value(mybuf);
		actionsMeleeRoll[1]->value(mybuf);
		actionsMeleeRoll[2]->value(mybuf);
		actionsMeleeRoll[3]->value(mybuf);
	}

	sprintf(mybuf, "%d", getOB(plyr, Act_Melee));
	actionsMeleeOB[0]->value(mybuf);
	sprintf(mybuf, "%d", getOB(plyr, Act_SpellCast));
	actionsMeleeOB[1]->value(mybuf);
	sprintf(mybuf, "%d", getOB(plyr, Act_MissileAttack));
	actionsMeleeOB[2]->value(mybuf);
	sprintf(mybuf, "%d", party[plyr].ParryVal);
	actionsMeleeParry[0]->value(mybuf);
	actionsMeleeParry[2]->value(mybuf);
	if (party[plyr].weap[4].wp_ob == 0) {
		meksActionsThrown->deactivate();
	}

//	for (j=0; j<9; j++) {
//		k = party[plyr].action[0].effects[j];
//		if (k != -1) {
//			for (l=meksActionReceiver->size(); l>0; l--) {
//				if (MEKSactionlist[l] == k) {
//					meksActionReceiver->value(l);
//				}
//			}
//		}
//	}

	meksTabMaster->value(meksTabActions);		// set the right tabs to active
	actionTabs->value(actionsMelee);
	actionsSpellModifiers->value(0);

	if (party[plyr].HitsCur < 1 || party[plyr].Inactive > 0 || party[plyr].Death > 0) {
		sprintf(mybuf, "FYI: %s is unconcious/inactive", party[plyr].Name);
		doSystemAlert(mybuf);
	} else if (party[plyr].Stun > 0) {
		sprintf(mybuf, "FYI: %s is Stunned", party[plyr].Name);
		doSystemAlert(mybuf);
	}

	setTimeOnTitle();

	meksMeleeWeaponSelector->clear();
	meksMeleeWeaponSelector->value(0);
	for (i=0; i<3; i++) {
		if (party[plyr].weap[i].wp_ob != 0) {
			meksMeleeWeaponSelector->add(party[plyr].weap[i].wp_dsc);
			if (party[plyr].weap[i].wp_sel == 1) {
				meksMeleeWeaponSelector->value(i);
			}
		}
	}
	sprintf(mybuf, "Initiator Selected: %s", party[plyr].Name);
	meksActionMessage->value(mybuf);
}

/********************************************************************************/
void acceptAction() {
int tile, hp, amr;
float xpm=1.0;
char bxp[2];

	j = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
	k = MEKSactionReceiverList[meksActionReceiver->value() - 1];
	tile=party[j].action[party[j].ActionCount];

	i = atoi(actionsMeleeRoll[tile]->value());

if (debug == 1) printf("aA: %d:%d (%d:%d)\n", j, k, tile,i);
	if (i < 0) {		// a fumble roll ...
		k = j;
		xpm = (float )0.0;		// No XP for this !!!!
	} else {
	// do the XP modifiers if they're incap in any way....
		if (party[k].Stun > 0) {
			xpm = (float )0.5;
		}
		if (party[k].HitsCur == 0 || party[k].Inactive > 0) {
			xpm = (float )0.1;
		}
		if (party[k].HitsCur < 0) {
			xpm = (float )0.0;
		}
		if (tile == 1) {	// Spells
			party[j].xp += (int )(100 * xpm);
		}
	}

	party[k].xp += (int )((atoi(actionsMeleeDamageHPs[tile]->value())) * xpm);
	if (tile != 3) {
		i = actionsMeleeCrit1Result[tile]->value();
	 	if (i > 0 && i < 6) {
			party[k].xp += (int )((i * 100) * xpm);
			party[j].xp += (int )((party[k].Level * actionsMeleeCrit1Result[tile]->value() * 5) * xpm);
			bxp[0] = i;
			bxp[0] = bxp[0] << 4;
			bxp[0] += k;
			bxp[1] = '\0';
			strncat((char *)&party[j].batlxp[0], &bxp[0], 1);
if (debug == 1) printf("aA: XP %d = %d (%d)\n", j, party[j].xp, i);
if (debug == 1) printf("aA: XP %d = %d\n", k, party[k].xp);
		}
		i = actionsMeleeCrit2Result[tile]->value();
	 	if (i > 0 && i < 6) {
			party[k].xp += (int )((i * 100) * xpm);
			party[j].xp += (int )((party[k].Level * actionsMeleeCrit2Result[tile]->value() * 5) * xpm);
			bxp[0] = i;
			bxp[0] = bxp[0] << 4;
			bxp[0] += k;
			bxp[1] = '\0';
			strncat((char *)&party[j].batlxp[0], &bxp[0], 1);
if (debug == 1) printf("aA: XP %d = %d (%d)\n", j, party[j].xp, i);
if (debug == 1) printf("aA: XP %d = %d\n", k, party[k].xp);
		}
		party[k].Parry += actionResults[0][4] + actionResults[1][4] + actionResults[2][4];
		party[k].NoParry += actionResults[0][5] + actionResults[1][5] + actionResults[2][5];
		party[k].Death += actionResults[0][6] + actionResults[1][6] + actionResults[2][6];
		party[k].Inactive += actionResults[0][7] + actionResults[1][7] + actionResults[2][7];
	}
	else {
		party[j].xp += mmxp[(actionsMoveLevel->value() * 2) + 1];
	}
if (debug == 1) printf("aA: XP %d = %d (%f, %d)\n", j, party[j].xp, xpm, bxp[0]);
if (debug == 1) printf("aA: XP %d = %d\n", k, party[k].xp);
	
	hp = atoi(actionsMeleeDamageHPs[tile]->value()) + atoi(actionsMeleeDamageBleed[tile]->value());
	if ((party[k].HitsCur > 0 && (party[k].HitsCur - hp) < 1) ||
		 (actionResults[0][6] + actionResults[1][6] + actionResults[2][6]) > 0) {
		sprintf(mybuf, "You've killed %s ... well done !!", party[k].Name);
		doSystemAlert(mybuf);
		if (MEKSconfig.use_logging == 1) {
			printf("Alert: %s\n", mybuf);
		}
// add in kill XP identifier
		bxp[0] = KILL_XP;
		bxp[0] = bxp[0] << 4;
		bxp[0] += k;
		bxp[1] = '\0';
		strncat((char *)&party[j].batlxp[0], &bxp[0], 1);
	}
	party[k].HitsCur -= hp;
	party[k].ActPenalty += atoi(actionsMeleeDamageAP[tile]->value());
	party[k].Bleed += atoi(actionsMeleeDamageBleed[tile]->value());
	if (atoi(actionsMeleeDamageBleed[tile]->value()) != 0) {
		strcat(party[k].Wounds, actionsMeleeDamageBleed[tile]->value());
		strcat(party[k].Wounds, ",");
	}
// if the defender has already done their action then inc stunned count if not already stunned
	if (party[k].ActionCount > 0 && atoi(actionsMeleeDamageStun[tile]->value()) > 0 && party[k].Stun == 0) {
		party[k].Stun++;
	}
	party[k].Stun += atoi(actionsMeleeDamageStun[tile]->value());

	if (tile == 0 || tile == 2) {
		party[j].ParryVal = atoi(actionsMeleeParry[tile]->value());
		party[k].ParryVal = atoi(actionsMeleeParryDefender[tile]->value());
	}
	if (MEKSconfig.use_logging == 1) {
		switch (tile) {
			case 0:
			case 1:
			case 2:
			case 3:	printf("%s %s %s (H:%d A:%d B:%d S:%d", party[j].Name, &actionString[tile][0], party[k].Name, atoi(actionsMeleeDamageHPs[tile]->value()), atoi(actionsMeleeDamageAP[tile]->value()), atoi(actionsMeleeDamageBleed[tile]->value()), atoi(actionsMeleeDamageStun[tile]->value()));
						if (tbl_crit1 != NULL) {
							printf(" C1:%1.1s/%s.", actionsMeleeCrit1Result[tile]->text(), tbl_crit1->msg);
						}
						if (tbl_crit2 != NULL) {
							printf(" C2:%1.1s/%s.", actionsMeleeCrit2Result[tile]->text(), tbl_crit2->msg);
						}
						printf(")\n");
					break;
		}
	}

	meksActionInitiator->activate();
	meksActionInitiator->deselect();
	meksActionReceiver->deselect(0);
	meksActionReceiver->deactivate();

	meksActionAccept->deactivate();
	meksActionCancel->deactivate();

	setActionTile(2);			// disable all lines

	party[j].ActionCount++;

	if (tile == 0) {
		party[j].AttackCount++;
	} else if (tile == 2) {
		party[j].AttackCount = party[j].NoAttks;
	}

	if (party[k].Stun > 100 || party[k].Inactive > 100 || party[k].Bleed > 100) {
		sprintf(mybuf, "Possible Data corruption for\n%s ... please Edit & check", party[k].Name);
		doSystemAlert(mybuf);
	}

			// check for any temporary penalties and assign as required
	for (i=0; i<8; i++) {
		if (tempPenalties[i][3] == k) {
			setTempPenalty(j, tempPenalties[i][0], tempPenalties[i][1], tempPenalties[i][2]);
		} else if (tempPenalties[i][3] == j) {
			setTempPenalty(k, tempPenalties[i][0], tempPenalties[i][1], tempPenalties[i][2]);
		}
		tempPenalties[i][0] = tempPenalties[i][1] = tempPenalties[i][2] = tempPenalties[i][3] = 0;
	}
}

/********************************************************************************/
void cancelAction() {
	meksActionInitiator->activate();
	meksActionInitiator->deselect();
	meksActionReceiver->deselect(0);
	meksActionReceiver->deactivate();

	meksActionAccept->deactivate();
	meksActionCancel->deactivate();

	meksActionMessage->value("");
	setActionTile(2);

	for (i=0; i<8; i++) {
		tempPenalties[i][0] = tempPenalties[i][1] = tempPenalties[i][2] = tempPenalties[i][3] = 0;
	}
}

/********************************************************************************/
int getDB(int plyr, int action) {
int val=0, i;

	switch (action) {
		case Act_Melee:
			val += party[plyr].DBBase + getModifiers(plyr, 'D'); // + party[plyr].DBShield 
			break;
		case Act_MissileAttack: 
			val += party[plyr].DBBase + getModifiers(plyr, 'D');
			break;
		case Act_SpellCast:
			val += party[plyr].DBBase + getModifiers(plyr, 'D');
			break;
	}
if (debug == 1) printf("gDB: %d/%d/%d\n", plyr, action, val);
	return val;
}

/********************************************************************************/
int getOB(int plyr, int action) {
int val=0, i;

   val -= (party[plyr].ActPenalty + getTempPenalties(plyr, TPEN_OB) + getTempPenalties(plyr, TPEN_APEN));

   if (party[plyr].HitsCur < (party[plyr].HitsMax / 2))
      val -= 20;

	switch (action) {
		case Act_Melee:
					i = party[plyr].AttackCount;
					if (party[plyr].NoAttks == 1) {
						for (j=0; j<3; j++) {
							if (party[plyr].weap[i].wp_sel == 1) {
								i = j;
								break;
							}
						}
					}
					if (i >= 0 && i <= 2) {			// make sure its a melee weapon
						if (party[plyr].weap[i].wp_ob == 0) {	// ensure an OB ?
							i = 0;
						}
					} else {		// hmm ... point to first weapon
						i = 0;
					}
					if (strcasecmp(&party[plyr].weap[i].wp_dsc[0], "Poison") == 0
					 || strcasecmp(&party[plyr].weap[i].wp_dsc[0], "Fear") == 0
					 || strcasecmp(&party[plyr].weap[i].wp_dsc[0], "Disease") == 0
					 || strcasecmp(&party[plyr].weap[i].wp_dsc[0], "Con Drain") == 0) {
						sprintf(mybuf, "A special attack (%s) is being done\nat level %d", party[plyr].weap[i].wp_dsc, party[plyr].weap[i].wp_ob);
						doSystemAlert(mybuf);
						val = 0;
					} else {
						if (party[plyr].NoAttks == 1) {		// find the 'selected' weapon ...
							for (i=0; i<3; i++) {
								if (party[plyr].weap[i].wp_sel == 1) {
									break;
								}
							}			// check to see if it has an OB, else use 1st weapon
							if (party[plyr].weap[i].wp_ob == 0 || i > 2) {
								i = 0;
								party[plyr].weap[0].wp_sel = 1;
								party[plyr].weap[1].wp_sel = party[plyr].weap[2].wp_sel = 0;
							}
						}
						val += party[plyr].weap[i].wp_ob + getModifiers(plyr, 'A');
					}
					break;
		case Act_MissileAttack: 
					val += party[plyr].weap[3].wp_ob + getModifiers(plyr, 'A');
					i=0;
					if (strcasecmp(party[plyr].weap[3].wp_dsc, "Composite Bow") == 0) {
						i = -25;
					} else if (strcasecmp(party[plyr].weap[3].wp_dsc, "CrossBow") == 0) {
						i = -50;
					} else if (strcasecmp(party[plyr].weap[3].wp_dsc, "Long Bow") == 0) {
						i = -35;
					} else if (strcasecmp(party[plyr].weap[3].wp_dsc, "Short Bow") == 0) {
						i = -10;
					}
					if (party[plyr].MissileLoad == 0) {
						val += i;
					}
					break;
		case Act_MissileLoad:
					val = 0;
					break;
		case Act_SpellCast:
					if (party[plyr].SpellCharge > 4)
						party[plyr].SpellCharge = 4;
					val += party[plyr].SpellBase + spellchge[party[plyr].SpellCharge] + getModifiers(plyr, 'A');
					break;
		case Act_SpellCharge:
					val = 0;
					break;
		case Act_MissileThrow:
					val += party[plyr].weap[4].wp_ob + getModifiers(plyr, 'A');
					break;
		case Act_Move:
					val = 0;
					break;
		case Act_OppAction:
					val = 0;
					break;
		case Act_Inactive:
					val = 0;
					break;
		case Act_Bandage:
					val = 0;
					break;
	}
   if (party[plyr].Stun > 0) {		// if stunned then only 50% of usual OB
		val /= 2;
		party[plyr].ParryVal = val;
	}

if (debug == 1) printf("gOB: %d/%d/%d\n", plyr, action, val);

	return val;
}

/********************************************************************************/
void saveSystemConfig() {
	MEKSconfig.rnd_no = atoi(meksSystemRound->value());
	MEKSconfig.init_sys = meksSystemInitiative->value();
	MEKSconfig.xp_mult = atof(meksSystemXPMultiplier->value());
	MEKSconfig.roll_all = meksSystemRollAllRolls->value();
	MEKSconfig.auto_save = (char )meksSystemAutoSave->value();
	MEKSconfig.use_parryperc = meksSystemParryPerc->value();
	strcpy(MEKSconfig.sys_dr, meksSystemDirectory->value());
	strcpy(MEKSconfig.pty_fn, meksPlayerFile->value());
	strcpy(MEKSconfig.mon_fn, meksMonsterFile->value());
	strcpy(MEKSconfig.xta_fn, meksExtrasFile->value());

	acceptTriggers();
	acceptModifiers();

	for (j=0; j<9; j++) {
		if (j != 0) {
			strncpy(MEKSconfig.meksOptions[j].title, meksOptionTitle[j]->value(), 14);
			MEKSconfig.meksOptions[j].title[14] = '\0';
		}
		for (i=0; i<7; i++) {
			strncpy(&MEKSconfig.meksOptions[j].value[i][0], meksOptionValue[j][i]->value(), 3);
			MEKSconfig.meksOptions[j].value[i][3] = '\0';
		}
	}
	for (j=0; j<(10+MAX_MONSTERS); j++) {
		strncpy(MEKSconfig.meksInitiatives[j].name, meksInitNames[j]->value(), 20); MEKSconfig.meksInitiatives[j].name[20] = '\0';
		MEKSconfig.meksInitiatives[j].value[0] = atoi(meksInitValues[j][0]->value());
		MEKSconfig.meksInitiatives[j].value[1] = atoi(meksInitValues[j][1]->value());
		MEKSconfig.meksInitiatives[j].value[2] = atoi(meksInitValues[j][2]->value());
		MEKSconfig.meksInitiatives[j].value[3] = meksInitKey[j];
	}
}

/********************************************************************************/
void loadSystemConfig() {
	sprintf(mybuf, "%d", MEKSconfig.rnd_no);
	meksSystemRound->value(mybuf);
	meksSystemInitiative->value(MEKSconfig.init_sys);
	sprintf(mybuf, "%.2f", MEKSconfig.xp_mult);
	meksSystemXPMultiplier->value(mybuf);
	meksSystemRollAllRolls->value(MEKSconfig.roll_all);
	meksSystemAutoSave->value(MEKSconfig.auto_save);
	meksSystemDirectory->value(MEKSconfig.sys_dr);
	meksPlayerFile->value(MEKSconfig.pty_fn);
	meksMonsterFile->value(MEKSconfig.mon_fn);
	meksExtrasFile->value(MEKSconfig.xta_fn);
	meksSystemActionLog->value(MEKSconfig.use_logging);
   meksSystemParryPerc->value(MEKSconfig.use_parryperc);
   meksSystemBreak150->value(MEKSconfig.use_150);

	for (j=0; j<9; j++) {
		if (j != 0) {
			meksOptionTitle[j]->value(MEKSconfig.meksOptions[j].title);
		}
		for (i=0; i<7; i++) {
			meksOptionValue[j][i]->value(&MEKSconfig.meksOptions[j].value[i][0]);
		}
	}
	for (j=0; j<(10+MAX_MONSTERS); j++) {
		meksInitNames[j]->value(MEKSconfig.meksInitiatives[j].name);
		sprintf(mybuf, "%d", MEKSconfig.meksInitiatives[j].value[0]); meksInitValues[j][0]->value(mybuf);
		sprintf(mybuf, "%d", MEKSconfig.meksInitiatives[j].value[1]); meksInitValues[j][1]->value(mybuf);
		sprintf(mybuf, "%d", MEKSconfig.meksInitiatives[j].value[2]); meksInitValues[j][2]->value(mybuf);
		meksInitKey[j] = MEKSconfig.meksInitiatives[j].value[3];
	}
}

/********************************************************************************/
void checkActionSelected() {
	if (k == Act_MissileLoad || k == Act_SpellCharge || k == Act_Move || k == Act_Inactive) {
		meksActionReceiver->deselect(0);
		l = meksActionInitiator->value();
if (debug == 1) printf("cAS: %d/%d\n", k, l);
		meksActionReceiver->value(l);
	}
}

/********************************************************************************/
int getModifiers(int plyr, int type) {
int val = 0;
unsigned char t, e;

	for (int i=0; i<6; i++) {
// if (debug == 1) printf("aM: %d:%d:%d:%d\n", MEKSconfig.meksModifiers[i].rnd, MEKSconfig.meksModifiers[i].bonus, MEKSconfig.meksModifiers[i].type, MEKSconfig.meksModifiers[i].effects);
		if (MEKSconfig.meksModifiers[i].rnd > 0) {
			t = MEKSconfig.meksModifiers[i].type;
			e = MEKSconfig.meksModifiers[i].effects;
			switch (type) {
				case 'A': if (t == 0) {								// Attack
								if ((e == 1 && plyr < 10) ||
								    (e == 2 && plyr > 9) ||
								    (MEKSmodifierList[e-3] == plyr)) {
									val += MEKSconfig.meksModifiers[i].bonus;
								}
							 }
if (debug == 1) printf("gM:A: %d : %d %d %d\n", plyr, t, e, MEKSmodifierList[e-3]);
						break;
				case 'D': if (t == 1 || t == 4 || t == 5) {		// Defence
								if ((e == 1 && plyr < 10) ||
								    (e == 2 && plyr > 9) ||
								    (MEKSmodifierList[e-3] == plyr)) {
									val += MEKSconfig.meksModifiers[i].bonus;
								}
							 }
if (debug == 1) printf("gM:D: %d : %d %d %d\n", plyr, t, e, MEKSmodifierList[e-3]);
						break;
				case 'M': if (t == 2 || t == 4 || t == 6) {		// Move & M
								if ((e == 1 && plyr < 10) ||
								    (e == 2 && plyr > 9) ||
								    (MEKSmodifierList[e-3] == plyr)) {
									val += MEKSconfig.meksModifiers[i].bonus;
								}
							 }
if (debug == 1) printf("gM:M: %d : %d %d %d\n", plyr, t, e, MEKSmodifierList[e-3]);
						break;
				case 'R': if (t == 3 || t == 5 || t == 6) {		// RR
								if ((e == 1 && plyr < 10) ||
								    (e == 2 && plyr > 9) ||
								    (MEKSmodifierList[e-3] == plyr)) {
									val += MEKSconfig.meksModifiers[i].bonus;
								}
							 }
if (debug == 1) printf("gM:R: %d : %d %d %d\n", plyr, t, e, MEKSmodifierList[e-3]);
						break;
				case 'B': if (t == 7) {								// Base Spells
								if ((e == 1 && plyr < 10) ||
								    (e == 2 && plyr > 9) ||
								    (MEKSmodifierList[e-3] == plyr)) {
									val += MEKSconfig.meksModifiers[i].bonus;
								}
							 }
if (debug == 1) printf("gM:B: %d : %d %d %d\n", plyr, t, e, MEKSmodifierList[e-3]);
						break;
				case 'E': if (t == 8) {								// Elemental Spells like Bolt/Ball
								if ((e == 1 && plyr < 10) ||
								    (e == 2 && plyr > 9) ||
								    (MEKSmodifierList[e-3] == plyr)) {
									val += MEKSconfig.meksModifiers[i].bonus;
								}
							 }
if (debug == 1) printf("gM:E: %d : %d %d %d\n", plyr, t, e, MEKSmodifierList[e-3]);
						break;
			}
		}
	}
if (debug == 1) printf("gM: %d %c = %d\n", plyr, type, val);
	return val;
}

/********************************************************************************/
int getTempPenalties(int plyr, int type) {
int i,val=0;

	for (i=0; i<8; i++) {
		if (party[plyr].TempPenalties[i][0] == type) {
			val += party[plyr].TempPenalties[i][1];
if (debug == 1) printf("gTP: %d %c %d\n", plyr, type, val);
		}
	}
	return val;
}

/********************************************************************************/
void doEndOfRound() {
	meksActionInitiator->activate();
	meksActionReceiver->activate();

	j=0; mybuf2[0] = '\0';
	for (i=0; i<(10+MAX_MONSTERS); i++) {		// Check to make sure everyone has done there actions
		if (party[i].HitsMax > 0 && party[i].Inactive == 0 && party[i].HitsCur > 0) {
			if (party[i].ActionCount == 0 || (party[i].NoAttks < party[i].AttackCount)) {
				j++;
				if (j % 6 == 0) {
					sprintf(mybuf2, "%s\n%s, ", mybuf2, party[i].Name);
				} else {
					sprintf(mybuf2, "%s%s, ", mybuf2, party[i].Name);
				}
			}
		}
	}
	if (j != 0) {
		sprintf(mybuf, "Continue as %d characters havent done actions ?\n%s", j, mybuf2);
		if (doAreYouSure(mybuf) == -1) {
			return;
		}
	}
	cancelAction();		// enable the Action Pane now

	for (i=0; i<(10+MAX_MONSTERS); i++) {
		party[i].HitsCur -= party[i].Bleed;
		if (party[i].Stun > 0) {
			party[i].Stun--;
		}
		if (party[i].Inactive > 0) {
			party[i].Inactive--;
		}
		if (party[i].Death > 0) {
			party[i].Death--;
			if (party[i].Death == 0) {
				sprintf(mybuf, "%s has now died !!!", party[i].Name);
				doSystemAlert(mybuf);
				if (MEKSconfig.use_logging == 1) {
					printf("Alert: %s\n", mybuf);
				}
			}
		}
		if (party[i].Parry > 0) {
			party[i].Parry--;
		}
		if (party[i].NoParry > 0) {
			party[i].NoParry--;
		}
		if (party[i].action[0] != Act_MissileLoad && party[i].action[0] != Act_SpellCharge
		 && party[i].action[1] != Act_MissileLoad && party[i].action[1] != Act_SpellCharge) {
			party[i].SpellCharge = party[i].MissileLoad = 0;
		}
		party[i].ActionCount = 0;
		party[i].AttackCount = 0;
			// now check for Temp Penalties and clear them out when done
		for (j=0; j<8; j++) {
			if (party[i].TempPenalties[j][2] > 0) {		// No.Rnds > 0
if (debug == 1) printf("eorTP: %d %d %d\n", i, j, party[i].TempPenalties[j][2]);
				party[i].TempPenalties[j][2] --;
				if (party[i].TempPenalties[j][2] == 0) {
if (debug == 1) printf("eorTP: Fin: %d %d %d\n", i, j, party[i].TempPenalties[j][2]);
					party[i].TempPenalties[j][0] = 0;
					party[i].TempPenalties[j][1] = 0;
					party[i].TempPenalties[j][2] = 0;
				}
			}
		}
	}

	reloadAllNames();

	MEKSconfig.rnd_no++;					// inc the round no
	sprintf(mybuf, "%d", MEKSconfig.rnd_no);
	meksSystemRound->value(mybuf);

	for (i=0; i<6; i++) {
		if (MEKSconfig.meksTriggers[i].rnd > 0) {
			MEKSconfig.meksTriggers[i].rnd--;
			if (MEKSconfig.meksTriggers[i].rnd == 0) {
				doSystemAlert(MEKSconfig.meksTriggers[i].text);
				if (MEKSconfig.use_logging == 1) {
					printf("Alert: %s\n", MEKSconfig.meksTriggers[i].text);
				}
				meksTriggerCount[i]->value("0");
				meksTriggerText[i]->value("");
				MEKSconfig.meksTriggers[i].text[0] = '\0';
			} else {
				sprintf(mybuf, "%d", MEKSconfig.meksTriggers[i].rnd);
				meksTriggerCount[i]->value(mybuf);
			}
		}
		if (MEKSconfig.meksModifiers[i].rnd > 0) {
			MEKSconfig.meksModifiers[i].rnd--;
			if (MEKSconfig.meksModifiers[i].rnd == 0) {
// do we show that it's finished ???
				meksModifierCount[i]->value("0");
				meksModifierBonus[i]->value("0");
				MEKSconfig.meksModifiers[i].bonus = 0;
			} else {
				sprintf(mybuf, "%d", MEKSconfig.meksModifiers[i].rnd);
				meksModifierCount[i]->value(mybuf);
			}
		}
	}

	if (MEKSconfig.auto_save > 0) {		// save after X rounds
		if ((MEKSconfig.rnd_no % MEKSconfig.auto_save) == 0) {
			qksaveFile();
		}
	}

	meks_init_calc();			// re do the init list
}

/********************************************************************************/
void setActionTile(int state) {
	switch(state) {
		case 0:
		case 2:
			for (i=0; i<3; i++) {
if (debug == 1) printf("sAT: %d\n", i);
				actionsMeleeRoll[i]->deactivate();
				actionsMeleeAdjustment[i]->deactivate();
				actionsMeleeOB[i]->deactivate();
				actionsMeleeLk1[i]->deactivate();
				actionsMeleeCrit1Roll[i]->deactivate();
				actionsMeleeCrit2Roll[i]->deactivate();
				actionsMeleeCrit1Result[i]->deactivate();
				actionsMeleeCrit2Result[i]->deactivate();
				actionsMeleeLk2[i]->deactivate();
				actionsMeleeLk3[i]->deactivate();
				actionsMeleeRoll[i]->value("0");
				actionsMeleeDamageHPs[i]->deactivate();
				actionsMeleeDamageAP[i]->deactivate();
				actionsMeleeDamageBleed[i]->deactivate();
				actionsMeleeDamageStun[i]->deactivate();
				actionsMeleeCrit1Roll[i]->value("0");
				actionsMeleeCrit1Result[i]->value(0);
				actionsMeleeCrit2Roll[i]->value("0");
				actionsMeleeCrit2Result[i]->value(0);
				actionsSpellCast->value(0);
				actionsMoveLevel->value(0);
				actionsMeleeParry[i]->deactivate();
				actionsMeleeParry[i]->value("0");
				actionsMeleeParryDefender[i]->value("0");
			}
			actionsMeleeRoll[3]->deactivate();
			actionsMeleeLk1[3]->deactivate();
			actionsMeleeDamageHPs[3]->deactivate();
			actionsMeleeDamageAP[3]->deactivate();
			actionsMeleeDamageBleed[3]->deactivate();
			actionsMeleeDamageStun[3]->deactivate();
			memset(actionResults, '\0', sizeof(actionResults));
			meksActionsThrown->value(0);
			meksActionsThrown->deactivate();
			meksMeleeSpecAttk->deactivate();
			break;
		case 1:
			for (i=0; i<3; i++) {
				actionsMeleeRoll[i]->activate();
				actionsMeleeAdjustment[i]->activate();
				actionsMeleeOB[i]->activate();
				actionsMeleeLk1[i]->activate();
				actionsMeleeRoll[i]->value("");
				actionsMeleeAdjustment[i]->value("");
				actionsMeleeOB[i]->value("0");
				actionsMeleeDamageHPs[i]->activate();
				actionsMeleeDamageAP[i]->activate();
				actionsMeleeDamageBleed[i]->activate();
				actionsMeleeDamageStun[i]->activate();
				actionsMeleeDamageHPs[i]->value("0");
				actionsMeleeDamageAP[i]->value("0");
				actionsMeleeDamageBleed[i]->value("0");
				actionsMeleeDamageStun[i]->value("0");
				actionsMeleeCrit1Roll[i]->value("");
				actionsMeleeCrit1Result[i]->value(0);
				actionsMeleeParry[i]->activate();
				actionsMeleeParry[i]->value("0");
				actionsMeleeParryDefender[i]->value("0");
			}
			actionsMeleeParry[1]->hide();
			actionsMeleeParryDefender[1]->hide();
			actionsMeleeRoll[3]->value("");
			actionsMeleeAdjustment[3]->value("");
			actionsMeleeRoll[3]->activate();
			actionsMeleeLk1[3]->activate();
			actionsMeleeDamageHPs[3]->value("0");
			actionsMeleeDamageAP[3]->value("0");
			actionsMeleeDamageBleed[3]->value("0");
			actionsMeleeDamageStun[3]->value("0");
			actionsMeleeDamageHPs[3]->activate();
			actionsMeleeDamageAP[3]->activate();
			actionsMeleeDamageBleed[3]->activate();
			actionsMeleeDamageStun[3]->activate();
			meksActionsThrown->activate();
			meksMeleeSpecAttk->activate();
			break;
		case 3:
			for (i=0; i<3; i++) {
				actionsMeleeCrit1Roll[i]->activate();
				actionsMeleeCrit1Roll[i]->value("");
				actionsMeleeCrit1Result[i]->activate();
				actionsMeleeCrit1Result[i]->value(0);
				actionsMeleeLk2[i]->activate();
			}
			break;
		case 4:
			for (i=0; i<3; i++) {
				actionsMeleeCrit2Roll[i]->activate();
				actionsMeleeCrit2Roll[i]->value("");
				actionsMeleeCrit2Result[i]->activate();
				actionsMeleeCrit2Result[i]->value(0);
				actionsMeleeLk3[i]->activate();
			}
			break;
	}
}

/********************************************************************************/
char * getSystemData(char *tbl, char decrypt) {
struct stat fs;
char mb[4];

	k=0;
	i=-1;
	while (tbl[++i] != '\0') {
		mb[i] = (char )tolower ((int)(unsigned char) tbl[i]);
	}
	k = toupper((int )tbl[0]) + toupper((int )tbl[1]);
	mb[i] = '\0';

if (debug == 1) printf("gSD: table id = %s (%s %d)\n", mb, tbl, i);
	for (i=0; i<61; i++) {
		if (strcasecmp(&tabletype[i][0], mb) == 0) {
			return(tablemem[i]);
		}
	}
	sprintf(mybuf, "%stab_%s.dat", MEKSconfig.sys_dr, mb);
	if ((i = open(mybuf, O_RDONLY)) != -1) {
		fstat(i, &fs);
		for (j=0; j<61; j++) {
			if (tabletype[j][0] == '\0' && tablemem[j] == NULL) {
				if ((tablemem[j] = (char *)malloc(fs.st_size)) != NULL) {
					strcpy(&tabletype[j][0], tbl);
					read(i, tablemem[j], fs.st_size);
					close(i);
// if (debug == 1) printf("gSD: loaded %s (%d:%d:%d)\n", mb, decrypt, k, j);
if (debug == 1) printf("gSD: loaded %s (%d:%d)\n", mb, decrypt, j);
					if (decrypt == 1) {
						myptr = tablemem[j];
						for (i=0; i<fs.st_size; i++) {
							*myptr = ~ (*myptr ^ k); 
							myptr++;
						}
					}
					return(tablemem[j]);
				}
				else {
if (debug == 1) printf("gSD: error malloc-ing %s\n", mb);
				}
			}
		}
	}
	else {
if (debug == 1) printf("gSD: error openning %s\n", mb);
	}
	return(NULL);
}

/********************************************************************************/
Fl_Window *alertWindow=NULL;
Fl_Button *alertButton=NULL;
Fl_Output *alertMessage=NULL;

static void cb_acceptAlertButton(Fl_Button*, void*) {
  alertWindow->hide();
}

/********************************************************************************/
void doSystemAlert(char *msg) {
if (debug == 1) printf("dSA: %s\n", msg);
	if (alertWindow == NULL) {
		alertWindow = new Fl_Window(228, 70, "MEKS: Alert Message");
		alertWindow->labelsize(MEKS_LABEL_SIZE);
		{ alertMessage = new Fl_Output(1, 1, 224, 40);
		  alertMessage->type(4);
		  alertMessage->labelsize(MEKS_LABEL_SIZE);
		  alertMessage->textsize(MEKS_TEXT_SIZE);
		}
		{ alertButton = new Fl_Button(148, 43, 55, 25, "OK");
		  alertButton->labelsize(MEKS_LABEL_SIZE);
		  alertButton->callback((Fl_Callback*)cb_acceptAlertButton);
		}
		alertWindow->set_modal();
		alertWindow->end();
	}
	alertMessage->value(msg);
	alertWindow->show();
}

/********************************************************************************/
Fl_Window *AYSWindow=NULL;
Fl_Button *AYSButton[2]={NULL,NULL};
Fl_Output *AYSMessage=NULL;

// static void cb_acceptAYSButton(Fl_Button*, void*) {
//   AYSreturn = 1;			// Yes
//   AYSWindow->hide();
// }
// static void cb_cancelAYSButton(Fl_Button*, void*) {
//   AYSreturn = -1;			// No
//   AYSWindow->hide();
// }

/********************************************************************************/
char doAreYouSure(char *msg) {
int AYSreturn = -1;			// Assume No

if (debug == 1) printf("dSA: %s\n", msg);
	if (AYSWindow == NULL) {
		AYSWindow = new Fl_Window(228, 70, "MEKS: Are You Sure ??");
		AYSWindow->labelsize(MEKS_LABEL_SIZE);
		{ AYSMessage = new Fl_Output(1, 1, 224, 40);
		  AYSMessage->type(4);
		  AYSMessage->labelsize(MEKS_LABEL_SIZE);
		  AYSMessage->textsize(MEKS_TEXT_SIZE);
		}
		{ AYSButton[0] = new Fl_Button(70, 43, 55, 25, "Yes");
		  AYSButton[0]->labelsize(MEKS_LABEL_SIZE);
//		  AYSButton[0]->callback((Fl_Callback*)cb_acceptAYSButton);
		}
		{ AYSButton[1] = new Fl_Button(148, 43, 55, 25, "No");
		  AYSButton[1]->labelsize(MEKS_LABEL_SIZE);
//		  AYSButton[1]->callback((Fl_Callback*)cb_cancelAYSButton);
		}
		AYSWindow->end();
	}
	AYSWindow->set_modal();
	AYSMessage->value(msg);
	AYSWindow->show();
	for (;;) {
		Fl_Widget *o = Fl::readqueue();
		if (!o) {
			Fl::wait();
		} else if ( o == AYSButton[0]) {
			AYSreturn = 1;
			break;
		} else if ( o == AYSButton[1]) {
			AYSreturn = -1;
			break;
		}
	}
	AYSWindow->hide();
	return AYSreturn;
}

/********************************************************************************/
void setTimeOnTitle() {
	if (time(&t) != -1) {
		tp = localtime(&t);
		sprintf(mybuf, "MEKS: ME Kombat System (%2.2d:%2.2d)", tp->tm_hour, tp->tm_min);
if (debug == 1) printf("sTOT: %s\n", mybuf);
		MeksWindow->label(mybuf);
	}
}

// ********************************************************
void do_meks_logline_edit() {
	i = meksLogText->value();
if (debug == 1) printf("llE: %d\n", i);
	if (strlen(meksLogInput->value()) == 0) {
		meksLogInput->value(meksLogText->text(i));
	}
}

// ********************************************************
void do_meks_upd_log() {
	i = meksLogText->value();
	meksLogText->text(i, meksLogInput->value());
	meksLogInput->value("");
}

// ********************************************************
int meks_special_copy_dup() {
	i = meksSpecCopyList->value();
if (debug == 1) printf("mSCD: %d\n", i);
	if (i == 0) {
		return 0;
	}
	for (j=10; j<(10+MAX_MONSTERS); j++) {
		if (party[j].Name[0] == '-' && party[j].Name[1] == '-') {
			memcpy(party[j].Name, party[i+9].Name, sizeof(players));
			strncpy(mybuf2, meksSpecCopyStart->value(), 1);
			mybuf2[1] = '\0';
			if (party[j].Name[2] == '-') {
				sprintf(mybuf, "%c - %s %d", mybuf2[0], &party[j].Name[4], j-10);
				strncpy(party[j].Name, mybuf, 20);
			} else {
				sprintf(mybuf, "%c - %s %d", mybuf2[0], party[j].Name, j-10);
				strncpy(party[j].Name, mybuf, 20);
			}
			mybuf2[0]++;
			party[j].HitsCur = party[j].HitsMax;
			party[j].Wounds[0] = '\0';
			party[j].batlxp[0] = '\0';
			party[j].Bleed = party[j].Stun = party[j].ActPenalty = 0;
			party[j].Parry = party[j].NoParry = party[j].Inactive = 0;
			party[j].Death = party[j].xp = party[j].ActionCount = 0;
			party[j].AttackCount = party[j].ParryVal = 0;
			meksSpecCopyStart->value(mybuf2);
			party[j].Name[20] = '\0';
			meksSpecCopyList->add(party[j].Name);
			reloadAllNames();
			meksSpecCopyList->clear();
			for (i=10;i<(10+MAX_MONSTERS);i++) 
				meksSpecCopyList->add(party[i].Name);
			return 0;
		}
	}
}

// ********************************************************
int meks_special_copy_del() {
	j = meksSpecCopyList->value();
if (debug == 1) printf("mSCM: %d\n", j);
	if (j == 0) {
		return 0;
	}
	memset(party[j+9].Name, '\0', sizeof(players));
	sprintf(mybuf, "--Monst Slot %d", j-1);
	strcpy(party[j+9].Name, mybuf);
	reloadAllNames();
	meksSpecCopyList->clear();
		for (i=10;i<(10+MAX_MONSTERS);i++) 
			meksSpecCopyList->add(party[i].Name);
}

// ********************************************************
int meks_init_reload() {
	j=0;
	memset(meksInitKey, -1, 20);
	for (i=0; i<(10+MAX_MONSTERS); i++) {
		if (party[i].HitsMax > 0 && party[i].Inactive == 0) {
			meksInitNames[j]->value(party[i].Name);
			meksInitKey[j] = i;
			switch(meksSystemInitiative->value()) {
				case 0:		// Std MERP
						sprintf(mybuf, "%d", party[i].MMBase);
						meksInitValues[j][0]->value(mybuf);
						meksInitValues[j][1]->value(mybuf);
						meksInitValues[j][2]->value(mybuf);
						break;
				case 1:	if (i > 9 || MEKSconfig.roll_all == 1) {
//								k = (party[i].MMBase + getModifiers(i, 'M') - party[i].ActPenalty)/5;
								k = (party[i].MMBase)/5;
								sprintf(mybuf, "%d", getRND(12) - k); meksInitValues[j][0]->value(mybuf);
								sprintf(mybuf, "%d", getRND(8) - k); meksInitValues[j][1]->value(mybuf);
								sprintf(mybuf, "%d", getRND(6) - k); meksInitValues[j][2]->value(mybuf);
							}
						break;
				case 2:	if (i > 9 || MEKSconfig.roll_all == 1) {
//								k = (party[i].MMBase + getModifiers(i, 'M') - party[i].ActPenalty)/5;
								k = (party[i].MMBase)/5;
								sprintf(mybuf, "%d", getRND(10) - k); meksInitValues[j][0]->value(mybuf);
								sprintf(mybuf, "%d", getRND(6) - k); meksInitValues[j][1]->value(mybuf);
								sprintf(mybuf, "%d", getRND(4) - k); meksInitValues[j][2]->value(mybuf);
							}
						break;
			}
			j++;
		}
	}
	return 0;
}

// ********************************************************
int meks_init_clear() {
	memset(meksInitKey, -1, 20);
	for (i=0; i<(10+MAX_MONSTERS); i++) {
		meksInitNames[i]->value("");
		meksInitValues[i][0]->value("");
		meksInitValues[i][1]->value("");
		meksInitValues[i][2]->value("");
		meksInitList->clear();
	}
	return 0;
}

// ********************************************************
int meks_init_calc() {
	meksInitList->clear();
	memset(mybuf2, -1, 400);
	for (i=0; i<(10+MAX_MONSTERS); i++) {
		j = 0;
		l = meksInitKey[i];
		if (l > -1) {
			switch(meksSystemInitiative->value()) {
				case 0:	if (strlen(meksInitNames[i]->value()) > 0 && party[l].Name[0] != '-') {
								k = (getModifiers(l, 'M') - party[l].ActPenalty)/5;
								if (meksInitActions[i][1]->value() == 1) {			// move,missile
									k = 25 - (k + atoi(meksInitValues[i][1]->value()) / 3);
									l = 150;
								} else if (meksInitActions[i][2]->value() == 1) {	// spells
									k = 25 - (k + atoi(meksInitValues[i][2]->value()) / 3);
									l = 50;
								} else {
									k = 25 - (k + atoi(meksInitValues[i][0]->value()) / 3);		// melee
									l = 250;
								}
								j = 1;
							}
							k += l;
						break;
				case 1:
				case 2:	if (strlen(meksInitNames[i]->value()) > 0 && party[l].Name[0] != '-') {
								k = (getModifiers(l, 'M') - party[l].ActPenalty)/5;
								if (meksInitActions[i][1]->value() == 1) {			// move,missile
									k = atoi(meksInitValues[i][1]->value()) - k;
								} else if (meksInitActions[i][2]->value() == 1) {	// spells
									k = atoi(meksInitValues[i][2]->value()) - k;
								} else {
									k = atoi(meksInitValues[i][0]->value()) - k;		// melee
								}
								j = 1;
							}
							k = (k * 15) + 150;
						break;
			}
		}
		if (j == 1) {
if (debug == 1) { printf("mIC: %d = %d:%d\n", meksInitKey[i], i, k); }
			k = (k>400)?380:k;
			k = (k<0)?10:k;
			if (mybuf2[k] == -1) {
				mybuf2[k] = meksInitKey[i];
			} else {
				for (j=1; j<10; j++) {
					if (mybuf2[k+j] == -1) {
						mybuf2[k+j] = meksInitKey[i];
						break;
					}
				}
			}
		}
	}
	for (i=0; i<400; i++) {
		if (mybuf2[i] != -1) {
			j = mybuf2[i];
			if (party[j].Inactive == 0 && party[j].HitsCur > 0) {
				meksInitList->add(party[j].Name);
			}
		}
	}
	return 0;
}

// ********************************************************
void doSaveAsIniFile() {

if (debug == 1) printf("doSaveAsIniFile\n");
//	Fl_Preferences mainPrefs(Fl_Preferences::USER, MEKSconfig.pty_fn, "ini");
//	for (i=0; i<10; i++) {
//		if (party[i].Name[0] != '-' && party[i].HitsMax != 0) {
//if (debug == 1) printf("doSaveAsIniFile: %s\n", party[i].Name);
//			sprintf(mybuf, "Player-%d", i);
//			Fl_Preferences playerPrefs(mainPrefs, mybuf);
//			playerPrefs.set("Name", party[i].Name);
//			playerPrefs.set("Level", party[i].Level);
//			playerPrefs.set("HitsMax", party[i].HitsMax);
//			playerPrefs.set("HitsCur", party[i].HitsCur);
//			playerPrefs.set("NoAttks", party[i].NoAttks);
//			playerPrefs.set("Bleed", party[i].Bleed);
//			playerPrefs.set("Wounds", party[i].Wounds);
//			playerPrefs.set("Stun", party[i].Stun);
//			playerPrefs.set("ActPenalty", party[i].ActPenalty);
//			playerPrefs.set("Parry", party[i].Parry);
//			playerPrefs.set("NoParry", party[i].NoParry);
//			playerPrefs.set("Inactive", party[i].Inactive);
//			playerPrefs.set("Death", party[i].Death);
//			playerPrefs.set("DBBase", party[i].DBBase);
//			playerPrefs.set("SpellBase", party[i].SpellBase);
//			playerPrefs.set("DBShield", party[i].DBShield);
//			playerPrefs.set("SpellDirAttacks", party[i].SpellDirAttacks);
//			playerPrefs.set("MMBase", party[i].MMBase);
//			playerPrefs.set("AGQU", party[i].AGQU);
//			playerPrefs.set("Armor", party[i].Armor);
//			playerPrefs.set("CON", party[i].CON);
//			playerPrefs.set("Size", party[i].Size);
//			playerPrefs.set("DBLeg", party[i].DBLeg);
//			playerPrefs.set("DBArm", party[i].DBArm);
//			playerPrefs.set("DBHelm", party[i].DBHelm);
//			playerPrefs.set("IgnoreAtk", party[i].IgnoreAtk);
//			playerPrefs.set("CritAdj", party[i].CritAdj);
//			playerPrefs.set("RRPoison", party[i].RRPoison);
//			playerPrefs.set("RRChannel", party[i].RRChannel);
//			playerPrefs.set("RRMentalism", party[i].RRMentalism);
//			playerPrefs.set("RREssence", party[i].RREssence);
//			playerPrefs.set("RRDisease", party[i].RRDisease);
//			playerPrefs.set("Realm", party[i].Realm);
//			playerPrefs.set("OBCur", party[i].OBCur);
//			playerPrefs.set("OBAdd", party[i].OBAdd);
//			playerPrefs.set("DBSpecial", party[i].DBSpecial);
//			playerPrefs.set("MaMCur", party[i].MaMCur);
//			playerPrefs.setArray("TempPenalties", &party[i].TempPenalties[0][0], sizeof(party[i].TempPenalties));
//			playerPrefs.set("NoDefd", party[i].NoDefd);
//			playerPrefs.set("perc", party[i].perc);
//			playerPrefs.set("track", party[i].track);
//			playerPrefs.set("u_item", party[i].u_item);
//			playerPrefs.set("r_rune", party[i].r_rune);
//			playerPrefs.set("p_lock", party[i].p_lock);
//			playerPrefs.set("d_trap", party[i].d_trap);
//			playerPrefs.set("influ", party[i].influ);
//			playerPrefs.set("stalk", party[i].stalk);
//			playerPrefs.setArray("batlxp", (char *)&party[i].batlxp[0], 80);
//			playerPrefs.set("xp", party[i].xp);
//			playerPrefs.setArray("action", (char *)&party[i].action[0],9);
//			playerPrefs.set("NoActions", party[i].NoActions);
//			playerPrefs.set("CurAction", party[i].CurAction);
//			playerPrefs.set("DoingOppAction", party[i].DoingOppAction);
//			playerPrefs.set("SpellCharge", party[i].SpellCharge);
//			playerPrefs.set("MissileLoad", party[i].MissileLoad);
//			playerPrefs.set("CurWeapon", party[i].CurWeapon);
//			playerPrefs.set("DelayAttk", party[i].DelayAttk);
//			playerPrefs.set("AttackCount", party[i].AttackCount);
//			playerPrefs.set("ActionCount", party[i].ActionCount);
//			playerPrefs.set("ParryVal", party[i].ParryVal);
//			
//			playerPrefs.set("0_wp_dsc", party[i].weap[0].wp_dsc);
//			playerPrefs.set("0_wp_tbl", party[i].weap[0].wp_tbl);
//			playerPrefs.set("0_wp_sel", party[i].weap[0].wp_sel);
//			playerPrefs.set("0_wp_ob", party[i].weap[0].wp_ob);
//			playerPrefs.set("0_wp_ca", party[i].weap[0].wp_ca);
//			playerPrefs.set("0_wp_sz", party[i].weap[0].wp_sz);
//			playerPrefs.set("0_wp_ma", party[i].weap[0].wp_ma);
//			playerPrefs.set("0_wp_fm", party[i].weap[0].wp_fm);
//			playerPrefs.set("0_wp_br", party[i].weap[0].wp_br);
//			playerPrefs.set("0_wp_bf", party[i].weap[0].wp_bf);
//			playerPrefs.set("0_wp_str", party[i].weap[0].wp_str);
//			playerPrefs.set("0_wp_pc", party[i].weap[0].wp_pc);
//			playerPrefs.set("0_wp_sc", party[i].weap[0].wp_sc);
//			playerPrefs.set("0_wp_sm", party[i].weap[0].wp_sm);
//
//			playerPrefs.set("1_wp_dsc", party[i].weap[1].wp_dsc);
//			playerPrefs.set("1_wp_tbl", party[i].weap[1].wp_tbl);
//			playerPrefs.set("1_wp_sel", party[i].weap[1].wp_sel);
//			playerPrefs.set("1_wp_ob", party[i].weap[1].wp_ob);
//			playerPrefs.set("1_wp_ca", party[i].weap[1].wp_ca);
//			playerPrefs.set("1_wp_sz", party[i].weap[1].wp_sz);
//			playerPrefs.set("1_wp_ma", party[i].weap[1].wp_ma);
//			playerPrefs.set("1_wp_fm", party[i].weap[1].wp_fm);
//			playerPrefs.set("1_wp_br", party[i].weap[1].wp_br);
//			playerPrefs.set("1_wp_bf", party[i].weap[1].wp_bf);
//			playerPrefs.set("1_wp_str", party[i].weap[1].wp_str);
//			playerPrefs.set("1_wp_pc", party[i].weap[1].wp_pc);
//			playerPrefs.set("1_wp_sc", party[i].weap[1].wp_sc);
//			playerPrefs.set("1_wp_sm", party[i].weap[1].wp_sm);
//
//			playerPrefs.set("2_wp_dsc", party[i].weap[2].wp_dsc);
//			playerPrefs.set("2_wp_tbl", party[i].weap[2].wp_tbl);
//			playerPrefs.set("2_wp_sel", party[i].weap[2].wp_sel);
//			playerPrefs.set("2_wp_ob", party[i].weap[2].wp_ob);
//			playerPrefs.set("2_wp_ca", party[i].weap[2].wp_ca);
//			playerPrefs.set("2_wp_sz", party[i].weap[2].wp_sz);
//			playerPrefs.set("2_wp_ma", party[i].weap[2].wp_ma);
//			playerPrefs.set("2_wp_fm", party[i].weap[2].wp_fm);
//			playerPrefs.set("2_wp_br", party[i].weap[2].wp_br);
//			playerPrefs.set("2_wp_bf", party[i].weap[2].wp_bf);
//			playerPrefs.set("2_wp_str", party[i].weap[2].wp_str);
//			playerPrefs.set("2_wp_pc", party[i].weap[2].wp_pc);
//			playerPrefs.set("2_wp_sc", party[i].weap[2].wp_sc);
//			playerPrefs.set("2_wp_sm", party[i].weap[2].wp_sm);
//
//			playerPrefs.set("3_wp_dsc", party[i].weap[3].wp_dsc);
//			playerPrefs.set("3_wp_tbl", party[i].weap[3].wp_tbl);
//			playerPrefs.set("3_wp_sel", party[i].weap[3].wp_sel);
//			playerPrefs.set("3_wp_ob", party[i].weap[3].wp_ob);
//			playerPrefs.set("3_wp_ca", party[i].weap[3].wp_ca);
//			playerPrefs.set("3_wp_sz", party[i].weap[3].wp_sz);
//			playerPrefs.set("3_wp_ma", party[i].weap[3].wp_ma);
//			playerPrefs.set("3_wp_fm", party[i].weap[3].wp_fm);
//			playerPrefs.set("3_wp_br", party[i].weap[3].wp_br);
//			playerPrefs.set("3_wp_bf", party[i].weap[3].wp_bf);
//			playerPrefs.set("3_wp_str", party[i].weap[3].wp_str);
//			playerPrefs.set("3_wp_pc", party[i].weap[3].wp_pc);
//			playerPrefs.set("3_wp_sc", party[i].weap[3].wp_sc);
//			playerPrefs.set("3_wp_sm", party[i].weap[3].wp_sm);
//
//			playerPrefs.set("4_wp_dsc", party[i].weap[4].wp_dsc);
//			playerPrefs.set("4_wp_tbl", party[i].weap[4].wp_tbl);
//			playerPrefs.set("4_wp_sel", party[i].weap[4].wp_sel);
//			playerPrefs.set("4_wp_ob", party[i].weap[4].wp_ob);
//			playerPrefs.set("4_wp_ca", party[i].weap[4].wp_ca);
//			playerPrefs.set("4_wp_sz", party[i].weap[4].wp_sz);
//			playerPrefs.set("4_wp_ma", party[i].weap[4].wp_ma);
//			playerPrefs.set("4_wp_fm", party[i].weap[4].wp_fm);
//			playerPrefs.set("4_wp_br", party[i].weap[4].wp_br);
//			playerPrefs.set("4_wp_bf", party[i].weap[4].wp_bf);
//			playerPrefs.set("4_wp_str", party[i].weap[4].wp_str);
//			playerPrefs.set("4_wp_pc", party[i].weap[4].wp_pc);
//			playerPrefs.set("4_wp_sc", party[i].weap[4].wp_sc);
//			playerPrefs.set("4_wp_sm", party[i].weap[4].wp_sm);
//
//			playerPrefs.set("5_wp_dsc", party[i].weap[5].wp_dsc);
//			playerPrefs.set("5_wp_tbl", party[i].weap[5].wp_tbl);
//			playerPrefs.set("5_wp_sel", party[i].weap[5].wp_sel);
//			playerPrefs.set("5_wp_ob", party[i].weap[5].wp_ob);
//			playerPrefs.set("5_wp_ca", party[i].weap[5].wp_ca);
//			playerPrefs.set("5_wp_sz", party[i].weap[5].wp_sz);
//			playerPrefs.set("5_wp_ma", party[i].weap[5].wp_ma);
//			playerPrefs.set("5_wp_fm", party[i].weap[5].wp_fm);
//			playerPrefs.set("5_wp_br", party[i].weap[5].wp_br);
//			playerPrefs.set("5_wp_bf", party[i].weap[5].wp_bf);
//			playerPrefs.set("5_wp_str", party[i].weap[5].wp_str);
//			playerPrefs.set("5_wp_pc", party[i].weap[5].wp_pc);
//			playerPrefs.set("5_wp_sc", party[i].weap[5].wp_sc);
//			playerPrefs.set("5_wp_sm", party[i].weap[5].wp_sm);
//		}
//	}
//	mainPrefs.flush();
//
//	Fl_Preferences monxPrefs(Fl_Preferences::USER, MEKSconfig.mon_fn, "ini");
//	for (i=10; i<(MAX_MONSTERS+10); i++) {
//		if (party[i].Name[0] != '-' && party[i].HitsMax != 0) {
//			sprintf(mybuf, "Monster-%d", i-10);
//			Fl_Preferences playerPrefs(monxPrefs, mybuf);
//			playerPrefs.set("Name", party[i].Name);
//			playerPrefs.set("Level", party[i].Level);
//			playerPrefs.set("HitsMax", party[i].HitsMax);
//			playerPrefs.set("HitsCur", party[i].HitsCur);
//			playerPrefs.set("NoAttks", party[i].NoAttks);
//			playerPrefs.set("Bleed", party[i].Bleed);
//			playerPrefs.set("Wounds", party[i].Wounds);
//			playerPrefs.set("Stun", party[i].Stun);
//			playerPrefs.set("ActPenalty", party[i].ActPenalty);
//			playerPrefs.set("Parry", party[i].Parry);
//			playerPrefs.set("NoParry", party[i].NoParry);
//			playerPrefs.set("Inactive", party[i].Inactive);
//			playerPrefs.set("Death", party[i].Death);
//			playerPrefs.set("DBBase", party[i].DBBase);
//			playerPrefs.set("SpellBase", party[i].SpellBase);
//			playerPrefs.set("DBShield", party[i].DBShield);
//			playerPrefs.set("SpellDirAttacks", party[i].SpellDirAttacks);
//			playerPrefs.set("MMBase", party[i].MMBase);
//			playerPrefs.set("AGQU", party[i].AGQU);
//			playerPrefs.set("Armor", party[i].Armor);
//			playerPrefs.set("CON", party[i].CON);
//			playerPrefs.set("Size", party[i].Size);
//			playerPrefs.set("DBLeg", party[i].DBLeg);
//			playerPrefs.set("DBArm", party[i].DBArm);
//			playerPrefs.set("DBHelm", party[i].DBHelm);
//			playerPrefs.set("IgnoreAtk", party[i].IgnoreAtk);
//			playerPrefs.set("CritAdj", party[i].CritAdj);
//			playerPrefs.set("RRPoison", party[i].RRPoison);
//			playerPrefs.set("RRChannel", party[i].RRChannel);
//			playerPrefs.set("RRMentalism", party[i].RRMentalism);
//			playerPrefs.set("RREssence", party[i].RREssence);
//			playerPrefs.set("RRDisease", party[i].RRDisease);
//			playerPrefs.set("Realm", party[i].Realm);
//			playerPrefs.set("OBCur", party[i].OBCur);
//			playerPrefs.set("OBAdd", party[i].OBAdd);
//			playerPrefs.set("DBSpecial", party[i].DBSpecial);
//			playerPrefs.set("MaMCur", party[i].MaMCur);
//			playerPrefs.setArray("TempPenalties", &party[i].TempPenalties[0][0], sizeof(party[i].TempPenalties));
//			playerPrefs.set("NoDefd", party[i].NoDefd);
//			playerPrefs.set("perc", party[i].perc);
//			playerPrefs.set("track", party[i].track);
//			playerPrefs.set("u_item", party[i].u_item);
//			playerPrefs.set("r_rune", party[i].r_rune);
//			playerPrefs.set("p_lock", party[i].p_lock);
//			playerPrefs.set("d_trap", party[i].d_trap);
//			playerPrefs.set("influ", party[i].influ);
//			playerPrefs.set("stalk", party[i].stalk);
//			playerPrefs.setArray("batlxp", (char *)&party[i].batlxp[0], 80);
//			playerPrefs.set("xp", party[i].xp);
//			playerPrefs.setArray("action", (char *)&party[i].action[0],9);
//			playerPrefs.set("NoActions", party[i].NoActions);
//			playerPrefs.set("CurAction", party[i].CurAction);
//			playerPrefs.set("DoingOppAction", party[i].DoingOppAction);
//			playerPrefs.set("SpellCharge", party[i].SpellCharge);
//			playerPrefs.set("MissileLoad", party[i].MissileLoad);
//			playerPrefs.set("CurWeapon", party[i].CurWeapon);
//			playerPrefs.set("DelayAttk", party[i].DelayAttk);
//			playerPrefs.set("AttackCount", party[i].AttackCount);
//			playerPrefs.set("ActionCount", party[i].ActionCount);
//			playerPrefs.set("ParryVal", party[i].ParryVal);
//			
//			playerPrefs.set("0_wp_dsc", party[i].weap[0].wp_dsc);
//			playerPrefs.set("0_wp_tbl", party[i].weap[0].wp_tbl);
//			playerPrefs.set("0_wp_sel", party[i].weap[0].wp_sel);
//			playerPrefs.set("0_wp_ob", party[i].weap[0].wp_ob);
//			playerPrefs.set("0_wp_ca", party[i].weap[0].wp_ca);
//			playerPrefs.set("0_wp_sz", party[i].weap[0].wp_sz);
//			playerPrefs.set("0_wp_ma", party[i].weap[0].wp_ma);
//			playerPrefs.set("0_wp_fm", party[i].weap[0].wp_fm);
//			playerPrefs.set("0_wp_br", party[i].weap[0].wp_br);
//			playerPrefs.set("0_wp_bf", party[i].weap[0].wp_bf);
//			playerPrefs.set("0_wp_str", party[i].weap[0].wp_str);
//			playerPrefs.set("0_wp_pc", party[i].weap[0].wp_pc);
//			playerPrefs.set("0_wp_sc", party[i].weap[0].wp_sc);
//			playerPrefs.set("0_wp_sm", party[i].weap[0].wp_sm);
//
//			playerPrefs.set("1_wp_dsc", party[i].weap[1].wp_dsc);
//			playerPrefs.set("1_wp_tbl", party[i].weap[1].wp_tbl);
//			playerPrefs.set("1_wp_sel", party[i].weap[1].wp_sel);
//			playerPrefs.set("1_wp_ob", party[i].weap[1].wp_ob);
//			playerPrefs.set("1_wp_ca", party[i].weap[1].wp_ca);
//			playerPrefs.set("1_wp_sz", party[i].weap[1].wp_sz);
//			playerPrefs.set("1_wp_ma", party[i].weap[1].wp_ma);
//			playerPrefs.set("1_wp_fm", party[i].weap[1].wp_fm);
//			playerPrefs.set("1_wp_br", party[i].weap[1].wp_br);
//			playerPrefs.set("1_wp_bf", party[i].weap[1].wp_bf);
//			playerPrefs.set("1_wp_str", party[i].weap[1].wp_str);
//			playerPrefs.set("1_wp_pc", party[i].weap[1].wp_pc);
//			playerPrefs.set("1_wp_sc", party[i].weap[1].wp_sc);
//			playerPrefs.set("1_wp_sm", party[i].weap[1].wp_sm);
//
//			playerPrefs.set("2_wp_dsc", party[i].weap[2].wp_dsc);
//			playerPrefs.set("2_wp_tbl", party[i].weap[2].wp_tbl);
//			playerPrefs.set("2_wp_sel", party[i].weap[2].wp_sel);
//			playerPrefs.set("2_wp_ob", party[i].weap[2].wp_ob);
//			playerPrefs.set("2_wp_ca", party[i].weap[2].wp_ca);
//			playerPrefs.set("2_wp_sz", party[i].weap[2].wp_sz);
//			playerPrefs.set("2_wp_ma", party[i].weap[2].wp_ma);
//			playerPrefs.set("2_wp_fm", party[i].weap[2].wp_fm);
//			playerPrefs.set("2_wp_br", party[i].weap[2].wp_br);
//			playerPrefs.set("2_wp_bf", party[i].weap[2].wp_bf);
//			playerPrefs.set("2_wp_str", party[i].weap[2].wp_str);
//			playerPrefs.set("2_wp_pc", party[i].weap[2].wp_pc);
//			playerPrefs.set("2_wp_sc", party[i].weap[2].wp_sc);
//			playerPrefs.set("2_wp_sm", party[i].weap[2].wp_sm);
//
//			playerPrefs.set("3_wp_dsc", party[i].weap[3].wp_dsc);
//			playerPrefs.set("3_wp_tbl", party[i].weap[3].wp_tbl);
//			playerPrefs.set("3_wp_sel", party[i].weap[3].wp_sel);
//			playerPrefs.set("3_wp_ob", party[i].weap[3].wp_ob);
//			playerPrefs.set("3_wp_ca", party[i].weap[3].wp_ca);
//			playerPrefs.set("3_wp_sz", party[i].weap[3].wp_sz);
//			playerPrefs.set("3_wp_ma", party[i].weap[3].wp_ma);
//			playerPrefs.set("3_wp_fm", party[i].weap[3].wp_fm);
//			playerPrefs.set("3_wp_br", party[i].weap[3].wp_br);
//			playerPrefs.set("3_wp_bf", party[i].weap[3].wp_bf);
//			playerPrefs.set("3_wp_str", party[i].weap[3].wp_str);
//			playerPrefs.set("3_wp_pc", party[i].weap[3].wp_pc);
//			playerPrefs.set("3_wp_sc", party[i].weap[3].wp_sc);
//			playerPrefs.set("3_wp_sm", party[i].weap[3].wp_sm);
//
//			playerPrefs.set("4_wp_dsc", party[i].weap[4].wp_dsc);
//			playerPrefs.set("4_wp_tbl", party[i].weap[4].wp_tbl);
//			playerPrefs.set("4_wp_sel", party[i].weap[4].wp_sel);
//			playerPrefs.set("4_wp_ob", party[i].weap[4].wp_ob);
//			playerPrefs.set("4_wp_ca", party[i].weap[4].wp_ca);
//			playerPrefs.set("4_wp_sz", party[i].weap[4].wp_sz);
//			playerPrefs.set("4_wp_ma", party[i].weap[4].wp_ma);
//			playerPrefs.set("4_wp_fm", party[i].weap[4].wp_fm);
//			playerPrefs.set("4_wp_br", party[i].weap[4].wp_br);
//			playerPrefs.set("4_wp_bf", party[i].weap[4].wp_bf);
//			playerPrefs.set("4_wp_str", party[i].weap[4].wp_str);
//			playerPrefs.set("4_wp_pc", party[i].weap[4].wp_pc);
//			playerPrefs.set("4_wp_sc", party[i].weap[4].wp_sc);
//			playerPrefs.set("4_wp_sm", party[i].weap[4].wp_sm);
//
//			playerPrefs.set("5_wp_dsc", party[i].weap[5].wp_dsc);
//			playerPrefs.set("5_wp_tbl", party[i].weap[5].wp_tbl);
//			playerPrefs.set("5_wp_sel", party[i].weap[5].wp_sel);
//			playerPrefs.set("5_wp_ob", party[i].weap[5].wp_ob);
//			playerPrefs.set("5_wp_ca", party[i].weap[5].wp_ca);
//			playerPrefs.set("5_wp_sz", party[i].weap[5].wp_sz);
//			playerPrefs.set("5_wp_ma", party[i].weap[5].wp_ma);
//			playerPrefs.set("5_wp_fm", party[i].weap[5].wp_fm);
//			playerPrefs.set("5_wp_br", party[i].weap[5].wp_br);
//			playerPrefs.set("5_wp_bf", party[i].weap[5].wp_bf);
//			playerPrefs.set("5_wp_str", party[i].weap[5].wp_str);
//			playerPrefs.set("5_wp_pc", party[i].weap[5].wp_pc);
//			playerPrefs.set("5_wp_sc", party[i].weap[5].wp_sc);
//			playerPrefs.set("5_wp_sm", party[i].weap[5].wp_sm);
//		}
//	}
//	monxPrefs.flush();
}


// ********************************************************
void doReadAsIniFile() {

//	Fl_Preferences mainPrefs(Fl_Preferences::USER, MEKSconfig.pty_fn, "ini");
//	for (i=0; i<10; i++) {
//		sprintf(mybuf, "./Player-%d", i);
//		if (mainPrefs.groupExists(mybuf) != 0) {
//			sprintf(mybuf, "Player-%d", i);
//			Fl_Preferences playerPrefs(mainPrefs, mybuf);
//			playerPrefs.get("Name", party[i].Name,"",21);
//if (debug == 1) printf("doReadAsIniFile: %s\n", party[i].Name);
//			playerPrefs.get("Level", party[i].Level,0);
//			playerPrefs.get("HitsMax", party[i].HitsMax,0);
//			playerPrefs.get("HitsCur", party[i].HitsCur,0);
//			playerPrefs.get("NoAttks", party[i].NoAttks,0);
//			playerPrefs.get("Bleed", party[i].Bleed,0);
//			playerPrefs.get("Wounds", party[i].Wounds,"",21);
//			playerPrefs.get("Stun", party[i].Stun,0);
//			playerPrefs.get("ActPenalty", party[i].ActPenalty,0);
//			playerPrefs.get("Parry", party[i].Parry,0);
//			playerPrefs.get("NoParry", party[i].NoParry,0);
//			playerPrefs.get("Inactive", party[i].Inactive,0);
//			playerPrefs.get("Death", party[i].Death,0);
//			playerPrefs.get("DBBase", party[i].DBBase,0);
//			playerPrefs.get("SpellBase", party[i].SpellBase,0);
//			playerPrefs.get("DBShield", party[i].DBShield,0);
//			playerPrefs.get("SpellDirAttacks", party[i].SpellDirAttacks,0);
//			playerPrefs.get("MMBase", party[i].MMBase,0);
//			playerPrefs.get("AGQU", party[i].AGQU,0);
//			playerPrefs.get("Armor", party[i].Armor,0);
//			playerPrefs.get("CON", party[i].CON,0);
//			playerPrefs.get("Size", party[i].Size,0);
//			playerPrefs.get("DBLeg", party[i].DBLeg,0);
//			playerPrefs.get("DBArm", party[i].DBArm,0);
//			playerPrefs.get("DBHelm", party[i].DBHelm,0);
//			playerPrefs.get("IgnoreAtk", party[i].IgnoreAtk,0);
//			playerPrefs.get("CritAdj", party[i].CritAdj,0);
//			playerPrefs.get("RRPoison", party[i].RRPoison,0);
//			playerPrefs.get("RRChannel", party[i].RRChannel,0);
//			playerPrefs.get("RRMentalism", party[i].RRMentalism,0);
//			playerPrefs.get("RREssence", party[i].RREssence,0);
//			playerPrefs.get("RRDisease", party[i].RRDisease,0);
//			playerPrefs.get("Realm", party[i].Realm,0);
//			playerPrefs.get("OBCur", party[i].OBCur,0);
//			playerPrefs.get("OBAdd", party[i].OBAdd,0);
//			playerPrefs.get("DBSpecial", party[i].DBSpecial,0);
//			playerPrefs.get("MaMCur", party[i].MaMCur,0);
//			playerPrefs.getArray("TempPenalties", &party[i].TempPenalties[0][0], sizeof(party[i].TempPenalties));
//			playerPrefs.get("NoDefd", party[i].NoDefd,0);
//			playerPrefs.get("perc", party[i].perc,0);
//			playerPrefs.get("track", party[i].track,0);
//			playerPrefs.get("u_item", party[i].u_item,0);
//			playerPrefs.get("r_rune", party[i].r_rune,0);
//			playerPrefs.get("p_lock", party[i].p_lock,0);
//			playerPrefs.get("d_trap", party[i].d_trap,0);
//			playerPrefs.get("influ", party[i].influ,0);
//			playerPrefs.get("stalk", party[i].stalk,0);
//			playerPrefs.getArray("batlxp", (char *)&party[i].batlxp[0], 80);
//			playerPrefs.get("xp", party[i].xp,0);
//			playerPrefs.getArray("action", (char *)&party[i].action[0],9);
//			playerPrefs.get("NoActions", j,0); party[i].NoActions=j;
//			playerPrefs.get("CurAction", party[i].CurAction,0);
//			playerPrefs.get("DoingOppAction", party[i].DoingOppAction,0);
//			playerPrefs.get("SpellCharge", party[i].SpellCharge,0);
//			playerPrefs.get("MissileLoad", party[i].MissileLoad,0);
//			playerPrefs.get("CurWeapon", party[i].CurWeapon,0);
//			playerPrefs.get("DelayAttk", party[i].DelayAttk,0);
//			playerPrefs.get("AttackCount", j,0); party[i].AttackCount=j;
//			playerPrefs.get("ActionCount", j,0); party[i].ActionCount=j;
//			playerPrefs.get("ParryVal", j,0); party[i].ParryVal=j;
//			
//			playerPrefs.get("0_wp_dsc", party[i].weap[0].wp_dsc,"",15);
//			playerPrefs.get("0_wp_tbl", party[i].weap[0].wp_tbl,"",4);
//			playerPrefs.get("0_wp_sel", j,0); party[i].weap[0].wp_sel = j;
//			playerPrefs.get("0_wp_ob", party[i].weap[0].wp_ob,0);
//			playerPrefs.get("0_wp_ca", party[i].weap[0].wp_ca,0);
//			playerPrefs.get("0_wp_sz", party[i].weap[0].wp_sz,"",1);
//			playerPrefs.get("0_wp_ma", party[i].weap[0].wp_ma,0);
//			playerPrefs.get("0_wp_fm", party[i].weap[0].wp_fm,0);
//			playerPrefs.get("0_wp_br", party[i].weap[0].wp_br,0);
//			playerPrefs.get("0_wp_bf", party[i].weap[0].wp_bf,0);
//			playerPrefs.get("0_wp_str", party[i].weap[0].wp_str,0);
//			playerPrefs.get("0_wp_pc", party[i].weap[0].wp_pc,"",2);
//			playerPrefs.get("0_wp_sc", party[i].weap[0].wp_sc,"",2);
//			playerPrefs.get("0_wp_sm", party[i].weap[0].wp_sm,"",29);
//
//			playerPrefs.get("1_wp_dsc", party[i].weap[1].wp_dsc,"",15);
//			playerPrefs.get("1_wp_tbl", party[i].weap[1].wp_tbl,"",4);
//			playerPrefs.get("1_wp_sel", j,0); party[i].weap[1].wp_sel = j;
//			playerPrefs.get("1_wp_ob", party[i].weap[1].wp_ob,0);
//			playerPrefs.get("1_wp_ca", party[i].weap[1].wp_ca,0);
//			playerPrefs.get("1_wp_sz", party[i].weap[1].wp_sz,"",1);
//			playerPrefs.get("1_wp_ma", party[i].weap[1].wp_ma,0);
//			playerPrefs.get("1_wp_fm", party[i].weap[1].wp_fm,0);
//			playerPrefs.get("1_wp_br", party[i].weap[1].wp_br,0);
//			playerPrefs.get("1_wp_bf", party[i].weap[1].wp_bf,0);
//			playerPrefs.get("1_wp_str", party[i].weap[1].wp_str,0);
//			playerPrefs.get("1_wp_pc", party[i].weap[1].wp_pc,"",2);
//			playerPrefs.get("1_wp_sc", party[i].weap[1].wp_sc,"",2);
//			playerPrefs.get("1_wp_sm", party[i].weap[1].wp_sm,"",29);
//
//			playerPrefs.get("2_wp_dsc", party[i].weap[2].wp_dsc,"",15);
//			playerPrefs.get("2_wp_tbl", party[i].weap[2].wp_tbl,"",4);
//			playerPrefs.get("2_wp_sel", j,0); party[i].weap[2].wp_sel = j;
//			playerPrefs.get("2_wp_ob", party[i].weap[2].wp_ob,0);
//			playerPrefs.get("2_wp_ca", party[i].weap[2].wp_ca,0);
//			playerPrefs.get("2_wp_sz", party[i].weap[2].wp_sz,"",1);
//			playerPrefs.get("2_wp_ma", party[i].weap[2].wp_ma,0);
//			playerPrefs.get("2_wp_fm", party[i].weap[2].wp_fm,0);
//			playerPrefs.get("2_wp_br", party[i].weap[2].wp_br,0);
//			playerPrefs.get("2_wp_bf", party[i].weap[2].wp_bf,0);
//			playerPrefs.get("2_wp_str", party[i].weap[2].wp_str,0);
//			playerPrefs.get("2_wp_pc", party[i].weap[2].wp_pc,"",2);
//			playerPrefs.get("2_wp_sc", party[i].weap[2].wp_sc,"",2);
//			playerPrefs.get("2_wp_sm", party[i].weap[2].wp_sm,"",29);
//
//			playerPrefs.get("3_wp_dsc", party[i].weap[3].wp_dsc,"",15);
//			playerPrefs.get("3_wp_tbl", party[i].weap[3].wp_tbl,"",4);
//			playerPrefs.get("3_wp_sel", j,0); party[i].weap[3].wp_sel = j;
//			playerPrefs.get("3_wp_ob", party[i].weap[3].wp_ob,0);
//			playerPrefs.get("3_wp_ca", party[i].weap[3].wp_ca,0);
//			playerPrefs.get("3_wp_sz", party[i].weap[3].wp_sz,"",1);
//			playerPrefs.get("3_wp_ma", party[i].weap[3].wp_ma,0);
//			playerPrefs.get("3_wp_fm", party[i].weap[3].wp_fm,0);
//			playerPrefs.get("3_wp_br", party[i].weap[3].wp_br,0);
//			playerPrefs.get("3_wp_bf", party[i].weap[3].wp_bf,0);
//			playerPrefs.get("3_wp_str", party[i].weap[3].wp_str,0);
//			playerPrefs.get("3_wp_pc", party[i].weap[3].wp_pc,"",2);
//			playerPrefs.get("3_wp_sc", party[i].weap[3].wp_sc,"",2);
//			playerPrefs.get("3_wp_sm", party[i].weap[3].wp_sm,"",29);
//
//			playerPrefs.get("4_wp_dsc", party[i].weap[4].wp_dsc,"",15);
//			playerPrefs.get("4_wp_tbl", party[i].weap[4].wp_tbl,"",4);
//			playerPrefs.get("4_wp_sel", j,0); party[i].weap[4].wp_sel = j;
//			playerPrefs.get("4_wp_ob", party[i].weap[4].wp_ob,0);
//			playerPrefs.get("4_wp_ca", party[i].weap[4].wp_ca,0);
//			playerPrefs.get("4_wp_sz", party[i].weap[4].wp_sz,"",1);
//			playerPrefs.get("4_wp_ma", party[i].weap[4].wp_ma,0);
//			playerPrefs.get("4_wp_fm", party[i].weap[4].wp_fm,0);
//			playerPrefs.get("4_wp_br", party[i].weap[4].wp_br,0);
//			playerPrefs.get("4_wp_bf", party[i].weap[4].wp_bf,0);
//			playerPrefs.get("4_wp_str", party[i].weap[4].wp_str,0);
//			playerPrefs.get("4_wp_pc", party[i].weap[4].wp_pc,"",2);
//			playerPrefs.get("4_wp_sc", party[i].weap[4].wp_sc,"",2);
//			playerPrefs.get("4_wp_sm", party[i].weap[4].wp_sm,"",29);
//
//			playerPrefs.get("5_wp_dsc", party[i].weap[5].wp_dsc,"",15);
//			playerPrefs.get("5_wp_tbl", party[i].weap[5].wp_tbl,"",4);
//			playerPrefs.get("5_wp_sel", j,0); party[i].weap[5].wp_sel = j;
//			playerPrefs.get("5_wp_ob", party[i].weap[5].wp_ob,0);
//			playerPrefs.get("5_wp_ca", party[i].weap[5].wp_ca,0);
//			playerPrefs.get("5_wp_sz", party[i].weap[5].wp_sz,"",1);
//			playerPrefs.get("5_wp_ma", party[i].weap[5].wp_ma,0);
//			playerPrefs.get("5_wp_fm", party[i].weap[5].wp_fm,0);
//			playerPrefs.get("5_wp_br", party[i].weap[5].wp_br,0);
//			playerPrefs.get("5_wp_bf", party[i].weap[5].wp_bf,0);
//			playerPrefs.get("5_wp_str", party[i].weap[5].wp_str,0);
//			playerPrefs.get("5_wp_pc", party[i].weap[5].wp_pc,"",2);
//			playerPrefs.get("5_wp_sc", party[i].weap[5].wp_sc,"",2);
//			playerPrefs.get("5_wp_sm", party[i].weap[5].wp_sm,"",29);
//		}
//	}
//	mainPrefs.flush();
}

// ********************************************************
void setTempPenalty(int plyr, int type, int val, int rnds) {
int i;

		// find a blank slot to use
	for (i=0; i<8; i++) {
		if (party[plyr].TempPenalties[i][0] == 0) {
			party[plyr].TempPenalties[i][0] = type;
			party[plyr].TempPenalties[i][1] = val;
			party[plyr].TempPenalties[i][2] = rnds;
if (debug == 1) printf("sTP: %d %d %d %d %d\n", plyr, i, type, val, rnds);
			return;
		}
	}
		// otherwise find a similar and inc rnds
	for (i=0; i<8; i++) {
		if (party[plyr].TempPenalties[i][0] == type && party[plyr].TempPenalties[i][1] == val) {
			party[plyr].TempPenalties[i][2] += rnds;
if (debug == 1) printf("sTP: %d %d %d %d %d\n", plyr, i, type, val, rnds);
			return;
		}
	}

	return;
}
