#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "MEKSinterp.h"
#include "MEKSextraa.h"

/*****************************************************************************/
typedef struct mbatlang {
int	cur_plyr;
int	cur_weap;
char	cur_armor;
int	cur_act;
int	prev_act;
char	has_helm;
char  has_leg;
char  has_arm;
char  has_shld;
} mbatlang;

typedef struct langtoken {
char    tkn[6];
int	cond;
int	val;
int	rnd;
int	type;
int	token;
} langtoken;

mbatlang langcnf[2];

langtoken ltoken[11+MAX_MONSTERS];

extern char debug;

/*****************************************************************************/
// void interpModifiers(char *, char, char);
char * do_nxttoken(char *, int);
void do_initplyr(int, int);
void do_getparams(int);
void do_lexaction(int, int);
void do_tokens();

extern int interpResults[9];
extern int tempPenalties[8][4];

/*****************************************************************************/
int getTokenType(int tok) {
	return ltoken[tok].token;
}

int getTokenValue(int tok) {
	return ltoken[tok].val;
}

int findTokenType(int tok) {
int i;

   for (i=0; ltoken[i].token != TOKEN_FIN && i < (10+MAX_MONSTERS); i++) {
if (debug == 1) printf("fTT: %d / %d (%d)\n", i, ltoken[i].token, tok);
		if (ltoken[i].token == tok) {
			return i;
		}
	}
	return -1;
}

/*****************************************************************************/
void interpModifiers(char *flex, char ca, char cd)
{
int i;

if (debug == 1) printf("iM: %s (%d:%d)\n", flex, ca, cd);

	memset(&ltoken[0].tkn[0], '\0', sizeof(ltoken));
	memset(interpResults, '\0', sizeof(interpResults));

	do_initplyr(ca, 0);
	do_initplyr(cd, 1);
	i=-1;
	while (ltoken[i].token != TOKEN_FIN && i<(10+MAX_MONSTERS))
	{
	   i++;
	   flex = do_nxttoken(flex, i);
	}
	do_tokens();
if (debug == 1) printf("\niM: %d:%d:%d:%d:%d:%d:%d:%d:%d\n", interpResults[0], interpResults[1], interpResults[2], interpResults[3], interpResults[4], interpResults[5], interpResults[6], interpResults[7], interpResults[8]);

	return;
}

/****************************************************************************/
void do_btmppen(int type, int val, int rnds, int plyr)
{
int i;

	for (i=0; i<8; i++)
		if (tempPenalties[i][0] == 0)
		{
			tempPenalties[i][0] = type;
			tempPenalties[i][1] = val;
			tempPenalties[i][2] = rnds;
			tempPenalties[i][3] = plyr;
			return;
		}
	for (i=0; i<8; i++)
		if (tempPenalties[i][0] == type && tempPenalties[i][1] == val && tempPenalties[i][3] == plyr)
		{		/* found similar one, so inc it's no. rnds */
			tempPenalties[i][2] += rnds;
			return;
		}
}

/*****************************************************************************/
char * do_nxttoken(char *line, int tkn)
{
int i=0, j;

	ltoken[tkn].tkn[0] = '\0';

	if (*line == ' ')
	   while (*line == ' ' && *line != '\0')
		line++;

	while (*line != ' ' && *line != '\0')
	{
	   ltoken[tkn].tkn[i++] = *line;
	   line++;
	}

	ltoken[tkn].tkn[i] = '\0';

	switch (ltoken[tkn].tkn[0])
	{
	   case '&': 		/*  AND */
		     ltoken[tkn].token = TOKEN_AND;
		     ltoken[tkn].type = TYP_JOIN;
		     ltoken[tkn].val = 0;
		     break;
	   case ':':		/*  range ie. A1:A10 */
		     ltoken[tkn].token = TOKEN_RGE;
		     ltoken[tkn].type = TYP_QUEST;
		     break;
	   case 'A': switch (ltoken[tkn].tkn[1])
		     {
			case 'A':	/*  arm armor */
		     		ltoken[tkn].token = TOKEN_AA;
				ltoken[tkn].type = TYP_QUEST;
				if (langcnf[1].has_arm != 'N')
				  ltoken[tkn].val = 1;
				break;
			case 'K':	/*  applies to person attacking */
		     		ltoken[tkn].token = TOKEN_AK;
				ltoken[tkn].type = TYP_ACT;
//				do_initplyr(MEKSconfig.cur_atk);
				break;
			case 'P':	/*  Activity Penalty */
		     		ltoken[tkn].token = TOKEN_AP;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
		     }
		     break;
	   case 'B': if (ltoken[tkn].tkn[1] == 'L')	/*  Bleed */
		     {
		     	ltoken[tkn].token = TOKEN_BL;
			ltoken[tkn].type = TYP_ACT;
			do_getparams(tkn);
		     }
		     break;
	   case 'C': switch (ltoken[tkn].tkn[1])
		     {
			case 'A':	/*  previous crit of attack was A */
		     		ltoken[tkn].token = TOKEN_CA;
				ltoken[tkn].type = TYP_QUEST;
				break;
			case 'B':	/*  previous crit of attack was B */
		     		ltoken[tkn].token = TOKEN_CB;
				ltoken[tkn].type = TYP_QUEST;
				break;
			case 'C':	/*  previous crit of attack was C */
		     		ltoken[tkn].token = TOKEN_CC;
				ltoken[tkn].type = TYP_QUEST;
				break;
			case 'D':	/*  previous crit of attack was D */
		     		ltoken[tkn].token = TOKEN_CD;
				ltoken[tkn].type = TYP_QUEST;
				break;
			case 'E':	/*  previous crit of attack was E */
		     		ltoken[tkn].token = TOKEN_CE;
				ltoken[tkn].type = TYP_QUEST;
				break;
			case 'H':	/*  Chain */
		     		ltoken[tkn].token = TOKEN_CH;
				ltoken[tkn].type = TYP_QUEST;
				if (party[langcnf[1].cur_plyr].Armor == 3)
				  ltoken[tkn].val = 1;
				break;
		     }
		     break;
	   case 'D': switch (ltoken[tkn].tkn[1])
		     {
			case 'A':	/*  delay attack until next rnd */
		     		ltoken[tkn].token = TOKEN_DA;
				ltoken[tkn].type = TYP_ACT;
				break;
			case 'D':	/*  Dead ie. DD 6 is death in 6 rnds */
		     		ltoken[tkn].token = TOKEN_DD;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
			case 'F':	/*  applies to person defending */
		     		ltoken[tkn].token = TOKEN_DF;
				ltoken[tkn].type = TYP_ACT;
//				do_initplyr(MEKSconfig.cur_def);
				break;
		     }
		     break;
	   case 'E': if (ltoken[tkn].tkn[1] == 'L')	/*  ELSE */
		     {
		     	ltoken[tkn].token = TOKEN_EL;
			ltoken[tkn].type = TYP_END;
			ltoken[tkn].val = 0;
		     }
		     break;
	   case 'H': switch (ltoken[tkn].tkn[1])
		     {
			case 'A':	/*  helm */
		     		ltoken[tkn].token = TOKEN_HA;
				ltoken[tkn].type = TYP_QUEST;
				if (langcnf[1].has_helm != 'N')
				  ltoken[tkn].val = 1;
				break;
			case 'T':	/*  Hits */
		     		ltoken[tkn].token = TOKEN_HT;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
		     }
		     break;
	   case 'I': switch (ltoken[tkn].tkn[1])
		     {
			case 'A':	/*  Inactive */
		     		ltoken[tkn].token = TOKEN_IA;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
			case 'F':	/*  IF */
		     		ltoken[tkn].token = TOKEN_IF;
				ltoken[tkn].type = TYP_QUEST;
				ltoken[tkn].val = 0;
				break;
			case 'N':	/*  IF NOT */
		     		ltoken[tkn].token = TOKEN_IN;
				ltoken[tkn].type = TYP_QUEST;
				ltoken[tkn].val = 0;
				break;
		     }
		     break;
	   case 'L': if (ltoken[tkn].tkn[1] == 'A')	/*  leg armor */
		     {
		     	ltoken[tkn].token = TOKEN_LA;
			ltoken[tkn].type = TYP_QUEST;
			if (langcnf[1].has_leg != 'N')
			  ltoken[tkn].val = 1;
		     }
		     break;
	   case 'M': switch (ltoken[tkn].tkn[1])
		     {
			case 'P':			/* must parry */
		     		ltoken[tkn].token = TOKEN_MP;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
		     }
		     break;
	   case 'N': switch (ltoken[tkn].tkn[1])
		     {
			case 'O':			/* no armor */
		     		ltoken[tkn].token = TOKEN_NO;
				ltoken[tkn].type = TYP_QUEST;
				if (&party[langcnf[1].cur_plyr].Armor == 0) 
				  ltoken[tkn].val = 1;
				break;
			case 'P':			/* no parry */
		     		ltoken[tkn].token = TOKEN_NP;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
		     }
		     break;
	   case 'O': switch (ltoken[tkn].tkn[1])
		     {
			case 'B':	/*  adjust OB */
		     		ltoken[tkn].token = TOKEN_OB;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
			case 'K':	/*  previous attack was successful */
		     		ltoken[tkn].token = TOKEN_OK;
				ltoken[tkn].type = TYP_QUEST;
				break;
		     }
		     break;
	   case 'P': switch (ltoken[tkn].tkn[1])
		     {
			case 'L':	/*  Plate */
		     		ltoken[tkn].token = TOKEN_PL;
				ltoken[tkn].type = TYP_QUEST;
				if (party[langcnf[1].cur_plyr].Armor == 4)
				  ltoken[tkn].val = 1;
				break;
			case 'C':	/*  Prim Crit */
		     		ltoken[tkn].token = TOKEN_PC;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
		     }
		     break;
	   case 'R': if (ltoken[tkn].tkn[1] == 'L')	/*  Rigid Lthr */
		     {
		     	ltoken[tkn].token = TOKEN_RL;
			ltoken[tkn].type = TYP_QUEST;
			if (party[langcnf[1].cur_plyr].Armor == 2)
			  ltoken[tkn].val = 1;
		     }
		     break;
	   case 'S': switch (ltoken[tkn].tkn[1])
		     {
			case 'C':	/*  Secondary Crit */
		     		ltoken[tkn].token = TOKEN_SC;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
			case 'D':	/*  Shield */
		     		ltoken[tkn].token = TOKEN_SD;
				ltoken[tkn].type = TYP_QUEST;
				if (langcnf[1].has_shld != 'N')
				  ltoken[tkn].val = 1;
				break;
			case 'L':	/*  Soft Lthr */
		     		ltoken[tkn].token = TOKEN_SL;
				ltoken[tkn].type = TYP_QUEST;
				if (party[langcnf[1].cur_plyr].Armor == 1)
				  ltoken[tkn].val = 1;
				break;
			case 'T':	/*  Stun */
		     		ltoken[tkn].token = TOKEN_ST;
				ltoken[tkn].type = TYP_ACT;
				do_getparams(tkn);
				break;
			case 'Z':	/*  size (TSMLH) */
		     		ltoken[tkn].token = TOKEN_SZ;
				break;
		     }
		     break;
	   case '|':		/*  OR */
		     ltoken[tkn].token = TOKEN_OR;
		     ltoken[tkn].type = TYP_JOIN;
		     ltoken[tkn].val = 0;
		     break;
	   case '.':		/*  END current statement */
		     ltoken[tkn].token = TOKEN_END;
		     ltoken[tkn].type = TYP_END;
		     ltoken[tkn].val = 0;
//		     do_initplyr(MEKSconfig.cur_def);
		     break;
	   default: 		/*  finish statement */
		     ltoken[tkn].token = TOKEN_FIN;
		     ltoken[tkn].type = TYP_FIN;
		     ltoken[tkn].val = 0;
//		     do_initplyr(MEKSconfig.cur_def);
		     break;
	}
if (debug == 1) printf("\nTKN = %s/%d TYPE = %d Val = %d Rnds = %d", &ltoken[tkn].tkn[0], ltoken[tkn].token, ltoken[tkn].type, ltoken[tkn].val, ltoken[tkn].rnd);

	return(line);
}

/*****************************************************************************/
void do_initplyr(int plyr, int v)
{
int i;

    langcnf[v].cur_plyr = plyr;
//    langcnf[v].cur_weap = party[plyr].cur_weap;
    langcnf[v].cur_armor = party[plyr].Armor;
    langcnf[v].has_helm = (party[plyr].DBHelm == 1)?'Y':'N';
    langcnf[v].has_leg = (party[plyr].DBLeg == 1)?'Y':'N';
    langcnf[v].has_arm = (party[plyr].DBArm == 1)?'Y':'N';
    langcnf[v].has_shld = (party[plyr].DBShield > 0)?'Y':'N';
    langcnf[v].cur_act = langcnf[v].prev_act = 0;
if (debug == 1) printf("Init Plyr %d = %d H:%c L:%c A:%c S:%c\n", v, plyr,
    langcnf[v].has_helm, langcnf[v].has_leg, langcnf[v].has_arm, langcnf[v].has_shld);

    return;
}

/*****************************************************************************/
void do_getparams(int tkn)
{
char *rdata;

	rdata = strstr(ltoken[tkn].tkn, ":");
	if (rdata == NULL)
	{
	   ltoken[tkn].val = atoi(&ltoken[tkn].tkn[2]);
	   return;
	}
	*rdata = '\0';
	ltoken[tkn].val = atoi(&ltoken[tkn].tkn[2]);
	rdata++;
	ltoken[tkn].rnd = atoi(rdata);
}

/*****************************************************************************/
void do_tokens()
{
int tkn=0, cndp=-1, i;
char cnd[10];
int plyr;

   memset(&cnd[0], '\0', 10);
   plyr = langcnf[0].cur_plyr;

   while (ltoken[tkn].token != TOKEN_FIN && tkn < (10+MAX_MONSTERS))
   {
	switch (ltoken[tkn].type)
	{
	   case TYP_QUEST: if (cndp == -1 && ltoken[tkn].token != TOKEN_IF && ltoken[tkn].token != TOKEN_IN)
					cndp++;
			   if (ltoken[tkn].token == TOKEN_IF)
					cndp++;
			   else if (ltoken[tkn].token == TOKEN_IN)
			   {
					cndp++;
					cnd[cndp++] = -3;
			   }
			   else
			   	cnd[cndp] += ltoken[tkn].val;
			break;
	   case TYP_ACT: 
			 if (ltoken[tkn].token == TOKEN_AK)
			 {
			     plyr = langcnf[0].cur_plyr;
			     break;
			 }
			 if (ltoken[tkn].token == TOKEN_DF)
			 {
			     plyr = langcnf[1].cur_plyr;
			     break;
			 }
			 if (cndp == -1)	/* just do it */
			 {
			     do_lexaction(tkn, plyr);
			 }
			 else	/* check the conditionals */
			 {
			     for (i=0; i<cndp; i++)
			     {
					 if (cnd[i] == -1)   /* it's an OR */
					 {
					   cnd[i+1] += cnd[i-1];
					 }
					 else if (cnd[i] == -2)   /* it's an AND */
					 {
					   if (cnd[i+1] >= 1 && cnd[i-1] >= 1)
					     cnd[i+1] = 1;
					 }
			     }
if (debug == 1) printf(" 0 = %d I = %d ", cnd[0], i);
			     if (cnd[0] == -3 && cnd[i] == 0)  /* IF NOTs */
			        do_lexaction(tkn, plyr);
			     else if (cnd[0] != -3 && cnd[i] == 1)
			        do_lexaction(tkn, plyr);
			 }
			break;
	   case TYP_JOIN: switch (ltoken[tkn].token)
			  {
			     case TOKEN_OR: cndp++; cnd[cndp++] = -1;
						break;
			     case TOKEN_AND: cndp++; cnd[cndp++] = -2;
						break;
			  }
			break;
	   case TYP_END: if (ltoken[tkn].token == TOKEN_END)
			 {
			    cndp = -1;
			    memset(&cnd[0], '\0', 10);
			    plyr = langcnf[1].cur_plyr;
			 }
			 else if (ltoken[tkn].token == TOKEN_EL)
			 {
			    if (cnd[0] == -3 && cnd[cndp] > 0)  /* IF NOTs */
			    {
					 while (ltoken[++tkn].type > 0)
			           do_lexaction(tkn, plyr);
			    }
			    else if (cnd[cndp] < 1)
			    {
					 while (ltoken[++tkn].type > 0)
			           do_lexaction(tkn, plyr);
			    }
			    else
			    {
					 while (ltoken[++tkn].type > 0)
				  		 ;
			    }
			    cndp = -1;
			    memset(&cnd[0], '\0', 10);
			    tkn--;
			 }
			break;
	}
	tkn++;
   }

   return;
}

/*****************************************************************************/
void do_lexaction(int tkn, int plyr)
{
int i;

   i = langcnf[0].cur_plyr;
   if (plyr == langcnf[1].cur_plyr)
     i = 2;

if (debug == 1) printf("\ndL: %d %d/%d/%d  ", tkn, plyr, i, langcnf[1].cur_plyr);

   switch (ltoken[tkn].token)
   {
	case TOKEN_OB:  if (ltoken[tkn].rnd > 0)
			{
			  do_btmppen(TPEN_OB, ltoken[tkn].val, ltoken[tkn].rnd, plyr);
			}
			else
			{
			   i = langcnf[0].cur_plyr;
			   interpResults[0] += ltoken[tkn].val;
			}
if (debug == 1) printf("OB Adj = %d/%d/%d\n",i,ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_AP:  if (ltoken[tkn].rnd > 0)
			{
			  do_btmppen(TPEN_APEN, ltoken[tkn].val, ltoken[tkn].rnd, plyr);
			}
			else
			   interpResults[4] += ltoken[tkn].val;
if (debug == 1) printf(" APen Adj = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_ST:  interpResults[6] += ltoken[tkn].val;
if (debug == 1) printf(" Stun Adj = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_HT:  if (ltoken[tkn].rnd > 0)
			{
			  do_btmppen(TPEN_HITS, ltoken[tkn].val, ltoken[tkn].rnd, plyr);
			}
			else
			   interpResults[3] += ltoken[tkn].val;
if (debug == 1) printf(" Hit Adj = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_BL:  if (ltoken[tkn].rnd > 0)
			{
			  do_btmppen(TPEN_HITS, ltoken[tkn].val, ltoken[tkn].rnd, plyr);
			}
			else
			   interpResults[5] += ltoken[tkn].val;
if (debug == 1) printf(" Bled Adj = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_DD:  interpResults[7] += ltoken[tkn].val;
if (debug == 1) printf(" Dead Adj = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_IA:  interpResults[8] += ltoken[tkn].val;
if (debug == 1) printf(" Inactive = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_NP:  interpResults[1] += ltoken[tkn].val;
if (debug == 1) printf(" No Parry = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;

	case TOKEN_MP:  interpResults[2] += ltoken[tkn].val;
if (debug == 1) printf(" Must Pry = %d/%d\n", ltoken[tkn].val, ltoken[tkn].rnd);
			break;
   }

   return;
}
