/* This will take a text file and make the appropriate file from it.
  Either an attack table or a critical table. It reads and writes to
  stdin & stdout.

	(C) Torquil Gault 2001+

*/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "MEKSmerp.h"

/**********************************************************/
crit_tab ctbl[50];
attk_tab atbl[50];

int i,j,k,sz;

FILE *ifile;
int ofile, ftype=0;

char iline[512], fid[5], *ptr;

/**********************************************************/
void processAT() {
	//	ST, ED, UM, (HP, CRIT) * 5
	while (gets(iline) != NULL) {
// printf("iL: %d: %s\n", i, iline);
		j = 1;
		atbl[i].st = atoi(strtok(iline, "|"));
		while ((ptr = strtok(NULL, "|")) != NULL) {
			switch (j) {
				case 1: atbl[i].ed = atoi(ptr);
					break;
				case 2: atbl[i].um_flag = atoi(ptr);
					break;
				case 3:
				case 5:
				case 7:
				case 9:
				case 11: atbl[i].res[(j/2)-1][0] = atoi(ptr);
					break;
				case 4:
				case 6:
				case 8:
				case 10:
				case 12: strncpy(&atbl[i].res[(j/2)-1][1], ptr, 1);
					if (atbl[i].res[(j/2)-1][1] < 'A' || atbl[i].res[(j/2)-1][1] > 'E') {
						atbl[i].res[(j/2)-1][1] = '\0';
					}
					break;
			}
// printf("J = %d  P = %s\n", j, ptr);
			j++;
		}
		i++;
	}
	ptr = (char *)&atbl[0].st;
	sz = sizeof(attk_tab) * (i+1);
	j = toupper(fid[0]) + toupper(fid[1]);
	fid[0] = tolower(fid[0]); fid[1] = tolower(fid[1]);
// printf("sz = %d id = %d\n", sz, j);
	for (i=0; i<sz; i++) {
		*ptr = ~ (*ptr ^ j); ptr++;
	}
	sprintf(iline, "tab_%s.dat", fid);
	if ((ofile = open(iline,  O_CREAT | O_RDWR | O_TRUNC| O_BINARY)) != -1) {
		write(ofile, &atbl[0].st, sz);
		close(ofile);
	}
}

/**********************************************************/
void processCT() {
	//	ST, ED, RES * 8, Msg, SpMods
	while (gets(iline) != NULL) {
// printf("iL: %d: %s\n", i, iline);
		j = 1;
		ctbl[i].st = atoi(strtok(iline, "|"));
		while ((ptr = strtok(NULL, "|")) != NULL) {
			switch (j) {
				case 1: ctbl[i].ed = atoi(ptr);
					break;
				case 2: 
				case 3:
				case 4:
				case 5:
				case 6:
				case 7:
				case 8:
				case 9: ctbl[i].res[j-2] = atoi(ptr);
					break;
				case 10: strncpy(ctbl[i].msg, ptr, 53);
					break;
				case 11: strncpy(ctbl[i].spec_mods, ptr, 29);
					break;
			}
// printf("J = %d  P = %s\n", j, ptr);
			j++;
		}
// printf("%d:%d %s\n", ctbl[i].st, ctbl[i].ed, ctbl[i].msg);
		i++;
	}
	ptr = (char *)&ctbl[0].st;
	sz = sizeof(crit_tab) * (i+1);
	j = toupper(fid[0]) + toupper(fid[1]);
	fid[0] = tolower(fid[0]); fid[1] = tolower(fid[1]);
// printf("sz = %d id = %d\n", sz, j);
	for (i=0; i<sz; i++) {
		*ptr = ~ (*ptr ^ j); ptr++;
	}
	sprintf(iline, "tab_%s.dat", fid);
	if ((ofile = open(iline,  O_CREAT | O_RDWR | O_TRUNC| O_BINARY)) != -1) {
		write(ofile, &ctbl[0].st, sz);
		close(ofile);
	}
}

/**********************************************************/
main(int argc, char **argv) {

	extern char *optarg;
	extern int optind, optopt;

	if (argc < 2) {
		printf("Usage: %s -i ID [-c | -a ]\n", argv[0]);
	}

	while ((i = getopt(argc, argv, "aci:")) != -1) {
		switch (i) {
			case 'a': ftype = 0;
						break;
			case 'c': ftype = 1;
						break;
			case 'i': strncpy(fid, optarg, 4);
						break;
		}
	}
// 	printf("FT = %d  ID = %s:\n", ftype, fid);

	i = j = 0;
	if (ftype == 0) {
		processAT();
	} else {
		processCT();
	}
}
