/**************************************************************************

**************************************************************************/
#include <stdio.h>
#include <string.h>

#include <FL/Fl_Menu_Item.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Check_Button.H>

#define MAX_MONSTERS 18

Fl_Menu_Item EditSelector[] = {
	{"Player0",0,0,(void*)0},
	{"Player1",0,0,(void*)0},
	{"Player2",0,0,(void*)0},
	{0}
};

Fl_Menu_Item IgnoreAtkSelector[] = {
	{"None",0,0,(void*)0},
	{"Bleeding",0,0,(void*)0},
	{"Stun",0,0,(void*)0},
	{"Both",0,0,(void*)0},
	{0}
};

Fl_Menu_Item CritAdjSelector[] = {
	{"None",0,0,(void*)0},
	{"-1",0,0,(void*)0},
	{"-2",0,0,(void*)0},
	{"Large",0,0,(void*)0},
	{"S.Large",0,0,(void*)0},
	{0}
};

Fl_Menu_Item ArmorSelector[] = {
	{"None",0,0,(void*)0},
	{"Soft Lthr",0,0,(void*)0},
	{"Rigid Lthr",0,0,(void*)0},
	{"Chain",0,0,(void*)0},
	{"Plate",0,0,(void*)0},
	{0}
};

Fl_Menu_Item SizeSelector[] = {
	{"Small",0,0,(void*)0},
	{"Medium",0,0,(void*)0},
	{"Large",0,0,(void*)0},
	{"Huge",0,0,(void*)0},
	{0}
};

Fl_Menu_Item ExtraSelector[] = {
	{"XP Calc",0,0,(void*)0},
	{"Status",0,0,(void*)0},
	{0}
};

Fl_Menu_Item DBArmSelector[] = {
	{"None",0,0,(void*)0},
	{"Leather",0,0,(void*)0},
	{"Metal",0,0,(void*)0},
	{0}
};

Fl_Menu_Item DBLegSelector[] = {
	{"None",0,0,(void*)0},
	{"Leather",0,0,(void*)0},
	{"Metal",0,0,(void*)0},
	{0}
};

Fl_Menu_Item DBHelmSelector[] = {
	{"None",0,0,(void*)0},
	{"Leather",0,0,(void*)0},
	{"Metal",0,0,(void*)0},
	{0}
};

Fl_Menu_Item MeleeWeaponSelector[] = {
	{0}
};

Fl_Menu_Item MissileWeaponSelector[] = {
	{0}
};

Fl_Menu_Item ThrownWeaponSelector[] = {
	{0}
};

Fl_Menu_Item InitiativeSelector[] = {
	{"Std MERP",0,0,(void*)0},
	{"d12,d8,d6",0,0,(void*)0},
	{"d10,d6,d4",0,0,(void*)0},
	{0}
};

Fl_Menu_Item YNSelector[] = {
	{"No",0,0,(void*)0},
	{"Yes",0,0,(void*)0},
	{0}
};

Fl_Menu_Item SpellSelector[] = {
	{"Base Spell", 0,0,(void*)0},
	{"Shock Bolt",  0,0,(void*)0},
	{"Water Bolt", 0,0,(void*)0},
	{"Ice Bolt",  0,0,(void*)0},
	{"Fire Bolt",  0,0,(void*)0},
	{"Light Bolt",  0,0,(void*)0},
	{"Cold Ball",  0,0,(void*)0},
	{"Fire Ball",  0,0,(void*)0},
	{"Special",  0,0,(void*)0},
	{0}
};

Fl_Menu_Item ActionList[] = {
	{"Attack",0,0,(void*)0},
	{"Mis Attack",0,0,(void*)0},
	{"Mis Load",0,0,(void*)0},
	{"Spell Cast",0,0,(void*)0},
	{"Spell Charge",0,0,(void*)0},
	{"Mis Throw",0,0,(void*)0},
	{"M & M",0,0,(void*)0},
	{"St M & M",0,0,(void*)0},
//	{"Move",0,0,(void*)0},
//	{"Parry",0,0,(void*)0},
//	{"Special",0,0,(void*)0},
//	{"Mis Parry",0,0,(void*)0},
	{"Opp Act",0,0,(void*)0},
	{"Inactive",0,0,(void*)0},
//	{"None",0,0,(void*)0},
//	{"Multi Acts",0,0,(void*)0},
	{"Bandage",0,0,(void*)0},
	{0}
};

char ActionIndex[][3] = {
	{"5A"},
	{"2A"},
	{"2L"},
	{"1A"},
	{"1C"},
	{"3A"},
	{"4"},
	{"7"},
//	{"6"},
//	{"5P"},
//	{"9"},
//	{"5P"},
	{"O"},
	{"IN"},
//	{"0"},
//	{"M"},
	{"4H"}};

Fl_Menu_Item CritSelector[] = {
	{"",0,0,(void*)0},
	{"A",0,0,(void*)0},
	{"B",0,0,(void*)0},
	{"C",0,0,(void*)0},
	{"D",0,0,(void*)0},
	{"E",0,0,(void*)0},
	{"T",0,0,(void*)0},
	{0}
};

Fl_Menu_Item MoveSelector[] = {
	{"Easy",0,0,(void*)0},
	{"Medium",0,0,(void*)0},
	{"V.Hard",0,0,(void*)0},
	{"Folly",0,0,(void*)0},
	{0}
};

Fl_Menu_Item ModTypeSelector[] = {
	{"OB",0,0,(void*)0},
	{"DB",0,0,(void*)0},
	{"MM",0,0,(void*)0},
	{"RR",0,0,(void*)0},
	{"DB+MM",0,0,(void*)0},
	{"RR+DB",0,0,(void*)0},
	{"RR+MM",0,0,(void*)0},
	{"BaseSpell",0,0,(void*)0},
	{"Elem. Sp",0,0,(void*)0},
	{0}
};

Fl_Menu_Item ModNamesSelector[] = {
	{0}
};

Fl_Menu_Item SpellModifiersSelector[] = {
	{"None",0,0,(void*)0},
	{"Instantaneous",0,0,(void*)0},		// SpellCharge == 2
	{"Def: Centred",0,0,(void*)0},		// +20
	{"Def: -AG Bonus",0,0,(void*)0},
	{"0' - 10'",0,0,(void*)0},			// +20
	{"11' - 50'",0,0,(void*)0},			// +0
	{"51' - 100'",0,0,(void*)0},		// -10
	{"101' - 200'",0,0,(void*)0},		// -20
	{0}
};

Fl_Menu_Item RealmSelector[] = {
	{"Channel",0,0,(void*)0},
	{"Essence",0,0,(void*)0},
	{"Mentalism",0,0,(void*)0},
	{"Ess/Chan",0,0,(void*)0},
	{0}
};

Fl_Menu_Item SpellAttackSelector[] = {
	{"",0,0,(void*)0},
	{"Ball",0,0,(void*)0},
	{"Bolt",0,0,(void*)0},
	{0}
};
char *SpellAttackTable[] = {"", "SA", "SO"};

Fl_Menu_Item SpellCriticalSelector[] = {
	{"",0,0,(void*)0},
	{"Electric",0,0,(void*)0},
	{"Heat",0,0,(void*)0},
	{"Impact",0,0,(void*)0},
	{"Cold",0,0,(void*)0},
	{0}
};
char *SpellCriticalTable[] = {"", "E", "H", "I", "C"};

Fl_Menu_Item LogActionSelector[] = {
	{"Accept",0,0,(void*)0},
	{"Upd Line",0,0,(void*)0},
	{"New Day",0,0,(void*)0},
	{"New Session",0,0,(void*)0},
	{0}
};

Fl_Menu_Item AttkTblSelector[] = {
	{"",0,0,(void*)0},
	{"1E - 1 Hand Edge",0,0,(void*)0},
	{"1C - 1 Hand Crush",0,0,(void*)0},
	{"2H - 2 Handed",0,0,(void*)0},
	{"GR - Grappling",0,0,(void*)0},
	{"MS - Missile",0,0,(void*)0},
	{"TC - Tiny Creature",0,0,(void*)0},
	{"SB - Base Spell",0,0,(void*)0},
	{0}
};

Fl_Menu_Item PrimCritSelector[] = {
	{"",0,0,(void*)0},
	{"S - Slashing",0,0,(void*)0},
	{"K - Crushing",0,0,(void*)0},
	{"P - Piercing",0,0,(void*)0},
	{"G - Grappling",0,0,(void*)0},
	{"U - Unbalancing",0,0,(void*)0},
	{"C - Cold",0,0,(void*)0},
	{"E - Electricity",0,0,(void*)0},
	{"H - Heat",0,0,(void*)0},
	{"I - Impact",0,0,(void*)0},
	{"D - Subduing",0,0,(void*)0},
	{"LA - Large",0,0,(void*)0},
	{"SL - Super Large",0,0,(void*)0},
	{0}
};

Fl_Menu_Item SecCritSelector[] = {
	{"",0,0,(void*)0},
	{"S - Slashing",0,0,(void*)0},
	{"K - Crushing",0,0,(void*)0},
	{"P - Piercing",0,0,(void*)0},
	{"G - Grappling",0,0,(void*)0},
	{"U - Unbalancing",0,0,(void*)0},
	{"C - Cold",0,0,(void*)0},
	{"E - Electricity",0,0,(void*)0},
	{"H - Heat",0,0,(void*)0},
	{"I - Impact",0,0,(void*)0},
	{"D - Subduing",0,0,(void*)0},
	{"s - slashing -20",0,0,(void*)0},
	{"k - crushing -20",0,0,(void*)0},
	{"p - piercing -20",0,0,(void*)0},
	{"g - grappling -20",0,0,(void*)0},
	{"u - unbalancing -20",0,0,(void*)0},
	{"c - cold -20",0,0,(void*)0},
	{"e - electricity -20",0,0,(void*)0},
	{"h - heat -20",0,0,(void*)0},
	{"i - impact -20",0,0,(void*)0},
	{"d - Subduing",0,0,(void*)0},
	{0}
};

Fl_Menu_Item ScreenSelector[] = {
	{"320x220",0,0,(void*)0},
	{"640x440",0,0,(void*)0},
	{0}
};

/****************************************************************************/
config MEKSconfig;
players party[11+MAX_MONSTERS];

unsigned char MEKSactionInitiatorList[11+MAX_MONSTERS], MEKSactionReceiverList[11+MAX_MONSTERS];
unsigned char MEKSmodifierList[11+MAX_MONSTERS];

char debug = 0, doSpecAttk=0;

attk_tab *tbl_attk;
crit_tab *tbl_crit, *tbl_crit1, *tbl_crit2;
move_tab *tbl_move;
weapon   *tbl_weap;
spells	*tbl_spel;
abbreviation *tbl_abbr;

abbreviation wp_abbrev[] = {
	{"BS", "Broadsword"},
	{"WH", "War Hammer"},
	{"SS", "Short Sword"},
	{"BA", "Battle Axe"},
	{"TH", "2H Sword"},
	{"2H", "2H Sword"},
	{"QS", "Qtr Staff"},
	{"MA", "Mace"},
	{"MS", "Morning Star"},
	{"WP", "Whip"},
	{"HA", "HandAxe"},
	{"CL", "Club"},
	{"DA", "Dagger"},
	{"SP", "1-Spear"},
	{"CB", "Composite Bow"},
	{"SB", "Short Bow"},
	{"LB", "Long Bow"},
	{"XB", "Crossbow"},
	{"", ""}
};

Fl_Input *meksEditWName[5];
Fl_Input *meksEditWOB[5];
Fl_Input *meksEditWTable[5];
Fl_Input *meksEditWSize[5];
Fl_Input *meksEditWFumble[5];
Fl_Input *meksEditWPrimaryCrit[5];
Fl_Input *meksEditWSecondaryCrit[5];
Fl_Input *meksEditWSpecMods[5];
Fl_Check_Button *meksEditWSelect[3];
Fl_Input *meksEditTempPen[8][3];

Fl_Input *actionsMeleeRoll[4];
Fl_Input *actionsMeleeAdjustment[4];
Fl_Input *actionsMeleeOB[4];
Fl_Button *actionsMeleeLk1[4];
Fl_Input *actionsMeleeCrit1Roll[4];
Fl_Button *actionsMeleeLk2[4];
Fl_Choice *actionsMeleeCrit1Result[4];
Fl_Button *actionsMeleeLk3[4];
Fl_Input *actionsMeleeCrit2Roll[4];
Fl_Choice *actionsMeleeCrit2Result[4];
Fl_Input *actionsMeleeDamageHPs[4];
Fl_Input *actionsMeleeDamageAP[4];
Fl_Input *actionsMeleeDamageBleed[4];
Fl_Input *actionsMeleeDamageStun[4];
Fl_Input *actionsMeleeParry[3];
Fl_Input *actionsMeleeParryDefender[3];

Fl_Input *meksMonsterCount[10+MAX_MONSTERS];
Fl_Output *meksMonsterName[10+MAX_MONSTERS];

Fl_Input *meksTriggerCount[6];
Fl_Input *meksTriggerText[6];

Fl_Input *meksModifierCount[6];
Fl_Input *meksModifierBonus[6];
Fl_Choice *meksModifierType[6];
Fl_Choice *meksModifierEffects[6];
Fl_Window *MeksWindow;

Fl_Input *meksOptionTitle[10];
Fl_Input *meksOptionValue[10][7];

Fl_Input *meksInitNames[11+MAX_MONSTERS];
Fl_Input *meksInitValues[11+MAX_MONSTERS][3];
Fl_Check_Button *meksInitActions[11+MAX_MONSTERS][3];
char meksInitKey[11+MAX_MONSTERS];

/****************************************************************************/
extern void getWeaponDetails(Fl_Input *);
static void cb_meksEditWName(Fl_Input *inp, void*) {
  getWeaponDetails(inp);
}

/****************************************************************************/
extern void getActionLookup(Fl_Button *);
static void cb_meksActionLookup(Fl_Button *btn, void*) {
  getActionLookup(btn);
}

extern void loadMonsters();
static void cb_meksMonsterLoad(Fl_Button*, void*) {
  loadMonsters();
}
