/***************************************************************************
***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <FL/Fl.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Round_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Tile.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Counter.H>
#include <FL/fl_file_chooser.H>

#include "MEKSmerp.h"

extern struct players party[];
extern unsigned char MEKSactionInitiatorList[], MEKSactionReceiverList[], MEKSmodifierList[11+MAX_MONSTERS];
extern char debug;

extern attk_tab *tbl_attk;
extern crit_tab *tbl_crit, *tbl_crit1, *tbl_crit2;
extern move_tab *tbl_move;
extern weapon   *tbl_weap;
extern spells   *tbl_spel;
extern abbreviation   *tbl_abbr;

extern Fl_Tabs  *meksTabMaster;
extern Fl_Tabs  *meksEditTab;
extern Fl_Tabs  *actionTabs;
extern Fl_Tile  *meksTabActions;
extern Fl_Tile  *meksSystem;
extern Fl_Tile  *meksEditCharacter;
extern Fl_Tile  *actionsMelee;
extern Fl_Input *meksEditName;
extern Fl_Input *meksEditLevel;
extern Fl_Input *meksEditHitsMax;
extern Fl_Input *meksEditHitsCur;
extern Fl_Input *meksEditNoAttks;
extern Fl_Input *meksEditBleed;
extern Fl_Input *meksEditWounds;
extern Fl_Input *meksEditStun;
extern Fl_Input *meksEditActPenalty;
extern Fl_Input *meksEditParry;
extern Fl_Input *meksEditNoParry;
extern Fl_Input *meksEditInactive;
extern Fl_Input *meksEditDeath;
extern Fl_Input *meksEditDBBase;
extern Fl_Input *meksEditSpellBase;
extern Fl_Input *meksEditDBShield;
extern Fl_Input *meksEditSpellDirAttacks;
extern Fl_Input *meksEditMMBase;
extern Fl_Input *meksEditAGQU;
extern Fl_Choice *meksEditArmor;
extern Fl_Input *meksEditCON;
extern Fl_Choice *meksEditSize;
extern Fl_Choice *meksEditDBLeg;
extern Fl_Choice *meksEditDBArm;
extern Fl_Choice *meksEditDBHelm;
extern Fl_Choice *meksEditIgnoreAtk;
extern Fl_Choice *meksEditCritAdj;
extern Fl_Choice *meksEditRealm;
extern Fl_Input *meksEditRRPoison;
extern Fl_Input *meksEditRRChannel;
extern Fl_Input *meksEditRRMentalism;
extern Fl_Input *meksEditRREssence;
extern Fl_Input *meksEditRRDisease;
extern Fl_Input *meksEditSpellCharge;
extern Fl_Input *meksEditMissileLoad;
extern Fl_Input *meksEditParryValue;
extern Fl_Input *meksEditTempPen[8][3];

extern Fl_Button *meksEditAccept;
extern Fl_Button *meksEditCancel;
extern Fl_Button *meksSystemQuickSave;

extern Fl_Input *actionsMeleeParry[], *actionsMeleeParryDefender[];
extern Fl_Choice *actionsSpellModifiers;

extern Fl_Choice *meksEditPlayerSelector;
extern Fl_Choice *meksEditMonsterSelector;

extern Fl_Input *meksPlayerFile;
extern Fl_Input *meksMonsterFile;
extern Fl_Input *meksExtrasFile;

extern Fl_Choice *meksExtraSelector;
extern Fl_Browser *meksExtrasDisplay;

extern Fl_Browser *meksSpecialBrowser;
extern Fl_Counter *meksSpecialCounter;

extern config MEKSconfig;

extern Fl_Menu_Item ActionList[];
extern char ActionIndex[][3];
extern Fl_Browser *meksActionInitiator, *meksActionReceiver;

extern Fl_Input *meksSystemRound;
extern Fl_Choice *meksSystemInitiative;
extern Fl_Input *meksSystemXPMultiplier;
extern Fl_Choice *meksSystemRollAllRolls;
extern Fl_Counter *meksSystemAutoSave;
extern Fl_Choice *meksSystemParryPerc;
extern Fl_Input *meksSystemDirectory;
extern Fl_Input *meksPlayerFile;
extern Fl_Input *meksMonsterFile;
extern Fl_Input *meksExtrasFile;

//extern Fl_Output *meksRndDoingMessage;

//extern Fl_Input *actionsMeleeRoll;
//extern Fl_Input *actionsMeleeCrit1Roll;
//extern Fl_Input *actionsMeleeCrit2Roll;
//extern Fl_Choice *actionsMeleeCrit1Result;
//extern Fl_Choice *actionsMeleeCrit2Result;
//extern Fl_Button *actionsMeleeLk1;
//extern Fl_Button *actionsMeleeLk2;
//extern Fl_Button *actionsMeleeLk3;
//extern Fl_Input *actionsMeleeDamageHPs;
//extern Fl_Input *actionsMeleeDamageAP;
//extern Fl_Input *actionsMeleeDamageBleed;
//extern Fl_Input *actionsMeleeDamageStun;
//extern Fl_Input *actionsMeleeAdjustment;
//extern Fl_Input *actionsMeleeOB;
extern Fl_Button *meksActionAccept;
extern Fl_Button *meksActionCancel;

extern Fl_Input *meksEditWName[5];
extern Fl_Input *meksEditWOB[5];
extern Fl_Input *meksEditWTable[5];
extern Fl_Input *meksEditWSize[5];
extern Fl_Input *meksEditWFumble[5];
extern Fl_Input *meksEditWPrimaryCrit[5];
extern Fl_Input *meksEditWSecondaryCrit[5];
extern Fl_Input *meksEditWSpecMods[5];
extern Fl_Check_Button *meksEditWSelect[3];

extern Fl_Input *meksEditSkillPerc;
extern Fl_Input *meksEditSkillUI;
extern Fl_Input *meksEditSkillRR;
extern Fl_Input *meksEditSkillStalk;

extern Fl_Input *actionsMeleeRoll[4];
extern Fl_Input *actionsMeleeAdjustment[4];
extern Fl_Input *actionsMeleeOB[3];
extern Fl_Button *actionsMeleeLk1[3];
extern Fl_Input *actionsMeleeCrit1Roll[3];
extern Fl_Button *actionsMeleeLk2[3];
extern Fl_Choice *actionsMeleeCrit1Result[3], *meksMeleeWeaponSelector, *meksMeleeArmorSelector;
extern Fl_Button *actionsMeleeLk3[3];
extern Fl_Input *actionsMeleeCrit2Roll[3];
extern Fl_Choice *actionsMeleeCrit2Result[3];
extern Fl_Input *actionsMeleeDamageHPs[3];
extern Fl_Input *actionsMeleeDamageAP[3];
extern Fl_Input *actionsMeleeDamageBleed[3];
extern Fl_Input *actionsMeleeDamageStun[3];

extern Fl_Menu_Item SpellSelector[];
extern Fl_Choice *actionsSpellCast;
extern Fl_Choice *actionsMoveLevel;

extern Fl_Output *meksActionMessage;

extern Fl_Input *meksMonsterCount[];
extern Fl_Output *meksMonsterName[];

extern Fl_Button *meksSpecialB1;
extern Fl_Button *meksSpecialB2;
extern Fl_Button *meksSpecialB3;
extern Fl_Button *meksSpecialB4;
extern Fl_Button *meksSpecialB5;
extern Fl_Button *meksSpecialB6;

extern Fl_Check_Button *meksActionsThrown;

extern Fl_Input *meksTriggerCount[];
extern Fl_Input *meksTriggerText[];

extern Fl_Input *meksModifierCount[];
extern Fl_Input *meksModifierBonus[];
extern Fl_Choice *meksModifierType[];
extern Fl_Choice *meksModifierEffects[];

extern Fl_Window *MeksWindow, *meksSpecAttkWindow;

//extern Fl_Button *meksLogUpdLog;
extern Fl_Choice *meksLogAction;
extern Fl_Input *meksLogInput;
extern Fl_Browser *meksLogText;

extern Fl_Button *meksMeleeSpecAttk;
extern Fl_Choice *meksSATable;
extern Fl_Choice *meksSAPrimCrit;
extern Fl_Choice *meksSASecCrit;

extern Fl_Button *meksActionEndRound;
extern Fl_Button *actionsSpellCharging;
extern Fl_Button *actionMissileLoad;
extern Fl_Tile *meksTabEdit;
extern Fl_Tile *meksSpecialTab;
extern Fl_Input *meksExtrasFile;
extern Fl_Choice *meksSystemResolution, *meksSystemActionLog;
extern Fl_Tile *meksExtras;
extern Fl_Browser *meksExtrasDisplay;
extern Fl_Tile *meksSession;
extern Fl_Button *meksLogsave;
extern Fl_Button *meksLogload;
extern Fl_Tile *meksSpecialTriggers, *meksSpecialModifiers, *meksSpecialMonsters, *meksSpecialExtras, *meksSpecials;

extern Fl_Input *meksOptionTitle[10];
extern Fl_Input *meksOptionValue[10][7];

extern Fl_Input *meksSpecialSpellName;
extern Fl_Browser *meksSpecSpellList, *meksSpecSpellDesc;

extern Fl_Browser *meksSpecCopyList, *meksInitList;
extern Fl_Input *meksSpecCopyStart;

extern Fl_Tile *actionsSpell, *actionsMissile, *actionsMove, *meksEditWeapon, *meksEditOther,
               *MeksSystem, *meksSpecialOptions, *meksSpecialSpells, *meksSpecialCopy;

extern Fl_Input *meksInitNames[11+MAX_MONSTERS];
extern Fl_Input *meksInitValues[11+MAX_MONSTERS][3];
extern Fl_Check_Button *meksInitActions[11+MAX_MONSTERS][3];

extern char meksInitKey[11+MAX_MONSTERS];

extern Fl_Tile *meksInit;
extern Fl_Browser *meksInitList;
extern Fl_Button *meksInitReload;
extern Fl_Button *meksInitClear;
extern Fl_Button *meksInitCalc;
extern Fl_Button *meksInitRF;
extern Fl_Scroll *meksInitScroll;
extern Fl_Menu_Item *ArmorSelector;
extern Fl_Round_Button *meksSystemBreak150;
