//
//
//

/****************************************************************************/
#include <time.h>
#include <string.h>
#include <ctype.h>

#include <FL/Fl.H>
#include <FL/Fl_Widget.H>
#include <FL/Fl_Button.H>
#include <FL/fl_ask.H>

#include "MEKSextraa.h"
#include "MEKSextrab.h"
#include "MEKSinterp.h"

/****************************************************************************/
int seed1, seed2, seed3;
Fl_Widget *widget;

/****************************************************************************/
char *getWeaponStats(char *);
void doActionTableLookup(int, int);
int getDiceRoll();
void doCriticalAdjustment(int, int ,int );
void doIgnoreAdjustment(int, int, int);
void setActionMessage(char *);
void doFumbleResult(char ca, char tile, int val);
int getRRValue(unsigned char , unsigned char , unsigned char, unsigned char);
void getCriticalRoll(char *, int );
void getAttackRoll(char *, int , int );
int getStatBonus(int);
void showSpecialSpell();
int meksSetScreenResolution(int);

extern char * getSystemData(char *, char);
extern void setActionTile(int);
extern int getDB(int, int);
extern int getOB(int, int);
extern void doSystemAlert(char *);
extern int getModifiers(int, int);
extern void reloadAllNames();
extern void interpModifiers(char *, char, char);
extern void setReceiverFlag();
void do_meks_upd_log();

extern char mybuf[], mybuf2[], doSpecAttk;
extern int actionResults[3][8];
extern int interpResults[9];

extern abbreviation wp_abbrev[];

extern int getTokenType(int );
extern int getTokenValue(int );
extern int findTokenType(int );

extern int tempPenalties[8][4];

/****************************************************************************/
void init16()     /* initialise the RANDOM No. generator */
{
time_t ltime;
struct tm *ntime;

	time(&ltime);
	ntime = gmtime(&ltime);

	seed1 = (ntime->tm_sec*1000)+(ntime->tm_min*100)+ntime->tm_mday;
	seed2 = (ntime->tm_min*1000)+(ntime->tm_sec*100)+ntime->tm_year;
	seed3 = (ntime->tm_sec*1000)+(ntime->tm_hour*100)+ntime->tm_mon;
}

/****************************************************************************/
double uniform16()   /* get a RANDOM No. */
{
int z, k;

    k = seed1 / 206;
    seed1 = 157 * (seed1 - k * 206) - k * 21;
    if (seed1 < 0)
        seed1 += 32363;

    k = seed2 / 217;
    seed2 = 146 * (seed2 - k * 217) - k * 45;
    if (seed2 < 0)
        seed2 += 31727;

    k = seed3 / 222;
    seed3 = 142 * (seed3 - k * 222) - k * 133;
    if (seed3 < 0)
        seed3 += 31657;

    z = seed1 - seed2;
    if (z > 706)
        z -= 32362;

    z += seed3;
    if (z < 1)
        z += 32362;

    return(z * 3.0899E-5);
}

/******************************************************************************/
int getRND(int val)
{
   if (val == 0) {
      val = getRND(9);
      fl_alert("Possible data issue ... 0 in GET-RND");
   }

   val = ((int )(uniform16() * 32767.99)) % val;

   return(val+1);
}

/******************************************************************************/
void doRollLookup(int line) {
int at=0;

	widget = actionTabs->value();
	if (widget == actionsMelee) {
		at=1;
	}
	else if (widget == actionsSpell) {
		at=2;
	}
	else if (widget == actionsMissile) {
		at=3;
	}
	else if (widget == actionsMove) {
		at=4;
	}
if (debug == 1) printf("aRL: %d (%d)\n", line, at);
}

/******************************************************************************/
void getWeaponDetails(Fl_Input *weap) {
int i,j,k;
char *myptr;

	if (MEKSconfig.cur_plyr < 0 || MEKSconfig.cur_plyr > 34) {	// no-one being editted
		return;
	}
	for (int i=0; i<5; i++) {
		if (weap == meksEditWName[i]) {
			j = MEKSconfig.cur_plyr;
			k = atoi(meksEditWOB[i]->value());
			if (k == 0) {
				myptr = getWeaponStats((char *)meksEditWName[i]->value());
				if (myptr != NULL) {
if (debug == 1) printf("gWD: %d/%d/%d (%s)\n", i,j,k,tbl_weap->wp_dsc);
					memcpy(&party[j].weap[i].wp_dsc[0], tbl_weap, sizeof(weapon));
					MEKSconfig.cur_plyr = -1;
					meksEditWName[i]->value(party[j].weap[i].wp_dsc);
					MEKSconfig.cur_plyr = j;
					party[j].weap[i].wp_ob = 0;
					sprintf(mybuf, "%d", party[j].weap[i].wp_ob);
					meksEditWOB[i]->value(mybuf);
					meksEditWTable[i]->value(party[j].weap[i].wp_tbl);
					meksEditWSize[i]->value(party[j].weap[i].wp_sz);
					sprintf(mybuf, "%d", party[j].weap[i].wp_fm);
					meksEditWFumble[i]->value(mybuf);
					meksEditWPrimaryCrit[i]->value(party[j].weap[i].wp_pc);
					meksEditWSecondaryCrit[i]->value(party[j].weap[i].wp_sc);
					meksEditWSpecMods[i]->value(party[j].weap[i].wp_sm);
				}
			}
			return;
		}
	}
}

/******************************************************************************/
char *getWeaponStats(char *wn) {
	tbl_weap = (weapon *)getSystemData("WE", 1);

	while (tbl_weap->wp_dsc[0] != '\0') {
		if (strcasecmp(tbl_weap->wp_dsc, wn) == 0) {
if (debug == 1) printf("gWS: %s\n", tbl_weap->wp_dsc);
			return (char *)tbl_weap;
		}
		tbl_weap++;
	}
		// check to see if it's an abbreviation ...
	tbl_abbr = &wp_abbrev[0];
	while (tbl_abbr->wp_abb[0] != '\0') {
		if (strcasecmp(tbl_abbr->wp_abb, wn) == 0) {
			return(getWeaponStats(tbl_abbr->wp_dsc));
		}
		tbl_abbr++;
	}
	return(NULL);
}

/******************************************************************************/
void getActionLookup(Fl_Button *btn) {
int i,j;

	for (i=0; i<4; i++) {
		if (actionsMeleeLk1[i] == btn) {
if (debug == 1) printf("gAL: pressed on %d\n", i);
			meksActionReceiver->deactivate();
			meksActionMessage->value("");
			memset(actionResults, '\0', sizeof(actionResults));		// zero all out just incase
			doActionTableLookup(i, 0);
			break;
		} else if (actionsMeleeLk2[i] == btn) {
if (debug == 1) printf("gAL: pressed on %d\n", i);
			doActionTableLookup(i, 1);
			break;
		} else if (actionsMeleeLk3[i] == btn) {
if (debug == 1) printf("gAL: pressed on %d\n", i);
			doActionTableLookup(i, 2);
			break;
		}
	} 
	if (i < 3) {
		j = (actionResults[0][0] + actionResults[1][0] + actionResults[2][0]);
		sprintf(mybuf, "%d", j);
		actionsMeleeDamageHPs[i]->value(mybuf);
		j = (actionResults[0][1] + actionResults[1][1] + actionResults[2][1]);
		sprintf(mybuf, "%d", j);
		actionsMeleeDamageAP[i]->value(mybuf);
		j = (actionResults[0][2] + actionResults[1][2] + actionResults[2][2]);
		sprintf(mybuf, "%d", j);
		actionsMeleeDamageBleed[i]->value(mybuf);
		j = (actionResults[0][3] + actionResults[1][3] + actionResults[2][3]);
		sprintf(mybuf, "%d", j);
		actionsMeleeDamageStun[i]->value(mybuf);
	}
}

/******************************************************************************/
void doActionTableLookup(int tile, int line) {
int  ca, cd=-1, val=-1, i, wp=0, amr, token, tokenValue;
char tbl[4], crt[4], sz;
char criticalModifier[6] = {-20, -10, 0, 10, 20, -50};   // A,B,C,D,E,T

	if (MEKSconfig.cur_def == -1) {
		doSystemAlert("Please select an Action Receiver !!!");
		meksActionReceiver->activate();
		return;
	}

	ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
	cd = MEKSactionReceiverList[meksActionReceiver->value() - 1];
	party[ca].action[party[ca].ActionCount] = tile;
	if (tile != 3) { 
		val = atoi(actionsMeleeOB[tile]->value()) + atoi(actionsMeleeRoll[tile]->value()) + atoi(actionsMeleeAdjustment[tile]->value()) - atoi(actionsMeleeParry[tile]->value());
		if (tile == 0 && (party[cd].HitsCur < 1 || party[cd].Inactive > 0 || party[cd].Death > 0 || party[cd].Stun > 0)) {
			val += 20;
		}
	}
	else {		// move action
		val = atoi(actionsMeleeRoll[tile]->value()) + atoi(actionsMeleeAdjustment[tile]->value()) + party[ca].MMBase - party[ca].ActPenalty;
		if (party[ca].Stun > 0) {
			val -= 50;
		}
	}

if (debug == 1) printf("dATL:0: %d/%d (%d:%d:%d)\n", ca, cd, val, tile, line);

	switch (line) {
		case 0:			// Action
				tbl_crit1 = tbl_crit2 = NULL;
				for (i=0; i<8; i++) {		// clear any temporary penalties
					tempPenalties[i][0] = tempPenalties[i][1] = tempPenalties[i][2] = tempPenalties[i][3] = 0;
				}
				switch (tile) {
					case 0:			// Melee
//							if (party[cd].ParryVal == 0 && party[cd].Stun > 0) {
							if (atoi(actionsMeleeParryDefender[tile]->value()) == 0 && party[cd].Stun > 0) {
								doSystemAlert("As the defender is stunned, add Parry etc as required");
							}
							if (meksActionsThrown->value() == 1) {
								wp=4;
							} else {
								wp=party[ca].AttackCount;
								if (party[ca].NoAttks == 1) {
									for (i=0; i<3; i++) {
										if (party[ca].weap[i].wp_sel == 1) {
											wp = i;
											break;
										}
									}
								}
								if (party[ca].weap[wp].wp_dsc[0] == '\0' || party[ca].weap[wp].wp_ob == 0) {
									wp = party[ca].AttackCount = 0;
								}
							}
							if (doSpecAttk != 0) {
								wp = 5;
								memset(party[ca].weap[5].wp_dsc, '\0', sizeof(weapon));
								strcpy(party[ca].weap[5].wp_dsc, "Special: + OB");
								strncpy(party[ca].weap[5].wp_tbl, meksSATable->text(), 2); party[ca].weap[5].wp_tbl[2] = '\0';
								strncpy(party[ca].weap[5].wp_pc, meksSAPrimCrit->text(), 2); party[ca].weap[5].wp_pc[2] = '\0';
								strncpy(party[ca].weap[5].wp_sc, meksSASecCrit->text(), 2); party[ca].weap[5].wp_sc[2] = '\0';
								for (i=0; i<3; i++) {
									if (party[ca].weap[5].wp_pc[i] == ' ') {
										party[ca].weap[5].wp_pc[i] = '\0';
									}
									if (party[ca].weap[5].wp_sc[i] == ' ') {
										party[ca].weap[5].wp_sc[i] = '\0';
									}
								}
if (debug == 1) printf("SA: %s (%s %s)\n", party[ca].weap[5].wp_tbl, party[ca].weap[5].wp_pc, party[ca].weap[5].wp_sc);
							}
							strcpy(tbl, party[ca].weap[wp].wp_tbl);
							sprintf(mybuf, "Using: %s\nDB (P:%d, B:%d, S:%d) %s\nAdd Shield/Parry as required", party[ca].weap[wp].wp_dsc, party[cd].ParryVal, party[cd].DBBase, party[cd].DBShield, party[cd].Name);
							meksActionMessage->value(mybuf);
							val -= getDB(cd, Act_Melee); // + party[cd].ParryVal;
							if (doSpecAttk == 0) {
								if (strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Pincher") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Bite") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Claw") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Stinger") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Grapple") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Bash") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Tiny Animal") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Trample") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Crush") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Kick") == 0
								 || strcasecmp(&party[ca].weap[wp].wp_dsc[0], "Tackle") == 0)
								{	/* must adjust attack roll by their size */
									sz = party[ca].Size;
									if (party[ca].weap[wp].wp_sz[0] >= 'H'
									 && party[ca].weap[wp].wp_sz[0] <= 'S')
									   sz = party[ca].weap[wp].wp_sz[0];
									switch (sz)
									{
										case 0:
									   case 'S': if (val > 105) val = 105;
											break;
										case 1:
									   case 'M': if (val > 120) val = 120;
											break;
										case 2:
									   case 'L': if (val > 135) val = 135;
											break;
										case 3:
									   case 'H': if (val > 150) val = 150;
											break;
									}
	if (debug == 1) printf("Size Adj: %c (%d) = %d\n", sz, sz, val);
								}
							}
							if (tbl[0] == '\0' || party[ca].weap[wp].wp_ob == 0) {
								doSystemAlert("Please Check their Melee Weapon configuration !!!");
							}
							break;
					case 1:			// Spell
							wp = actionsSpellCast->value();
							val += getModifiers(ca, 'B');		// get any BaseSpell modifiers
							if (wp > 0 && wp < 6) {
								val += party[ca].SpellDirAttacks;
								val += getModifiers(ca, 'E');			// get any Elemental Spell attack modifiers
							}
							if (wp == 0) {
if (debug == 1) { printf("Spec Chan Adj %d/%d\n", party[ca].Realm, party[cd].Armor); }
								if ((party[ca].Realm == 0 || party[ca].Realm == 3) && (party[cd].Armor == 3 || party[cd].Armor == 4)) {
									if (party[ca].Realm == 3) {
										if (doAreYouSure("Are they casting a Channeling Spell ?") == 1) {
											val -= 10;		// Base Channeling spells less effective against metal armor
										}
									} else {
										val -= 10;		// Base Channeling spells less effective against metal armor
									}
								}
							}
							wp=5;
							sprintf(mybuf, "Using: %s\nDB (P:%d, B:%d, S:%d) %s\n!!! Add Parry/Shield as required !!!", party[ca].weap[5].wp_dsc, party[cd].ParryVal, party[cd].DBBase, party[cd].DBShield, party[cd].Name);
							meksActionMessage->value(mybuf);
							strcpy(tbl, party[ca].weap[5].wp_tbl);
							break;
					case 2:			// Missile
							wp=3;
							sprintf(mybuf, "Using: %s\nDB (P:%d, B:%d, S:%d) %s\n!!! Add Parry/Shield as required !!!", party[ca].weap[3].wp_dsc, party[cd].ParryVal, party[cd].DBBase, party[cd].DBShield, party[cd].Name);
							meksActionMessage->value(mybuf);
							strcpy(tbl, party[ca].weap[3].wp_tbl);
							if (party[ca].weap[3].wp_tbl[0] == '\0' || party[ca].weap[3].wp_ob == 0) {
								doSystemAlert("Please Check their Missile Weapon configuration !!!");
							}
							val -= getDB(cd, Act_MissileAttack);
							break;
					case 3:			// Move
							strcpy(tbl, "MM");
							if (val < 0) {
								doFumbleResult(ca, tile, val);
								return;
							}
							val += getModifiers(ca, 'M');
							val = (val > 350)?350:val;
							cd = (actionsMoveLevel->value() * 2) + 1;
							tbl_move = (move_tab *)getSystemData(tbl, 1);
							for (i=0; i<23; i++) {
								if (tbl_move->st <= val && tbl_move->ed >= val) {
if (debug == 1) printf("M&M: %d @ %d = %d\n", val, cd, tbl_move->res[cd]);
									if (tbl_move->res[cd] > 0) {
										sprintf(mybuf, "Completed %d%% of their action", tbl_move->res[cd]);
										setActionMessage(mybuf);
									} else {
										meksActionMessage->value("!!! Fumble !!!\nPlease Adjust the Roll with\nthe fumble Modifiers.\nMake the roll NEGATIVE");
									}
									return;
								}
								tbl_move++;
							}
							return;
							break;
					default:
							return;
							break;
				}
				if (tile != 3) {
					if (party[cd].HitsCur < 1 || party[cd].Inactive > 0 || party[cd].Death > 0) {
						sprintf(mybuf, "FYI: %s is dead/inactive ....", party[cd].Name);
						doSystemAlert(mybuf);
					}
				}
				if (party[ca].weap[wp].wp_sm[0] != '\0') {
					interpModifiers(party[ca].weap[wp].wp_sm, ca, cd);
					val += interpResults[0];
				}
				if (atoi(actionsMeleeRoll[tile]->value()) < 0) {
					doFumbleResult(ca, tile, val);
					return;
				}
				getAttackRoll(tbl, atoi(actionsMeleeRoll[tile]->value()), 1);
				if (tbl_attk == NULL) {
					getAttackRoll(tbl, val, 0);
					if (tbl_attk == NULL) {
						return;
					}
				}
				amr = 4 - party[cd].Armor;
				if (tile == 1 && actionsSpellCast->value() == 0 && (party[ca].Realm == 0 || party[ca].Realm == 3)
					&& (party[cd].Armor == 1 || party[cd].Armor == 2)) {
						if (party[ca].Realm == 3) {
							if (doAreYouSure("Are they casting a Channeling Spell ?") == 1) {
								amr = 4;	// Base Channeling spells with target wearing leather => NoArmor
							}
						} else {
							amr = 4;	// Base Channeling spells with target wearing leather => NoArmor
						}
				}
if (debug == 1) printf("dATL:1: %s (%d: %d/%c)\n", tbl, val, tbl_attk->res[amr][0], tbl_attk->res[amr][1]);
				if (atoi(actionsMeleeRoll[tile]->value()) <=  party[ca].weap[wp].wp_fm || tbl_attk->res[amr][0] == -1) {
					meksActionMessage->value("!!! Fumble !!!\nPlease Adjust the Roll with\nthe fumble Modifiers.\nMake the roll NEGATIVE");
					return;
				}
				memset(actionResults, '\0', sizeof(actionResults));
				if (tile == 1) {		// Spell Cast
					switch (actionsSpellCast->value()) {
						case 0:			// Base Spell
							i = getRRValue(party[ca].Level, cd, party[cd].Level, party[ca].Realm) - tbl_attk->res[amr][0];
							if (cd > 9 || MEKSconfig.roll_all == 1) {
								wp = getDiceRoll();
								sprintf(mybuf, "Needed %d, rolled %d", i, wp);
							}
							else {
								sprintf(mybuf, "Roll better than %d to resist", i);
							}
							meksActionMessage->value(mybuf);
							return;
							break;
					}
				}
				sprintf(mybuf, "%d", tbl_attk->res[amr][0]);
				actionResults[line][0] = tbl_attk->res[amr][0];		// Hits
				actionsMeleeDamageHPs[tile]->value(mybuf);
				actionsMeleeCrit1Result[tile]->value(0);
				if (tbl_attk->res[amr][1] != '\0') {
					setActionTile(3);
					if (MEKSconfig.roll_all == 1 || ca > 9) {
						sprintf(mybuf, "%d", getRND(100));
						actionsMeleeCrit1Roll[0]->value(mybuf);
						actionsMeleeCrit1Roll[1]->value(mybuf);
						actionsMeleeCrit1Roll[2]->value(mybuf);
					}
					if (tbl_attk->res[amr][1] == 'T') {
						actionsMeleeCrit1Result[tile]->value(6);
					} else {
						actionsMeleeCrit1Result[tile]->value(tbl_attk->res[amr][1] - 'A' + 1);
						if ((token = findTokenType(TOKEN_PC)) != -1) {
							tokenValue = getTokenValue(token);
if (debug == 1) printf("dATL:PC: %d/%d/%d\n", token, tokenValue, actionsMeleeCrit1Result[tile]->value());
							tokenValue += actionsMeleeCrit1Result[tile]->value();
							if (tokenValue > 5) {
								tokenValue = 5;
							} else if (tokenValue < 0) {
								tokenValue = 0;
							} 
							actionsMeleeCrit1Result[tile]->value(tokenValue);
						}
					}
					doCriticalAdjustment(tile, line, cd);
				}
				break;
		case 1:			// Crit1
		case 2:			// Crit2
				tbl[0] = 'C';
				tbl[2] = '\0';
				if (line == 1) {
					if (actionsMeleeCrit1Result[tile]->value() == 0) {		// No crit to lookup
						return;
					}
					val =  atoi(actionsMeleeCrit1Roll[tile]->value()) + criticalModifier[actionsMeleeCrit1Result[tile]->value()-1];
					switch (tile) {
						case 0:			// Melee
							if (doSpecAttk == 0) {
								wp=party[ca].AttackCount;
								if (party[ca].NoAttks == 1) {
									for (i=0; i<3; i++) {
										if (party[ca].weap[i].wp_sel == 1) {
											wp = i;
											break;
										}
									}
								}
								tbl[1] = party[ca].weap[wp].wp_pc[0];
							} else {
								wp=5;
								tbl[1] = party[ca].weap[5].wp_pc[0];
								if (strcasecmp(party[ca].weap[5].wp_pc, "LA") == 0 || strcasecmp(party[ca].weap[5].wp_pc, "SL") == 0) {
									sprintf(tbl, "%sA", party[ca].weap[5].wp_pc);
								}
								if (strcasecmp(party[ca].weap[5].wp_sc, "LA") == 0 || strcasecmp(party[ca].weap[5].wp_sc, "SL") == 0) {
									sprintf(tbl, "%sA", party[ca].weap[5].wp_sc);
								}
							}
							if (party[cd].CritAdj > 2) {			// Large or SuperLarge adjustment
								strcpy(tbl, "LAA");
								if (party[cd].CritAdj == 4) {		// SuperLarge
									val -= 20;
									strcpy(tbl, "SLA");
								}
							}
							break;
						case 1:			// Spell
							wp=5;
							tbl[1] = party[ca].weap[5].wp_pc[0];
							if (party[cd].CritAdj > 2) {			// Large or SuperLarge adjustment
								strcpy(tbl, "LAS");
								if (party[cd].CritAdj == 4) {		// SuperLarge
									val -= 20;
									strcpy(tbl, "SLS");
								}
							}
							break;
						case 2:			// Missile
							wp=3;
							tbl[1] = party[ca].weap[3].wp_pc[0];
							break;
					}
					i = actionsMeleeCrit1Result[tile]->value()-1;
if (debug == 1) printf("dATL: %d (%d:%s)\n", ca, i, party[ca].weap[wp].wp_sc);
					if (party[ca].weap[wp].wp_sc[0] != '\0' && i > 1 && i < 5) {		// any secondary crit
						setActionTile(4);
						if (MEKSconfig.roll_all == 1 || ca > 9) {
							sprintf(mybuf, "%d", getRND(100));
							actionsMeleeCrit2Roll[0]->value(mybuf);
							actionsMeleeCrit2Roll[1]->value(mybuf);
							actionsMeleeCrit2Roll[2]->value(mybuf);
						}
						if (party[ca].weap[wp].wp_sc[0] == tolower(party[ca].weap[wp].wp_sc[0])) {
							actionsMeleeCrit2Result[tile]->value(i-1);
						} else {
							actionsMeleeCrit2Result[tile]->value(i+1);
						}
						if (party[ca].weap[wp].wp_sc[1] != '\0') {
							i = 'A' - toupper(party[ca].weap[wp].wp_sc[1]) + 1;
							actionsMeleeCrit2Result[tile]->value(i);
						}
						if ((token = findTokenType(TOKEN_SC)) != -1) {
							tokenValue = getTokenValue(token);
if (debug == 1) printf("dATL:SC: %d/%d/%d\n", token, tokenValue, actionsMeleeCrit2Result[tile]->value());
							tokenValue += actionsMeleeCrit2Result[tile]->value();
							if (tokenValue > 5) {
								tokenValue = 5;
							} else if (tokenValue < 0) {
								tokenValue = 0;
							} 
							actionsMeleeCrit2Result[tile]->value(tokenValue);
						}
					}
				} else {
					if (actionsMeleeCrit2Result[tile]->value() == 0) {		// No crit to lookup
						return;
					}
					val =  atoi(actionsMeleeCrit2Roll[tile]->value()) + criticalModifier[actionsMeleeCrit2Result[tile]->value()-1];
					switch (tile) {
						case 0:			// Melee
							if (doSpecAttk == 0) {
								wp=party[ca].AttackCount;
								if (party[ca].NoAttks == 1) {
									for (i=0; i<3; i++) {
										if (party[ca].weap[i].wp_sel == 1) {
											wp = i;
											break;
										}
									}
								}
								tbl[1] = party[ca].weap[wp].wp_sc[0];
							} else {
								tbl[1] = party[ca].weap[5].wp_sc[0];
							}
							break;
						case 1:			// Spell
							tbl[1] = party[ca].weap[5].wp_sc[0];
							break;
						case 2:			// Missile
							tbl[1] = party[ca].weap[3].wp_sc[0];
							break;
					}
				}
				getCriticalRoll(tbl, val);
				if (tbl_crit != NULL) {
if (debug == 1) printf("FC: A: %d (%d/%d: %s) %d:%d:%d:%d\n", val, tbl_crit->st, tbl_crit->ed, tbl_crit->msg,tbl_crit->res[4],tbl_crit->res[5],tbl_crit->res[6],tbl_crit->res[7]);
					setActionMessage(tbl_crit->msg);
					actionResults[line][0] = tbl_crit->res[0];		// Hits
					actionResults[line][1] = tbl_crit->res[1];		// Act. Pen
					actionResults[line][2] = tbl_crit->res[2];		// Bleed
					actionResults[line][3] = tbl_crit->res[3];		// Stun
					actionResults[line][4] = tbl_crit->res[4];		// Parry
					actionResults[line][5] = tbl_crit->res[5];		// No Parry
					actionResults[line][6] = tbl_crit->res[6];		// Death
					actionResults[line][7] = tbl_crit->res[7];		// Inactive
					if (tbl_crit->spec_mods[0] != '\0') {
						interpModifiers(tbl_crit->spec_mods, ca, cd);
						actionResults[line][0] += interpResults[3];		// Hits
						actionResults[line][1] += interpResults[4];		// Act. Pen
						actionResults[line][2] += interpResults[5];		// Bleed
						actionResults[line][3] += interpResults[6];		// Stun
						actionResults[line][4] += interpResults[2];		// Parry
						actionResults[line][5] += interpResults[1];		// No Parry
						actionResults[line][6] += interpResults[7];		// Death
						actionResults[line][7] += interpResults[8];		// Inactive
					}
					doIgnoreAdjustment(tile, line, cd);
					if (line == 1) {
						tbl_crit1 = tbl_crit;
					} else {
						tbl_crit2 = tbl_crit;
					}
					return;
				}
				break;
	}
}

/******************************************************************************/
int getDiceRoll() {
int val=0, i;

	val = i = getRND(100);
	while (i > 95) {
		i = getRND(100);
		val += i;
	}
	return val;
}

/******************************************************************************/
void setSpellAction() {
int ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1],
    i = actionsSpellCast->value();
char *myptr;

	if (meksActionInitiator->active() == 1) {
		return;
	}

if (debug == 1) printf("sSA: %d (%d -> %s)\n", ca, i, SpellSelector[i].text);
	myptr = (char *)SpellSelector[i].text;
	memcpy(party[ca].weap[5].wp_dsc, getWeaponStats(myptr), sizeof(weapon));

		// is it a special spell like Stun Cloud etc etc ....
// printf("sSA: 1\n");
	if (strcasecmp(party[ca].weap[5].wp_dsc, "Special") == 0) {
// printf("sSA: 2\n");
		showSpecialSpell();
	}
// printf("sSA: 3\n");
}

/******************************************************************************/
void setSpellCharging() {
int ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
	party[ca].SpellCharge++;
	party[ca].action[party[ca].ActionCount] = Act_SpellCharge;
	if (party[ca].SpellCharge > 4) {
		party[ca].SpellCharge = 4;
	}
}

/******************************************************************************/
void setMissileLoading() {
int ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
	party[ca].MissileLoad++;
	party[ca].action[party[ca].ActionCount] = Act_MissileLoad;
}

/******************************************************************************/
void doIgnoreAdjustment(int tile, int line, int cd) {
	int i = party[cd].IgnoreAtk;
if (debug == 1) printf("dIA: %d (%d/%d)\n", cd, line, i);
	if (i == 1 || i == 3) {		// No Bleeding
		actionResults[line][2] = 0;
	}
	if (i == 2 || i == 3) {		// No Stun
		actionResults[line][3] = 0;
	}
}

/******************************************************************************/
void doCriticalAdjustment(int tile, int line, int cd) {
int i, j;

	i = party[cd].CritAdj;
	j = actionsMeleeCrit1Result[line]->value();
if (debug == 1) printf("dCA: %d (%d:%d/%d)\n", cd, line, i, j);
	switch (i) {
		case 1:		// -1
		case 2:		// -2
			if (line == 0) {
				if (j >= i) {
					actionsMeleeCrit1Result[line]->value(j-i);
				}
				if (j == 6) {	// T crit
					actionsMeleeCrit1Result[line]->value(0);
				}
			}
			break;
		case 3:		// Large
			j = actionsMeleeCrit1Result[tile]->value();
			if (j < 2 || j > 6) {		// Ignore A, T crits
			}
			break;
		case 4:		// SuperLarge
			j = actionsMeleeCrit1Result[tile]->value();
			if (j < 4 || j > 6) {		// Ignore A-C, T crits
			}
			break;
	}
}

/******************************************************************************/
void setActionMessage(char *msg) {
int i=0,j=0;
	while (msg[i] != '\0') {
		mybuf2[j] = msg[i];
		i++;
		j++;
		if ((j % 40) == 0) {
			mybuf2[j++] = '\n';
		}
	}
	mybuf2[j] = '\0';
	meksActionMessage->value(mybuf2);
if (debug == 1) printf("sAM: %s\n", mybuf2);
}

/******************************************************************************/
void doFumbleResult(char ca, char tile, int val) {
char ft[3] = {"FW"};
	switch(tile) {
		case 0:			// melee
				ft[1] = 'W';
				break;
		case 1:			// spell
				ft[1] = 'S';
				break;
		case 2:			// missile
				ft[1] = 'I';
				break;
		case 3:			// move
				ft[1] = 'M';
				break;
	}
	val = atoi(actionsMeleeRoll[tile]->value()) * -1;
if (debug == 1) printf("dFR: %d (%d/%d) %s\n", ca, tile, val, ft);
	getCriticalRoll(ft, val);
	if (tbl_crit != NULL) {
if (debug == 1) printf("FC: %d (%d/%d: %s)\n", val, tbl_crit->st, tbl_crit->ed, tbl_crit->msg);
		setActionMessage(tbl_crit->msg);
		actionResults[0][0] = tbl_crit->res[0];		// Hits
		actionResults[0][1] = tbl_crit->res[1];		// Act. Pen
		actionResults[0][2] = tbl_crit->res[2];		// Bleed
		actionResults[0][3] = tbl_crit->res[3];		// Stun
		actionResults[0][4] = tbl_crit->res[4];		// Parry
		actionResults[0][5] = tbl_crit->res[5];		// No Parry
		actionResults[0][6] = tbl_crit->res[6];		// Death
		actionResults[0][7] = tbl_crit->res[7];		// Inactive
		doIgnoreAdjustment(tile, 0, ca);
		return;
	}
}

/******************************************************************************/
void getAttackRoll(char *tbl, int roll, int um) {
if (debug == 1) printf("gAR: %s = %d/%d\n", tbl, roll, um);
	if (roll > 150 && MEKSconfig.use_150 == 1) {
		sprintf(mybuf2, "+150 Roll. Add +%d to 1st Crit Roll (%d)", (((roll-150)/25)+1)*5, roll);
		doSystemAlert(mybuf2);
	}

	roll = (roll < 1)?1:roll;
	roll = (roll > 150)?150:roll;
	tbl_attk = (attk_tab *)getSystemData(tbl, 1);
	if (tbl_attk != NULL) {
		for (int i=0; i<28; i++) {
// printf("gAR: %d %d:%d\n", i, tbl_attk->st, tbl_attk->ed);
			if (tbl_attk->st <= roll && tbl_attk->ed >= roll) {
				if (tbl_attk->um_flag == um) { // || (um == 0 && tbl_attk->um_flag == 1 && roll < 10)) {
if (debug == 1) printf("gAR: %d:%d:%d:%d:%d\n", tbl_attk->res[0][0],tbl_attk->res[1][0],tbl_attk->res[2][0],tbl_attk->res[3][0],tbl_attk->res[4][0]);
					return;
				}
			}
			if (tbl_attk->ed >= 250) {
				tbl_attk = NULL;
				return;
			}
			tbl_attk++;
		}
	}
	tbl_attk = NULL;
	return;
}

/******************************************************************************/
void getCriticalRoll(char *tbl, int roll) {
if (debug == 1) printf("gCR: %s = %d\n", tbl, roll);
	roll = (roll < 1)?1:roll;
	roll = (roll > 120)?120:roll;
	tbl_crit = (crit_tab *)getSystemData(tbl, 1);
	if (tbl_crit != NULL) {
		for (int i=0; i<19; i++) {
			if (tbl_crit->st <= roll && tbl_crit->ed >= roll) {
if (debug == 1) printf("gCR: %d:%d:%d:%d:%d\n", tbl_crit->res[0],tbl_crit->res[1],tbl_crit->res[2],tbl_crit->res[3],tbl_crit->res[4]);
				return;
			}
			tbl_crit++;
		}
	}
	tbl_crit = NULL;
	return;
}

/******************************************************************************/
int getRRValue(unsigned char atk_lvl, unsigned char def, unsigned char def_lvl, unsigned char type) {
int rr=0;

	if (def_lvl > 15)
	  rr = 15 - def_lvl;
	else if (def_lvl > 10)
	  rr = 15 - ((def_lvl - 10) * 2);
	else if (def_lvl > 5)
	  rr = 30 - ((def_lvl - 5) * 3);
	else if (def_lvl > 1)
	  rr = 50 - ((def_lvl - 1) * 5);
	else
	  rr = 50;
	
	if (atk_lvl > 15)
	  rr += 50 + (atk_lvl-15);
	else if (atk_lvl > 10)
	  rr += 35 + ((atk_lvl - 10) * 2);
	else if (atk_lvl > 5)
	  rr += 20 + ((atk_lvl - 5) * 3);
	else if (atk_lvl > 1)
	  rr += (atk_lvl - 1) * 5;

	if (atk_lvl == def_lvl)
	  rr = 50;

	switch (type)
	{
		case 1:
	   case 'E': rr -= party[def].RREssence;
		     break;
		case 0:
	   case 'F':		/* Fear is a channeling RR */
	   case 'C': rr -= party[def].RRChannel;
		     break;
		case 2:
	   case 'M': rr -= party[def].RRMentalism;
		     break;
	   case 'P': rr -= party[def].RRPoison;
		     break;
	   case 'D': rr -= party[def].RRDisease;
		     break;
	}
	rr -= getModifiers(def, 'R');

if (debug == 1) printf("gRRV: %d:%d:%c = %d\n", atk_lvl, def_lvl, type, rr);

	return(rr);
}

/******************************************************************************/
void setSpellModifiers() {
int ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
int cd = MEKSactionReceiverList[meksActionReceiver->value() - 1];
int adj=0;

if (debug == 1) printf("sSM: %d:%d\n",ca,cd);
	switch (actionsSpellModifiers->value()) {
		case 1:		// instant
			party[ca].SpellCharge = 2;
			sprintf(mybuf, "%d", getOB(ca, Act_SpellCast));
			actionsMeleeOB[1]->value(mybuf);
			return;
			break;
		case 2:		// centred +20
		case 4:		// +20
			adj = +20;
			break;
		case 3:		// AG bonus
			adj = getStatBonus(party[cd].AGQU);
			break;
		case 5:		// +0
			break;
		case 6:		// -10
			adj = -10;
			break;
		case 7:		// -20
			adj = -20;
			break;
	}
	sprintf(mybuf, "%d", atoi(actionsMeleeAdjustment[1]->value()) + adj);
	actionsMeleeAdjustment[1]->value(mybuf);
}

/******************************************************************************/
int getStatBonus(int val) {
	if (val > 101)
		return +35;
	else if (val > 100)
		return +30;
	else if (val > 99)
		return +25;
	else if (val > 97)
		return +20;
	else if (val > 94)
		return +15;
	else if (val > 89)
		return +10;
	else if (val > 74)
		return +5;
	else if (val > 24)
		return +0;
	else if (val > 9)
		return -5;
	else if (val > 4)
		return -10;
	else if (val > 2)
		return -15;
	else if (val == 2)
		return -20;

	return -25;
}

/******************************************************************************/
void doSpecialExtras(Fl_Button *b) {
int i;
	if (b == meksSpecialB1) {		// Reset Players
if (debug == 1) printf("dSE: RP\n");
		for (i=0; i<10; i++) {
			party[i].HitsCur = party[i].HitsMax;
			party[i].Wounds[0] = '\0';
			party[i].batlxp[0] = '\0';
			party[i].Bleed = party[i].Stun = party[i].ActPenalty = 0;
			party[i].Parry = party[i].NoParry = party[i].Inactive = 0;
			party[i].Death = party[i].xp = party[i].ActionCount = 0;
			party[i].AttackCount = party[i].ParryVal = 0;
		}
		reloadAllNames();
	} else if (b == meksSpecialB2) {		// Clear Monsters
if (debug == 1) printf("dSE: CM\n");
		memset(party[10].Name, '\0', sizeof(players)*MAX_MONSTERS);
		for (int i=10; i<(10+MAX_MONSTERS); i++) {
  	   	  sprintf(party[i].Name, "--Monst Slot %d", i-10);
  	   	  strcpy(party[i].weap[0].wp_dsc, "Melee");
  	   	  strcpy(party[i].weap[1].wp_dsc, "Melee");
  	   	  strcpy(party[i].weap[2].wp_dsc, "Melee");
  	   	  strcpy(party[i].weap[3].wp_dsc, "Missile");
  	   	  strcpy(party[i].weap[4].wp_dsc, "Thrown");
		}
		reloadAllNames();
	} else if (b == meksSpecialB3) {		// Reset Monsters
if (debug == 1) printf("dSE: RM\n");
		for (i=10; i<(10+MAX_MONSTERS); i++) {
			party[i].HitsCur = party[i].HitsMax;
			party[i].Wounds[0] = '\0';
			party[i].batlxp[0] = '\0';
			party[i].Bleed = party[i].Stun = party[i].ActPenalty = 0;
			party[i].Parry = party[i].NoParry = party[i].Inactive = 0;
			party[i].Death = party[i].xp = party[i].ActionCount = 0;
			party[i].AttackCount = party[i].ParryVal = 0;
		}
		reloadAllNames();
	} else if (b == meksSpecialB4) {		// Clean Players
		for (i=0; i<9; i++) {
			if ((party[i].Name[0] == '\0' && party[i].HitsMax < 1) ||
			  (party[i].Name[0] == '-' && party[i].HitsMax < 1 && (party[i+1].Name[0] != '-' || party[i+1].Name[0] != '\0'))) {
if (debug == 1) printf("dSE: CP: %d\n", i);
				memcpy(&party[i].Name[0], &party[i+1].Name[0], sizeof(players));
				memset(&party[i+1].Name[0], '\0', sizeof(players));
  	   	   sprintf(party[i+1].Name, "--Party Slot %d", i+1);
			}
		}
		for (i=0; i<10; i++) {
			if (party[i].Name[0] == '-' && party[i].Name[1] == '-') {
				sprintf(party[i].Name, "--Party Slot %d", i);
			}
		}
		reloadAllNames();
	} else if (b == meksSpecialB5) {		// 
	} else if (b == meksSpecialB6) {		// 
	}
}

/******************************************************************************/
void dontAcceptCopyright();
void doAcceptCopyright();

static void cb_copyrightNoButton(Fl_Button*, void*) {
  dontAcceptCopyright();
}
static void cb_copyrightButton(Fl_Button*, void*) {
  doAcceptCopyright();
}

Fl_Window* copyrightWindow;
/******************************************************************************/
void showCopyright() {
Fl_Button *copyrightButton=(Fl_Button *)0;
Fl_Button *copyrightNoButton=(Fl_Button *)0;
Fl_Output *copyrightMessage=(Fl_Output *)0;
if (debug == 1) printf("sC:\n");
	
	copyrightWindow = new Fl_Window(200, 100, "MEKS: Copyright");
	{ Fl_Button* o = copyrightButton = new Fl_Button(25, 75, 50, 20, "I Accept");
	    o->labelsize(MEKS_LABEL_SIZE);
	    o->callback((Fl_Callback*)cb_copyrightButton);
	}
	{ Fl_Button* o = copyrightNoButton = new Fl_Button(126, 75, 50, 20, "I Dont");
	    o->labelsize(MEKS_LABEL_SIZE);
	    o->callback((Fl_Callback*)cb_copyrightNoButton);
	}
	{ Fl_Output* o = copyrightMessage = new Fl_Output(0, 0, 200, 70);
	    o->labelsize(MEKS_LABEL_SIZE);
	    o->textsize(MEKS_TEXT_SIZE);
		o->type(4);
		o->value("\t   MEKS v3.3 28 May 2004\n\tCopyright Torquil Gault 2001+\n\nData & lookup tables used are copyright\nto I.C.E (used with permission)");
	}
	copyrightWindow->set_modal();
	copyrightWindow->end();
	copyrightWindow->show();
}
void dontAcceptCopyright() {
	exit(0);
}
void doAcceptCopyright() {
	copyrightWindow->hide();
}

/******************************************************************************/
void loadMonsters() {
players *p;
unsigned char j=0, l=0;

if (debug == 1) printf("lM:\n");
	p = (players *)getSystemData("XM", 0);
	if (p == NULL) {
		return;
	}

//	for (int i=0; i<19; i++) {
//		j = atoi(meksMonsterCount[i]->value());
//		while (j > 0) {
//			for (l=10; l<20; l++) {
//				if (party[l].Name[0] == '-' && party[l].HitsMax == 0) {
//					memcpy(party[l].Name, p[i].Name, sizeof(players));
//					sprintf(mybuf, "%c - %s", ('A' + l - 10), party[l].Name);
//					strcpy(party[l].Name, mybuf);
//					break;
//				}
//			}
//			j--;
//		}
//		meksMonsterCount[i]->value("");
//	}
	
	j = (unsigned char) meksSpecialCounter->value();
	if (j < 1) {
		return;
	}

	int i = meksSpecialBrowser->value() - 1;
	while (j > 0) {
		for (l=10; l<(10+MAX_MONSTERS); l++) {
			if (party[l].Name[0] == '-' && party[l].HitsMax == 0) {
				memcpy(party[l].Name, p[i].Name, sizeof(players));
				sprintf(mybuf, "%c - %s", ('A' + l - 10), party[l].Name);
				strcpy(party[l].Name, mybuf);
				break;
			}
		}
		j--;
	}

	reloadAllNames();
	meksSpecialCounter->value(0);
}

/******************************************************************************/
void doClearXP() {
	for (int i=0; i<(10+MAX_MONSTERS); i++) {
		party[i].xp = 0;
		party[i].batlxp[0] = '\0';
	}
}

/******************************************************************************/
int getWindowEvent(int e) {
// printf("gWE: %d\n", e);
	return e;
}

/******************************************************************************/
void setThrownAttack() {
int ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
if (debug == 1) printf("sTA: %d\n", meksActionsThrown->value());

	if (meksActionsThrown->value() == 1) {
		sprintf(mybuf, "%d", getOB(ca, Act_MissileThrow));
		actionsMeleeOB[0]->value(mybuf);
	}
	else {
		sprintf(mybuf, "%d", getOB(ca, Act_Melee));
		actionsMeleeOB[0]->value(mybuf);
	}
}

/******************************************************************************/
void acceptTriggers() {
	for (int i=0; i<6; i++) {
		MEKSconfig.meksTriggers[i].rnd = atoi(meksTriggerCount[i]->value());
		strncpy(MEKSconfig.meksTriggers[i].text, meksTriggerText[i]->value(), 30);
		MEKSconfig.meksTriggers[i].text[30] = '\0';
	}
}

/******************************************************************************/
void acceptModifiers() {
	for (int i=0; i<6; i++) {
		MEKSconfig.meksModifiers[i].rnd = atoi(meksModifierCount[i]->value());
		MEKSconfig.meksModifiers[i].bonus = atoi(meksModifierBonus[i]->value());
		if (MEKSconfig.meksModifiers[i].rnd > 0) {
			MEKSconfig.meksModifiers[i].type = meksModifierType[i]->value();
			MEKSconfig.meksModifiers[i].effects = meksModifierEffects[i]->value();
		} else {
			MEKSconfig.meksModifiers[i].type = 0;
			MEKSconfig.meksModifiers[i].effects = 0;
		}
if (debug == 1) printf("aM: %d:%d:%d:%d\n", MEKSconfig.meksModifiers[i].rnd, MEKSconfig.meksModifiers[i].bonus, MEKSconfig.meksModifiers[i].type, MEKSconfig.meksModifiers[i].effects);
	}
}

/******************************************************************************/
void AcceptSpecialSpell();
void CancelSpecialSpell();

static void cb_cancelSpecialSpell(Fl_Button*, void*) {
  CancelSpecialSpell();
}
static void cb_acceptSpecialSpell(Fl_Button*, void*) {
  AcceptSpecialSpell();
}

Fl_Window *specialSpellWindow = NULL;
Fl_Button *acceptSpecialSpellButton=(Fl_Button *)0;
Fl_Button *cancelSpecialSpellButton=(Fl_Button *)0;
Fl_Choice *SpecialSpellAttack, *SpecialSpellCrit1, *SpecialSpellCrit2;

/******************************************************************************/
void showSpecialSpell() {
if (debug == 1) printf("sSS:\n");
	
	if (specialSpellWindow == NULL) {
		specialSpellWindow = new Fl_Window(200, 80, "MEKS: Special Spell");
		{ Fl_Button* o = acceptSpecialSpellButton = new Fl_Button(25, 55, 50, 20, "OK");
		    o->labelsize(MEKS_LABEL_SIZE);
		    o->callback((Fl_Callback*)cb_acceptSpecialSpell);
		}
		{ Fl_Button* o = cancelSpecialSpellButton = new Fl_Button(126, 55, 50, 20, "Cancel");
		    o->labelsize(MEKS_LABEL_SIZE);
		    o->callback((Fl_Callback*)cb_cancelSpecialSpell);
		}
		{ Fl_Choice* o = SpecialSpellAttack = new Fl_Choice(100, 5, 40, 20, "Attk Type:");
		  o->labelsize(MEKS_LABEL_SIZE);
		  o->textsize(MEKS_TEXT_SIZE);
		  o->menu(SpellAttackSelector);
		}
		{ Fl_Choice* o = SpecialSpellCrit1 = new Fl_Choice(60, 30, 50, 20, "Crits: Prim:");
		  o->labelsize(MEKS_LABEL_SIZE);
		  o->textsize(MEKS_TEXT_SIZE);
		  o->menu(SpellCriticalSelector);
		}
		{ Fl_Choice* o = SpecialSpellCrit2 = new Fl_Choice(140, 30, 50, 20, "Sec:");
		  o->labelsize(MEKS_LABEL_SIZE);
		  o->textsize(MEKS_TEXT_SIZE);
		  o->menu(SpellCriticalSelector);
		}
		specialSpellWindow->set_modal();
		specialSpellWindow->end();
	}
	specialSpellWindow->show();
}
void CancelSpecialSpell() {
	specialSpellWindow->hide();
}
void AcceptSpecialSpell() {
int ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
	specialSpellWindow->hide();
	strcpy(party[ca].weap[5].wp_tbl, SpellAttackTable[SpecialSpellAttack->value()]);
	strcpy(party[ca].weap[5].wp_pc, SpellCriticalTable[SpecialSpellCrit1->value()]);
	strcpy(party[ca].weap[5].wp_sc, SpellCriticalTable[SpecialSpellCrit2->value()]);
	party[ca].weap[5].wp_sc[0] = (char )tolower( party[ca].weap[5].wp_sc[0]);
if (debug == 1) printf("ASS: %s %s %s\n", party[ca].weap[5].wp_tbl, party[ca].weap[5].wp_pc, party[ca].weap[5].wp_sc);
	setActionTile(3);
}

/******************************************************************************/
int do_meks_log_accept() {
   meksLogText->add(meksLogInput->value());
   meksLogText->middleline(meksLogText->size());
   meksLogInput->value("");
}

extern time_t t;
extern struct tm *tp;
/******************************************************************************/
int do_meks_new_session() {
	if (time(&t) != -1) {
		tp = localtime(&t);
   	sprintf(mybuf, "New Session %2.2d/%2.2d/%4.4d %2.2d:%2.2d", tp->tm_mday, tp->tm_mon+1, tp->tm_year+1900, tp->tm_hour, tp->tm_min);
   	meksLogText->add(mybuf);
   	meksLogText->middleline(meksLogText->size());
	}
}

/******************************************************************************/
int do_meks_new_day() {
   meksLogText->add("New Day");
   meksLogText->middleline(meksLogText->size());
}

FILE *ofile;
/******************************************************************************/
int do_meks_save_log() {
int i, k;
   if ((ofile = fopen("session.log", "w+")) != NULL) {
      k = meksLogText->size();
      for (i=1; i<=k; i++) {
         fprintf(ofile, "%s\n", meksLogText->text(i));
      }
		fclose(ofile);
   }
}

/******************************************************************************/
int do_meks_log_load() {
	meksLogText->load("session.log");
	meksLogText->middleline(meksLogText->size());
	meksLogAction->activate();
}

/******************************************************************************/
void do_meks_log_action() {
if (debug == 1) printf("dMLA: %d\n", meksLogAction->value());
	switch(meksLogAction->value()) {
		case 0: do_meks_log_accept();
				break;
		case 1: do_meks_upd_log();
				break;
		case 2: do_meks_new_day();
				break;
		case 3: do_meks_new_session();
				break;
	}
}

/******************************************************************************/
int do_set_debug(int bug) {
	debug = bug;
if (debug == 1) printf("dSD: %d\n", debug);
}

/******************************************************************************/
int do_meks_spec_attk(int type) {
int i;
	meksSpecAttkWindow->hide();
	doSpecAttk = type;
	if (type == 0) {
		i = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
		sprintf(mybuf, "%d", getOB(i, Act_Melee));
		actionsMeleeOB[0]->value(mybuf);
		setReceiverFlag();
		return 0;
	}
if (debug == 1) { 
	if (meksSATable->value() != 0) {
		strncpy(&mybuf[0], meksSATable->text(), 2);
	}
	if (meksSAPrimCrit->value() != 0) {
		strncpy(&mybuf[2], meksSAPrimCrit->text(), 1);
	}
	if (meksSASecCrit->value() != 0) {
		strncpy(&mybuf[3], meksSASecCrit->text(), 1);
	}
	mybuf[4] = '\0';
	printf("dMSA: %s (%d)\n", mybuf, doSpecAttk);
}
	actionsMeleeOB[0]->value("0");
	meksActionMessage->value("Using: Special ... add OB manually !!!");

	if (meksSATable->value() == 0 && type == 1) {
		if (meksSAPrimCrit->value() != 0) {
			i = MEKSactionInitiatorList[meksActionInitiator->value() - 1];
			strncpy(party[i].weap[5].wp_pc, meksSAPrimCrit->text(), 2); party[i].weap[5].wp_pc[2] = '\0';
			strncpy(party[i].weap[5].wp_sc, meksSASecCrit->text(), 2); party[i].weap[5].wp_sc[2] = '\0';
			i = MEKSactionReceiverList[meksActionReceiver->value() - 1];
			setActionTile(3);
			setActionTile(4);
			if (MEKSconfig.roll_all == 1 || i > 9) {
				sprintf(mybuf, "%d", getRND(100));
				actionsMeleeCrit1Roll[0]->value(mybuf);
				actionsMeleeCrit1Roll[1]->value(mybuf);
				actionsMeleeCrit1Roll[2]->value(mybuf);
				sprintf(mybuf, "%d", getRND(100));
				actionsMeleeCrit2Roll[0]->value(mybuf);
				actionsMeleeCrit2Roll[1]->value(mybuf);
				actionsMeleeCrit2Roll[2]->value(mybuf);
			}
		}
	}
}

/******************************************************************************/
int meksSetScreenResolution(int size) {
int w=320,h=219;

	return 0;

if (debug == 1) printf("dMSSR: %d\n", size);
	if (size == 1) {
		MeksWindow->resize(20,20,640, 439);
		meksTabMaster->resize(-2, 0, 630, 424);
		meksTabActions->resize(-2, 25, 630, 399);

		meksActionInitiator->resize(2, 25, 146, 215);
		meksActionReceiver->resize(152, 25, 156, 215);
		meksActionEndRound->resize(516, 27, 47, 25);
		meksActionAccept->resize(356, 27, 47, 25);
		meksActionCancel->resize(432, 27, 47, 25);
		actionTabs->resize(0, 246, 330, 126);
		actionsMelee->resize(0, 264, 320, 104);
		meksActionsThrown->resize(237, 314, 25, 25);
		meksMeleeSpecAttk->resize(276, 267, 42, 20);
		actionsSpell->resize(0, 264, 328, 104);
		actionsSpellCharging->resize(266, 267, 52, 22);
		actionsSpellCast->resize(266, 292, 52, 20);
		actionsSpellModifiers->resize(266, 314, 52, 20);
		actionsMissile->resize(0, 264, 310, 104);
		actionMissileLoad->resize(264, 267, 54, 22);
		actionsMove->resize(-2, 264, 322, 104);
		actionsMoveLevel->resize(68, 294, 60, 20);

		meksActionMessage->resize(319, 56, 271, 98);
		meksExtras->resize(0, 24, 548, 324);
		meksExtrasDisplay->resize(0, 54, 472, 286);
		meksSession->resize(0, 24, 512, 332);
		meksLogInput->resize(118, 276, 242, 20);
		meksLogText->resize(2, 27, 438, 211);
		meksLogsave->resize(44, 276, 52, 20);
		meksLogload->resize(266, 243, 52, 20);
		meksLogAction->resize(76, 244, 76, 20);
	meksTabEdit->resize(0, 24, 320, 196);
	meksSpecials->resize(0, 24, 320, 214);
	meksSpecialTab->resize(0, 28, 320, 210);
//	meksSpecialTriggers->resize(0, 50, 320, 188);
//	meksSpecialModifiers->resize(0, 50, 320, 188);
//	meksSpecialMonsters->resize(0, 50, 320, 188);
//	meksSpecialExtras->resize(0, 50, 320, 188);
		meksInit->resize(-2, 25, 630, 399);
		meksInitList->resize(235, 26, 208, 321);
		meksInitReload->resize(6, 329, 36, 20);
		meksInitClear->resize(72, 329, 36, 20);
		meksInitCalc->resize(141, 329, 36, 20);
		meksInitScroll->resize(1, 27, 217, 295);
		meksInitRF->resize(195, 329, 25, 20);
	}
}

/******************************************************************************/
int meksSpellLookup() {
int i,j;

	tbl_spel = (spells *)getSystemData("XS", 1);
	if (tbl_spel == NULL) {
		doSystemAlert("Unable to load Spell Data ... sorry!!");
		return -1;
	}
	strcpy(mybuf2, meksSpecialSpellName->value());
	i = strlen(mybuf2);
	if (i == 0) {
		return 0;
	}
	meksSpecSpellList->clear();
if (debug == 1) printf("mSS: %s (%d)\n", mybuf2, i);
	while (tbl_spel->realm_id != -1) {
		j = strncasecmp(tbl_spel->spell_name, mybuf2, i);
if (debug == 1) printf("mSS: %s : %s (%d)\n", tbl_spel->spell_name, mybuf2, j);
		if (j == 0) {
			meksSpecSpellList->add(tbl_spel->spell_name);
		} else if (j > 0) {
			return 0;
		}
		tbl_spel++;
	}
}

/******************************************************************************/
int meksSpellSelect() {
	tbl_spel = (spells *)getSystemData("XS", 1);
	if (tbl_spel == NULL) {
		doSystemAlert("Unable to load Spell Data ... sorry!!");
		return -1;
	}
		// is there a valid selection ...
	if (meksSpecSpellList->value() == 0) {
		return -1;
	}
	strcpy(mybuf2, meksSpecSpellList->text(meksSpecSpellList->value()));
if (debug == 1) printf("mSS: %s\n", mybuf2);
	while (tbl_spel->realm_id != -1) {
		if (strcmp(tbl_spel->spell_name, mybuf2) == 0) {
			meksSpecSpellDesc->clear();
			sprintf(mybuf2, " Name: %s", tbl_spel->spell_name);
			meksSpecSpellDesc->add(mybuf2);
			sprintf(mybuf2, "   AoE: %s", tbl_spel->spell_aoe);
			meksSpecSpellDesc->add(mybuf2);
			sprintf(mybuf2, "    Dur: %s", tbl_spel->spell_duration);
			meksSpecSpellDesc->add(mybuf2);
			sprintf(mybuf2, "Range: %s", tbl_spel->spell_range);
			meksSpecSpellDesc->add(mybuf2);
			sprintf(mybuf2, "  Desc: %s", tbl_spel->spell_desc);
			meksSpecSpellDesc->add(mybuf2);
			sprintf(mybuf2, " Level: %d", tbl_spel->spell_lvl);
			meksSpecSpellDesc->add(mybuf2);
			if (tbl_spel->realm_id == 0) {
				meksSpecSpellDesc->add(" Realm: Essence");
			} else {
				meksSpecSpellDesc->add(" Realm: Channel");
			}
				
		}
		tbl_spel++;
	}
}

/******************************************************************************/
void meksMeleeWeaponSelect(int wp) {
	int ca = MEKSactionInitiatorList[meksActionInitiator->value() - 1];

	if (ca < 0 || ca > (10+MAX_MONSTERS)) {
		return;
	}

	party[ca].weap[0].wp_sel = party[ca].weap[1].wp_sel = party[ca].weap[2].wp_sel = 0;
	party[ca].weap[wp].wp_sel = 1;
if (debug == 1) printf("mMWS: %d %d\n", ca, wp);
	sprintf(mybuf, "%d", getOB(ca, Act_Melee));
	actionsMeleeOB[0]->value(mybuf);
}

/******************************************************************************/
void meksMeleeArmorSelect(int ar) {
	int cd = MEKSactionReceiverList[meksActionReceiver->value() - 1];
	if (cd < 0 || cd > (10+MAX_MONSTERS)) {
		return;
	}
	party[cd].Armor = meksMeleeArmorSelector->value();
}

/******************************************************************************/
int do_set_150rule(int bug) {
	MEKSconfig.use_150 = bug;
}
