/*****************************************************************************/

#define MAX_MONSTERS 18

typedef struct weapon {
	char	wp_dsc[15];	/* Description */
	char	wp_tbl[4];	/* attack table to use */
	char	wp_sel;		/* Weapon selected */
	int	wp_ob;		/* Current OB */
	int	wp_ca;	/* Weapon Critical Adjustment */
	char	wp_sz[2];	/* Size of weapon's attack */
	int	wp_ma;	/* it's weight */
	int	wp_fm;		/* Fumble Value */
	int 	wp_br;	/* Base Range */
	int 	wp_bf;		/* Breakage Factor */
	int 	wp_str;		/* Strength */
	char	wp_pc[3];	/* Primary Crit Value */
	char	wp_sc[3];	/* Secondary Crit Value */
	char	wp_sm[30];	/* Special armor mods */
} weapon;

typedef struct abbreviation {
	char	wp_abb[4];	/* Abbreviation */
	char	wp_dsc[15];	/* Description */
} abbreviation;

// typedef struct init {
// 	int	 init_val;	/* init value for this action */
// 	signed char	action;			/* code for this action */
// 	signed char	effects[9];	/* ID's of whom it effects */
// 	signed char	atkres[9];	/* results of each attack on ID */
// } init;

typedef struct players {
	char	Name[21];
	int	Level;
	int	HitsMax;
	int	HitsCur;
	int	NoAttks;
	int	Bleed;
	char	Wounds[21];
	int	Stun;
	int	ActPenalty;
	int	Parry;
	int	NoParry;
	int	Inactive;
	int	Death;
	int	DBBase;
	int	SpellBase;
	int	DBShield;
	int	SpellDirAttacks;
	int	MMBase;
	int	AGQU;
	int	Armor;
	int	CON;
	int	Size;
	int	DBLeg;
	int	DBArm;
	int	DBHelm;
	int	IgnoreAtk;
	int	CritAdj;
	int	RRPoison;
	int	RRChannel;
	int	RRMentalism;
	int	RREssence;
	int	RRDisease;
	int	Realm;

	weapon  weap[6];	/* their weapons 0-2=melee, 3=miss, 4=thrown, 5=spell */
	int 	OBCur;		/* current OB with attacking weapon */
	int 	OBAdd; 	/* additives to current OB */
	int   DBSpecial; 	/* special additional DB */
	int 	MaMCur;		/* AG/QU stat, used for INIT calcs */

	int	TempPenalties[8][3];	/* temp penalties ie. 8 hits 3 rnds. 0=Type,
				   1=value, 2=no_rnds */

	int 	NoDefd;	/* no of attacks to be defended against */

	int 	perc;		/* Perception Stat Value */
	int 	track;		/* Track Stat Value */
	int 	u_item;		/* Use Item Stat Value */
	int 	r_rune;		/* Read Rune Stat Value */
	int 	p_lock;		/* Pick Locks Stat Value */
	int 	d_trap;		/* Disarm Trap Stat Value */
	int 	influ;		/* Influence Stat Value */
	int 	stalk;		/* Stalk/Hide Stat Value */

unsigned char	batlxp[80];	/* experience points from battle */
	int 	xp;		/* experience points gained from actions */

//	init	action[3];	/* actions they're doing */
	unsigned char	action[9];	/* actions they're doing */

	int	NoActions;	/* no of actions performed this round */
	int	CurAction;	/* current action (pointer) being performed */
	int	DoingOppAction;	/* currently doing an opportunity action */

	int 	SpellCharge;		/* no. rnds spent charging - spells */
	int 	MissileLoad;		/* no. rnds spent charging - missile */
	int 	CurWeapon;	/* current weapon, pointer into weap[] */
	char	DelayAttk;	/* an auto attack next round, into weap[] */
	unsigned char	AttackCount;		/* no. of attacks done this rnd */
	unsigned char	ActionCount;		/* no. actions done this rnd */

	unsigned char	ParryVal;		/* parry value */
	unsigned char	c_tmp3;		/* a temp var */

	int	i_tmp2;		/* a temp variables */
	char	c_tmp1;		/* a temp variables */
	char	c_tmp2;		/* a temp variables */
} players;

/* players party[35];  		Party 0-9    Monsters 10-33    Dummy 34 */

typedef struct triggers {
    unsigned char 	rnd;		/* no rnds lasts */
    char	text[31];				/* description */
} triggers;

typedef struct modifiers {
    unsigned char 	rnd;		/* no rnds lasts */
    char 	bonus;				/* bonus */
    char		type;					/* type A,D,M,R */
    char		effects;				/* who it effects, their ID's */
} modifiers;

typedef struct options {
	char title[15];
	char value[7][4];
} options;

typedef struct initiatives {
	char name[21];
	int  value[4];
} initiatives;

typedef struct attk_tab {	/* MERP table */
    unsigned char	st;		/* start value */
    unsigned char	ed;		/* end value */
    char um_flag;	/* unmodified roll flag */
    char res[5][3];	/* array of results Hits/Crit/Crit_Type */
} attk_tab;

	/* res[8] is HITS,APEN,BLEED,STUN,PARRY,No PARRY,DEATH,INACT */
typedef struct crit_tab {	/* MERP table */
    unsigned char	st;	   	/* start value */
    unsigned char	ed;  	   	/* end value */
    int res[8];   	/* array of results HITS/BLEED/STUN/ACT etc */
    char msg[54];   	/* description */
    char spec_mods[30];	/* Special armor mods, temp penalties */
} crit_tab;

typedef struct move_tab {
    	int st;			/* start value */
    	int ed;			/* end value */
    unsigned char res[9];	/* array of results */
} move_tab;

typedef struct config {
    char use_merp;		/* using MERP or RM */
    char init_sys;		/* initiatives system */
    char use_logging;		/* using action logging */
    double xp_mult; 		/* XP multiplier */
    char pty_fn[15];		/* party load/save filename */
    char mon_fn[15];		/* monster load/save filename */
    char xta_fn[15];		/* extra's load/save filename */
    char log_fn[15];		/* log load/save filename */
    char sys_dr[25];		/* system directory */
    unsigned char rnd_no;			/* current round no */
    int cur_init;		/* current init value */
    unsigned char cur_atk;		/* current ID of attacker */
    signed char cur_def;		/* current ID of defender */
    char cur_plyr;		/* current ID of editted */
    char cur_crit[3];		/* current Critical type */
    unsigned char atk_ptr;		/* current attack form, primary/sec crit */
    unsigned char edit_pty;		/* have they edited the party */
    unsigned char edit_mon;		/* have they edited the monsters */
    unsigned char plyr_actn;		/* current ID of players action */
    char roll_all;		/* roll all rolls */
    char encumber;		/* use encumbrance */
    char weap_break;		/* use weapon breakages */
    char armor_end;		/* use armor endurance */
    char auto_save;		/* save after every round */
    char action_type;		/* what action type the 'attacker' is doing */
	 triggers  meksTriggers[6];
	 modifiers meksModifiers[6];
	 options meksOptions[9];
	 initiatives meksInitiatives[11+MAX_MONSTERS];
	 char use_parryperc;
	 char use_150;
} config;

typedef struct spells {
	signed char realm_id;
	signed char spell_lvl;
	char spell_name[25];
	char spell_aoe[13];
	char spell_duration[13];
	char spell_range[9];
	char spell_desc[34];
} spells;


#define     CRITG_A		1
#define     CRITG_B		2
#define     CRITG_C		3
#define     CRITG_D		4
#define     CRITG_E		5
#define     KILL_XP		6

#define     TPEN_HITS           1
#define     TPEN_APEN           2
#define     TPEN_OB             3

#ifndef O_BINARY
#define O_BINARY O_RDWR
#endif

	/* this points into the list of actions available */
#define Act_Melee 0
#define Act_MissileAttack 1
#define Act_MissileLoad 2
#define Act_SpellCast 3
#define Act_SpellCharge 4
#define Act_MissileThrow 5
#define Act_Move 6
#define Act_OppAction 7
#define Act_Inactive 8
#define Act_Bandage 9

#define Ans_No 1
#define Ans_Yes 2
