#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <malloc.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <FL/Fl_Choice.H>
#include <FL/Fl_Input.H>

#include "MEKSmerp.h"

// **************************************************

extern char mybuf[], mybuf2[];
extern Fl_Input *attackMessage, *criticalMessage1, *criticalMessage2;
extern Fl_Choice *attackTable, *criticalTable1, *criticalTable2;

// **************************************************
char * getSystemData(char *, char );

// **************************************************
char debug = 0;
char *tablemem[61];    /* memory malloc'ed for each table file */
char  tabletype[61][4];    /* all the 2 digit table codes loaded */
int i, j, k, l;
char *myptr;

extern attk_tab *tbl_attk;
extern crit_tab *tbl_crit;

// **************************************************
int attackTableLookup(int val, int tbl) {
	if (tbl == 0)
		return 0;
	strncpy(mybuf2, (char *)attackTable->text(), 2);
if (debug == 1) { printf("aTL: %d:%d = %s\n", val, tbl, mybuf2); }

	tbl_attk = (attk_tab *) getSystemData(mybuf2, 1);
	if (tbl_attk != NULL) {
		for (int i=0; i<28; i++) {
// printf("gAR: %d %d:%d\n", i, tbl_attk->st, tbl_attk->ed);
			if (tbl_attk->st <= val && tbl_attk->ed >= val) {
				if (tbl_attk->um_flag == 0) {
if (debug == 1) printf("gAR: %d:%d:%d:%d:%d\n", tbl_attk->res[0][0],tbl_attk->res[1][0],tbl_attk->res[2][0],tbl_attk->res[3][0],tbl_attk->res[4][0]);
					sprintf(mybuf, "PL: %d/%c  CH: %d/%c  RL: %d/%c  SL: %d/%c  NO: %d/%c", 
(int )tbl_attk->res[0][0], (tbl_attk->res[0][1] == 0)?' ':tbl_attk->res[0][1],
(int )tbl_attk->res[1][0], (tbl_attk->res[1][1] == 0)?' ':tbl_attk->res[1][1],
(int )tbl_attk->res[2][0], (tbl_attk->res[2][1] == 0)?' ':tbl_attk->res[2][1],
(int )tbl_attk->res[3][0], (tbl_attk->res[3][1] == 0)?' ':tbl_attk->res[3][1],
(int )tbl_attk->res[4][0], (tbl_attk->res[4][1] == 0)?' ':tbl_attk->res[4][1]);
					attackMessage->value(mybuf);
					return 0;
				}
			}
			if (tbl_attk->ed >= 250) {
				tbl_attk = NULL;
				return 0;
			}
			tbl_attk++;
		}
	}
	return 0;
}

// **************************************************
int criticalTableLookup(int val, int tbl, int cl) {
	if (tbl == 0)
		return 0;
if (debug == 1) { printf("cTL: %d:%d\n", val, tbl); }

	if (cl == 0) {
		sprintf(mybuf2, "C%s", (char *)criticalTable1->text());
	} else {
		sprintf(mybuf2, "C%s", (char *)criticalTable2->text());
	}
	if (mybuf2[2] == ' ')
		mybuf2[2] = '\0';
	if (mybuf2[3] == ' ')
		mybuf2[3] = '\0';
	tbl_crit = (crit_tab *) getSystemData(mybuf2, 1);
	if (tbl_crit != NULL) {
		for (int i=0; i<19; i++) {
			if (tbl_crit->st <= val && tbl_crit->ed >= val) {
if (debug == 1) printf("gCR: %d:%d:%d:%d:%d\n", tbl_crit->res[0],tbl_crit->res[1],tbl_crit->res[2],tbl_crit->res[3],tbl_crit->res[4]);
				sprintf(mybuf, "HP:%d APen:%d Bld:%d Stn:%d Pary:%d NoPary:%d Deth:%d Inact:%d\n%s\n%s", tbl_crit->res[0], tbl_crit->res[1], tbl_crit->res[2], tbl_crit->res[3], tbl_crit->res[4], tbl_crit->res[5], tbl_crit->res[6], tbl_crit->res[7], tbl_crit->msg, tbl_crit->spec_mods);
				if (cl == 0) {
					criticalMessage1->value(mybuf);
				} else {
					criticalMessage2->value(mybuf);
				}
				return 0;
			}
			tbl_crit++;
		}
	}
	return 0;
}

/********************************************************************************/
char * getSystemData(char *tbl, char decrypt) {
struct stat fs;
char mb[4];

	k=0;
	i=-1;
	while (tbl[++i] != '\0') {
		mb[i] = (char )tolower ((int)(unsigned char) tbl[i]);
	}
	k = toupper((int )tbl[0]) + toupper((int )tbl[1]);
	mb[i] = '\0';

if (debug == 1) printf("gSD: table id = %s (%s %d)\n", mb, tbl, i);
	for (i=0; i<61; i++) {
		if (strcasecmp(&tabletype[i][0], mb) == 0) {
			return(tablemem[i]);
		}
	}
	sprintf(mybuf, "mrpdat/tab_%s.dat", mb);
	if ((i = open(mybuf, O_RDONLY)) != -1) {
		fstat(i, &fs);
		for (j=0; j<61; j++) {
			if (tabletype[j][0] == '\0' && tablemem[j] == NULL) {
				if ((tablemem[j] = (char *)malloc(fs.st_size)) != NULL) {
					strcpy(&tabletype[j][0], tbl);
					read(i, tablemem[j], fs.st_size);
					close(i);
// if (debug == 1) printf("gSD: loaded %s (%d:%d:%d)\n", mb, decrypt, k, j);
if (debug == 1) printf("gSD: loaded %s (%d:%d)\n", mb, decrypt, j);
					if (decrypt == 1) {
						myptr = tablemem[j];
						for (i=0; i<fs.st_size; i++) {
							*myptr = ~ (*myptr ^ k); 
							myptr++;
						}
					}
					return(tablemem[j]);
				}
				else {
if (debug == 1) printf("gSD: error malloc-ing %s\n", mb);
				}
			}
		}
	}
	else {
if (debug == 1) printf("gSD: error openning %s (%s)\n", mb, mybuf);
	}
	return(NULL);
}
